
indexbase 1
includepath "$\inc\"
include "TimeUtil.inc"
include "Parseutil.inc"
include "StorageUtil.inc" : UseLispishStorage

'indexbase 1 'default index base required for byte overlays

'GLOBALS
========

declare eval(string sr,sys*i) as string
declare tokens(string sr) as string
declare lisp(string sr) as string

sys    xopf    'external operator flag
sys    rdo     'iter flag
sys    xit     'exit iter flag
sys    xdo     'exit flag
sys    fenc    'last fence position in varbuf
sys    coun    'params count
double pd[32]  'parameter array for customised functions
string ps[32]  'parameter array for customised functions

string cr   = chr(13,10) 'line break
string tab  = chr(9)     'tab
string chrt = chr(255)   'token marker


function countm(string s) as sys
================================
sys a,b,c
b=0
a=1
do
  c=a
  stepitem s,a
  if c=a then exit do else b++
end do
return b
end function


function setmids(string wr, sys i,string wd)
============================================
sys aa,bb,ld,lv
ld=len wd
findvar wr,aa,bb
if aa then
  aa+=i-1
  lv=bb-aa
  if lv>0 then
    sys p = aa-1+strptr varbuf
    sys q =strptr wd
    sys a = ld
    if a>lv then a=lv
    copy p,q,a
  end if
end if
end function


macro selectmid()
=================
sys a,b,c,i
if m<0 then
  b=0
  a=1
  do
    c=a
    stepitem wd,a
    if c=a then exit do else b++
  end do
  m=b+m+1 ' counting from right
end if
a=1
for i=1 to < m
  c=a
  stepitem wd,a
  if c=a then exit for 'no more items
next
skipspace wd,a
b=a
for i=1 to n
  c=b
  stepitem wd,b
  if c=b then exit for 'no more items
next
skipspace wd,b
end macro


function setvar(string wr,sr,sys m,n)
==========================================
'n: 0 insert +ve overwrite -ve delete
sys aa,bb,le,i
string wd,wi,ws
le=len(sr)
i=1
if n>=0 then
  wi=mid sr,i,le
else 'DELETION
  n=-n
  'wi empty
end if
findvar wr,aa,bb
if aa then
  wd=mid varbuf,aa,bb-aa
  if m then 'REWRITE MEMBERS
    selectmid
    if len(wi)>0 and bb>aa then ws=" " 'SPACER
    wi=left(wd,a-1)+wi+ws+mid(wd,b)
  else
    if n=0 then
      if len(wi)>0 and bb>aa then ws=" " 'SPACER
      wi=wd+ws+wi  'APPEND
    end if
  end if
  if aa>fenc then
    insvar(wi,aa,bb) 'WRITE TO ORIGINAL VARIABLE
    exit function
  end if
end if
newtrimvar wr,wi 'CREATE NEW VARIABLE
end function


function getvar(string wr,sys m,n) as string
============================================
sys aa,bb,de
if n<0 then
  n=-n : de=1 'EXTRACTIVE
end if
string wd
findvar wr,aa,bb
if aa then
  if m then
    wd=mid varbuf,aa,bb-aa
    selectmid
    function=mid(wd,a,b-a)
    if de then wd=left(wd,a-1)+mid(wd,b) 'DELETE MEMBERS
  else
    function=mid varbuf,aa,bb-aa
    if de then wd="" 'DELETE ALL CONTENTS
  end if
  if de then
    if aa>fenc then
      insvar(wd,aa,bb) 'WRITE TO ORIGINAL VARIABLE
    else
      newtrimvar wr,wd 'CREATE NEW VARIABLE
    end if
  end if
end if
end function


function ordpos(string wd,sys m) as sys
=======================================
sys i,c,le
i=1
le=len wd
if m>le then exit function
do
  c++
  stepitem wd,i
  if i>=m then return c 
end do
end function


function getit(string wr) as string
===================================
ascw=asc wr
select ascw
case 40 : i=sttw    : return eval wr,1    'expr
case 45,46,48 to 57 : return wr           'number
case 34,39,96       : return unquote wr   'quote
case 0              : return ""           'empty
end select
'otherwise assume variable
return getvar wr,0,0
end function


function getval(string sr, sys*i) as string
===========================================
string wr
wr=getword sr,i
select ascw
case 40 : i=sttw    : return eval sr,i    'expr
case 45,46,48 to 57 : return wr           'number
case 34,39,96       : return unquote wr   'quote
case 0              : return ""           'empty
end select
'otherwise assume variable
wr=getvar wr,0,0
if asc(wr)<>40 then return wr
return eval wr,1
end function


function getnval(string sr, sys*i) as double
============================================
string wr
wr=getword sr,i
select ascw
case 40 : i=sttw    : return eval sr,i    'expr
case 45,46,48 to 57 : char*w=sttw-1+strptr sr
                      return val w        'number
case 34,39,96       : return 0            'quote
case 0              : return 0            'empty
end select
'otherwise assume variable
wr=getvar(wr,0,0)
if asc(wr)<>40 then return val wr
return val eval wr,1
end function


function items() as sys
=======================
sys a=1
string wr=getvar("items",0,0)
sys lw=len wr
wi=getitem(wr,a)
if wi then
  coun++
  setvar "items",mid(wr,a,lw-a+1),0,1
  setvar "item",wi,0,1
  return 1
end if
end function


function replace(string t,w,r) as string
========================================
'
sys a,b,ls,lw,lr
string s=t
'
lw=len w
ls=len s
if lw=0 or ls<lw then return s
lr=len(r)
a=1
'  
do
  a=instr(a,s,w)
  if a=0 then exit do
  s=left(s,a-1)+r+mid(s,a+lw)
  a+=lr
end do
return s
end function



'HARD CODED FUNCTIONS / OPERATORS

ops="
no      1,
get     2,
let     3,
set     4,
=       4,
letmem  5,
find    6,
findr   7,
replace 8,
ordpos  9,

count   10,
loop    11,
exit    12,
next    13,
iter    14,
incr    15,
decr    16,

setmid  17,
getmid  18,
getmids 19,
setmids 20,

do     21,
pack   22,
eval   23,

if     24,
case   25,

lcase  26,
ucase  27,
ltrim  28,
rtrim  29,
asc    30,
inner  31,

not    32,
neg    33,

len     35,
space   36,
chr     37,
hex     38,
str     39,

+      43,
-      45,
*      42,
/      47,
and    48,
or     49,
xor    50,

<      60,
==     61,
>      62,
<=     65,
>=     66,
<>     67,

abs    70
recip  71,
deg    72,
rad    73,
sin    74,
cos    75,
tan    76,
asin   77,
acos   78,
atn    79,
atan   80,
sqrt   81,
exp    82,
mod    83,
pow    84,
lin    85,
log    86,
log2   87,
log10  88,
logn   89,
round  90,
trunc  91,
frac   92,
floor  93,
ceil   94,
hypot  95,

<<     100,
>>     101,
<<<    102,
>>>    103,

reading  110,
getword  111,
readpos  112,

extn     128,
exts     129,
call     130,
basic    131,
free     132,
tokens   133,

print    180,
printl   181,
input    182,
getkey   183,
cls      184,
setpos   185,
color    186,

getfile  190,
putfile  191,
datetime 192,

cr       230,
tab      231,
pi       240,
"

'APP EXTENSIONS
===============


function extNf(double *pd, sys n) as double,label
=================================================
'dummy
sys i
double d
for i=1 to n
  d+=pd[i]
next
return d
end function


function extSf(sys p, sys n) as string, label
=================================================
'dummy
string ps at p 'string array
string s
sys i
for i=1 to n
  s+=ps[i]+cr
next
return s
end function


!* extN(double *pd, sys n) as double
!* extS(sys      p, sys n) as string

@extN=@extNf 'function pointer
@extS=@extSf 'function pointer



function eval(string sr,sys*ii=1) as string
==========================================
string wr, wa, wo, ws
double v, w
sys    rc, sc
sys    a, b, i, j, nm, rb, ri, ido, ls, en
sys    op
'
skipspace(sr,ii)
rb=ii+1
stepitem(sr,ii)
i=rb
ls=ii-2

stepword sr,i
'
if ascw=0 then
  exit function 'EMPTY
elseif ascw=255 then
  op=opw 'USE TOKEN  
else
  wo=mid sr,sttw,lenw
  op=lookupindex ops,wo
  if not op then
    findvar wo,a,b
    if a=0
      return mid sr,rb,ls-rb+1 'RETURN AS UNPROCESSED LIST
    end if
    'param passing
    sys c,d
    newScope b    'local allocation point
    d=fenc
    fenc=b
    coun=0
    do
      wr=getit getitem sr,i 'next param
      c=sttw
      wp=getword varbuf,a 'itr malformed op trap?
      select ascw
      case 0  : exit do
      case 40 : a-- : exit do 'start of op
      end select
      newtrimvar wp,wr
    end do
    newtrimvar "items",mid sr,c,ls-c+1
    newvar "item",""
    wa=eval varbuf,a
    fenc=d
    endScope b  'disalloc locals
    if xdo then xdo--  'reduce exit flag
    return wa
  end if
end if
ri=i
do
  '
  def params
  a=getnval sr,i : b=getnval sr,i
  end def
  '
  def paramm
  b=getnval sr,i : ws=getval sr,i
  end def
  '
  def spaced
  a=len wa
  if a>0 and asc(wa,a)>32 and asc(wr)>32 then
    wa+=" "+wr
  else
    wa+=wr
  end if
  end def
  '
  '
  'OPERATIONS
  '
  select op
  case 1 to 9
    wr=getitem sr,i
    if ascw then
      select op
      case 1  : exit do                             'NO
      case 2  : wa=getvar wr, 0, 0    : exit do     'GET
      case 3  : ws=getval sr,i
              : newtrimvar wr,ws          : jmp fwd ndo 'LET
      case 4  : ws=getval sr,i
              : setvar wr,ws,0,1      : jmp fwd ndo 'SET
      case 5  : a=getnval sr,i
              : newvar wr,space(a)    : jmp fwd ndo 'LETMEM
      case 6  : 'FIND index string keyw
        a=getnval wr,1
        if a=0 then a=1
        wa=getit getitem sr,i
        wr=getval sr,i
        wa=str instr a, wa, wr
      case 7 : 'FINDR index string keyw
        v=getnval wr,1
        wa=getit getitem sr,i
        wr=getval sr,i
        wa=str instrev v, wa, wr
      case 8 : 'REPLACE
        ws=getval wr,1
        wa=getval sr,i
        wr=getval sr,i
        wa=replace(ws,wa,wr)
      case 9 : 'ORDPOS
        ws=getit wr
        a =getval sr,i
        wa=ordpos ws,a
        exit do
      end select
    end if
  case 10 to 20
    wr=getitem sr,i
    select op
    'LOOP & ITERATION
    case 10 : if ascw=0 then
                wa= str coun                 'COUNT ITEMS PROCESSED
              else 
                wa=str countm getit wr       'COUNT MEMBERS OF LIST
              end if
    case 11 : i=sttw                           'LOOP
      while xdo=0
        wr=getval sr,i
        ascw=asc wr
        spaced
        i=ri
      wend 
      xdo--
    case 12 : xdo=1 : a=wr : if a then xdo=a 'EXIT
    case 13 : rdo=1 : xit=1-items()          'NEXT
    case 14 : rdo=1 : a=getnval wr,1  : a--  'ITER
              if a<=0 then xit=1
              setvar wr,str(a),0,1
    case 15 : a=getnval wr,1  : a++ 'INCR
              ws=str a
              setvar wr,ws,0,1
    case 16 : a=getnval wr,1  : a-- 'DECR
              ws=str a
              setvar wr,ws,0,1
   'MID
    case 17 : params : ws=getval sr,i : setvar wr,ws,a, b 'SETMID
    case 18 : params : wa=getvar wr,a,b                   'GETMID
    case 19 : params : ws=getit wr : wa=mid ws,a,b        'GETMIDS
    case 20 : paramm : setmids wr,b,ws                    'SETMIDS
    end select
    exit do
    '
  case 21 to 23
    wr=getval sr,i
    select op
    case 21  :        'DO
    case 22  : wa+=wr 'PACK
    case 23  : spaced 'EVAL
    end select
    jmp fwd ndo
  case 24 to 31
    wr=getval sr,i
    select op
    case 24  : 'IF 'ELSE
      w=wr
      if w then 
        wa=getval sr,i : stepitem sr,i
      else
        stepitem sr,i : wa=getval sr,i
      end if
      exit do
    case 25 : 'CASE
      w=wr
      if sc=0 then
        sc=1
        ws=wr
        v=w
        wr=getval sr,i
        w=wr
      end if
      a=0
      if v then  'MATCH NUMERIC CASE
        if w=v then a=1
      else 'MATCH TEXT CASE
        if ws=wr then a=1
      end if
      if a then
        wa=getval sr,i
        exit do 'done
      else
        stepitem sr,i
      end if
      jmp fwd ndo
    case 26 : wa=lcase wr               'LCASE
    case 27 : wa=ucase wr               'UCASE
    case 28 : wa=ltrim wr               'LTRIM
    case 29 : wa=rtrim wr               'RTRIM
    case 30 : wa=str asc wr,getval sr,i 'ASC
    case 31 : wa=inner wr               'INNER
    end select
    exit do
    '
  case 32 to 41 
    '
    wr=getval sr,i
    v=wr
    if i<ls
      ws=getval sr,i
      w=ws
    end if
    '
    select op
    '
    'UNARY 
    case 32 : a=-v-1 : wa=str a 'NOT
    case 33 : wa=str -v         'NEG
    '
    'STRINGS WITH NUMERIC PARAMS
    case 35 : wa=str len wr 'LEN
    case 36 : wa=space v    'SPACE
    case 37 : wa=chr v      'CHR
    case 38 : wa=hex v,w    'HEX
    case 39 : wa=str v,w    'STR
    end select
    exit do
  case 42 to 50 'ARITHMETIC
    wr=getval sr,i 'PRE-EVALUATE
    if asc(wr) then
      w=wr
      if sc=0 then
        sc=1
        v=w
        w=getnval sr,i 'EVALUATE
      end if
      select op
      case 43 : v+=w
      case 45 : v-=w
      case 42 : v*=w
      case 47 : v/=w
      case 48 : v and= w 
      case 49 : v  or= w
      case 50 : v xor= w
      end select
    end if
    jmp fwd ndo
  case 60 to 67 'COMPARISONS
    wr=getval sr,i
    ws=getval sr,i
    select asc(wr)
    case 45,46,48 to 57 : nm=1 : v=wr : w=ws
    case else : v=0 : w=0
    end select
    a=0
    'COMPARE 
    if nm then 'number compare
      select op
      case 60 : a=(v<w)
      case 61 : a=(v==w)
      case 62 : a=(v>w)
      case 65 : a=(v<=w)
      case 66 : a=(v>=w)
      case 67 : a=(v<>w)
      end select
    else 'text compare
      ws=getval sr,i
      select op
      case 60 : a=(wr<ws)
      case 61 : a=(wr==ws)
      case 62 : a=(wr>ws)
      case 65 : a=(wr<=ws)
      case 66 : a=(wr>=ws)
      case 67 : a=(wr<>ws)
      end select
    end if
    wa=str a and 1 'comparison boolean
    exit do
    '
  case 70 to 99
    v=getnval sr,i
    if i<ls
      w=getnval(sr,i)
    else
      w=1
    end if
    select op 'FLOAT FUNCTIONS
    case 70 : wa=str abs (v)
    case 71 : wa=str recip(v)
    case 72 : wa=str deg (v)
    case 73 : wa=str rad (v)
    case 74 : wa=str sin (v)
    case 75 : wa=str cos (v)
    case 76 : wa=str tan (v)
    case 77 : wa=str asin(v)
    case 78 : wa=str acos(v)
    case 79 : wa=str atn(v)
    case 80 : wa=str atan(v,w)
    case 81 : wa=str sqrt  (v)
    case 82 : wa=str exp   (v)
    case 83 : wa=str mod (v,w)
    case 84 : wa=str pow (v,w)
    case 85 : wa=str lin(v)
    case 86 : wa=str log(v)
    case 87 : wa=str log2(v)
    case 88 : wa=str log10(v)
    case 89 : wa=str logn(v,w)
    case 90 : wa=str round(v)
    case 91 : wa=str trunc(v)
    case 92 : wa=str frac(v)
    case 93 : wa=str floor(v)
    case 94 : wa=str ceil(v)
    case 95 : wa=str hypot(v,w)
    end select
    exit do
  case 100 to 109
    a=getnval sr,i
    if i<ls
      b=getnval(sr,i)
    else
      b=1
    end if
    select op
    case 100 : wa=a<<b
    case 101 : wa=a>>b
    case 102 : wa=a<<<b
    case 103 : wa=a>>>b
    end select
  case 120 to 229
    wr=getval sr,i
    ascw=asc wr
    select op
    case 128 : 'EXTN
      if ascw
        en++
        pd[en]=wr 'double params
        continue do
      else
        wa=extN pd,en
        exit do
      end if
    case 129 : 'EXTS
      if ascw
        en++
        ps[en]=wr 'string params
        continue do
      else
        wa=exts @ps,en
        exit do
      end if
    #ifndef NoOxygenCompile
    case 130 : 'CALL
      if ascw
        if sc=0
          a=wr
          sc=1
        else
          en++
          ps[en]=wr 'string params
        end if
        continue do
      else
        if a then
          wa= (bstring) call a '@ps,en
        end if
        exit do
      end if
    case 131 : 'BASIC
      a=compile wr
      string er=error
      if er
        wa="0"+cr+er
      else
        wa=a
      end if
      exit do
    case 132 : 'FREE
      a=wr
      freememory a
    #endif
    case 133 : 'TOKENIZE
      wa=tokens wr
    'CONSOLE
    #ifdef UseSystemConsole
      case 180 : print wr
      case 181 : printl wr
      case 182 : wa=input
      case 183 : wa=str getkey
      case 184 : cls : exit do
      case 185 : a=getnval wr,1 : b=getnval sr,i : setpos a,b
      case 186 : color getnval wr,1
    #endif
    '
    'FILE
    case 190 : wa=getfile wr           'GETFILE
    case 191 : putfile wr,getval(sr,i) 'PUTFILE
    case 192 : wa=TimeStr              'DATETIME
    '
    'MACHINE
    case 200 'OPCODE
    end select
  case 230 to 255 'CONSTANTS
    select op
    case 230 : wa=cr
    case 231 : wa=tab
    case 240 : wa=str pi
    end select
  end select
  '
  '
  ====
  ndo:
  ====
  '
  if rdo 'DETECT GLOBAL ITER FLAG
    ido=rdo
    rdo=0
  end if
  '
  if ido then 'LOCAL NEXT / ITER
    if xit then xit=0 : exit do
  end if
  '
  if xdo then
    exit do
  end if
  '
  skipspace sr,i
  '
  if i>ls then
    if ido then
      i=ri : continue do 'ITERATION
    else
      exit do
    end if
  end if
  '
end do
select op
case 42 to 50 : wa+=str v 'ARITH / LOGICAL OPERATORS
end select
return wa
end function


function tokens(string s) as string
===================================
sys    i=1,j
sys    ls=len s
string sr=space ls*2
sys    ii=1
sys    op
string wr
do
  stepword s,i
  if ascb=0 then exit do
  if xopf then
    j=sttw
    skipspace s,i 'look ahead
  else
    j=i
  end if
  if ascb=40 then
    mid sr,ii,"(" : ii+=1
    wr=getword(s,j)
    if xopf then
      i+=1
    else
      i=j
    end if
    op=lookupindex ops,wr
    if op then
      mid sr,ii,chrt+chr(op) 'TOKENISE OP IN SOURCE STRING
      ii+=2
      continue do
    end if
  end if
  mid sr,ii, mid(s,sttw,lenw)
  ii+=lenw+1
end do
'printl left sr,ii-1
return left sr,ii-1
end function

function lisp(string s) as string
=================================
xopf=0
return eval(tokens(s))
end function


function xlisp(string s) as string
==================================
xopf=1
return eval(tokens(s))
end function
