'cTimerLowRes.inc class file
'Last updated:
'2011.10.22 KS

'Member variables have a "m" prefix for member
'Parameters/Arguements have an "a" prefix for arguement

declare function GetTickCount lib "kernel32.dll" () as sys

class cTimerLowRes
    private
        sys mFrames
        sys mCurrentTime
        sys mLastTime
        sys mElapsedTime
        double mFPS
        double mCurrentFPS
        
    public
        method GetFPS() as double
            mFrames++
            mCurrentTime = GetTickCount
            mElapsedTime = mCurrentTime - mLastTime
            if mElapsedTime >= 250 then 'check every 1/4 second
                mCurrentFPS = ( mFrames / mElapsedTime ) * 1000
                'average it out over 2 iterations
                mFPS = ( mFPS + mCurrentFPS ) / 2 
                mLastTime = mCurrentTime
                mFrames = 0
            end if
            return mFPS
        end method
        
        
        method GetTick() as sys
            return GetTickCount
        end method
    
    
        method Constructor()
            mFrames      = 0
            mCurrentTime = 0
            mElapsedTime = 0
            mFPS         = 0
            mCurrentFPS  = 0
            mLastTime    = GetTickCount
        end method
        
        
        method Destructor()
        end method
end class

'References:
' GetTickCount: http://msdn.microsoft.com/en-us/library/ms724408(v=vs.85).aspx