'Based on VB6 WinApi
'by Kent Sarikaya (kryton9) 2012 June

include once "winConsts.inc"

type RECT
    Left as long
    Top as long
    Right as long
    Bottom as long
end type

type RECTL
    Left as long
    Top as long
    Right as long
    Bottom as long
end type

type POINTAPI
    x as long
    y as long
end type

type POINTL
    x as long
    y as long
end type

type Size
    cx as long
    cy as long
end type

type POINTS
    x as short
    y as short
end type

type MSG
    hwnd as sys
    message as long
    wParam as long
    lParam as long
    time as long
    pt as POINTAPI
end type

type SID_IDENTIFIER_AUTHORITY
    Value(6) as byte
end type

type SID_AND_ATTRIBUTES
    Sid as long
    Attributes as long
end type

type OVERLAPPED
    Internal as long
    InternalHigh as long
    offset as long
    OffsetHigh as long
    hEvent as long
end type

type SECURITY_ATTRIBUTES
    nLength as long
    lpSecurityDescriptor as long
    bInheritHandle as sys 
end type

type PROCESS_INFORMATION
    hProcess as sys
    hThread as sys
    dwProcessId as long
    dwThreadId as long
end type

type FILETIME
    dwLowDateTime as long
    dwHighDateTime as long
end type

type SYSTEMTIME
    wYear as short
    wMonth as short
    wDayOfWeek as short
    wDay as short
    wHour as short
    wMinute as short
    wSecond as short
    wMilliseconds as short
end type

type COMMPROP
    wPacketLength as short
    wPacketVersion as short
    dwServiceMask as long
    dwReserved1 as long
    dwMaxTxQueue as long
    dwMaxRxQueue as long
    dwMaxBaud as long
    dwProvSubType as long
    dwProvCapabilities as long
    dwSettableParams as long
    dwSettableBaud as long
    wSettableData as short
    wSettableStopParity as short
    dwCurrentTxQueue as long
    dwCurrentRxQueue as long
    dwProvSpec1 as long
    dwProvSpec2 as long
    wcProvChar(1) as short
end type

type COMSTAT
    fBitFields as long
    cbInQue as long
    cbOutQue as long
end type

type DCB
    DCBlength as long
    BaudRate as long
    fBitFields as long
    wReserved as short
    XonLim as short
    XoffLim as short
    ByteSize as byte
    Parity as byte
    StopBits as byte
    XonChar as byte
    XoffChar as byte
    ErrorChar as byte
    EofChar as byte
    EvtChar as byte
    wReserved1 as short 
end type

type COMMTIMEOUTS
    ReadIntervalTimeout as long
    ReadTotalTimeoutMultiplier as long
    ReadTotalTimeoutConstant as long
    WriteTotalTimeoutMultiplier as long
    WriteTotalTimeoutConstant as long
end type

type SYSTEM_INFO
    dwOemID as long
    dwPageSize as long
    lpMinimumApplicationAddress as sys
    lpMaximumApplicationAddress as sys
    dwActiveProcessorMask as long
    dwNumberOrfProcessors as long
    dwProcessorType as long
    dwAllocationGranularity as long
    dwReserved as long
end type

type MEMORYSTATUS
    dwLength as long
    dwMemoryLoad as long
    dwTotalPhys as long
    dwAvailPhys as long
    dwTotalPageFile as long
    dwAvailPageFile as long
    dwTotalVirtual as long
    dwAvailVirtual as long
end type

type GENERIC_MAPPING
    GenericRead as long
    GenericWrite as long
    GenericExecute as long
    GenericAll as long
end type

type LUID
    LowPart as long
    HighPart as long
end type

type LUID_AND_ATTRIBUTES
    pLuid as LUID
    Attributes as long
end type

type ACL
    AclRevision as byte
    Sbz1 as byte
    AclSize as short
    AceCount as short
    Sbz2 as short
end type

type ACE_HEADER
    AceType as byte
    AceFlags as byte
    AceSize as long
end type

type ACCESS_ALLOWED_ACE
    Header as ACE_HEADER
    Mask as long
    SidStart as long
end type

type ACCESS_DENIED_ACE
    Header as ACE_HEADER
    Mask as long
    SidStart as long
end type

type SYSTEM_AUDIT_ACE
    Header as ACE_HEADER
    Mask as long
    SidStart as long
end type

type SYSTEM_ALARM_ACE
    Header as ACE_HEADER
    Mask as long
    SidStart as long
end type

type ACL_REVISION_INFORMATION
    AclRevision as long
end type

type ACL_SIZE_INFORMATION
    AceCount as long
    AclBytesInUse as long
    AclBytesFree as long
end type

type SECURITY_DESCRIPTOR
    Revision as byte
    Sbz1 as byte
    Control as long
    Owner as long
    Group as long
    Sacl as ACL
    Dacl as ACL
end type

type PRIVILEGE_SET
    PrivilegeCount as long
    Control as long
    Privilege(ANYSIZE_ARRAY) as LUID_AND_ATTRIBUTES
end type

type EXCEPTION_RECORD
    ExceptionCode as long
    ExceptionFlags as long
    pExceptionRecord as long	
    ExceptionAddress as long
    NumberParameters as long
    ExceptionInformation(EXCEPTION_MAXIMUM_PARAMETERS) as long
end type

type EXCEPTION_DEBUG_INFO
    pExceptionRecord as EXCEPTION_RECORD
    dwFirstChance as long
end type

type CREATE_THREAD_DEBUG_INFO
    hThread as sys
    lpThreadLocalBase as sys
    lpStartAddress as sys
end type

type CREATE_PROCESS_DEBUG_INFO
    hFile as sys
    hProcess as sys
    hThread as sys
    lpBaseOfImage as sys
    dwDebugInfoFileOffset as long
    nDebugInfoSize as long
    lpThreadLocalBase as sys
    lpStartAddress as sys
    lpImageName as sys
    fUnicode as short
end type

type EXIT_THREAD_DEBUG_INFO
    dwExitCode as long
end type

type EXIT_PROCESS_DEBUG_INFO
    dwExitCode as long
end type

type LOAD_DLL_DEBUG_INFO
    hFile as sys
    lpBaseOfDll as sys
    dwDebugInfoFileOffset as long
    nDebugInfoSize as long
    lpImageName as sys
    fUnicode as short
end type

type UNLOAD_DLL_DEBUG_INFO
    lpBaseOfDll as sys
end type

type OUTPUT_DEBUG_STRING_INFO
    lpDebugStringData as char ptr
    fUnicode as short
    nDebugStringLength as short
end type

type RIP_INFO
    dwError as long
    dwType as long
end type

type OFSTRUCT
    cBytes as byte
    fFixedDisk as byte
    nErrCode as short
    Reserved1 as short
    Reserved2 as short
    szPathName(OFS_MAXPATHNAME) as byte
end type

type CRITICAL_SECTION
    dummy as long
end type

type BY_HANDLE_FILE_INFORMATION
    dwFileAttributes as long
    ftCreationTime as FILETIME
    ftLastAccessTime as FILETIME
    ftLastWriteTime as FILETIME
    dwVolumeSerialNumber as long
    nFileSizeHigh as long
    nFileSizeLow as long
    nNumberOfLinks as long
    nFileIndexHigh as long
    nFileIndexLow as long
end type

type MEMORY_BASIC_INFORMATION
    BaseAddress as long
    AllocationBase as long
    AllocationProtect as long
    RegionSize as long
    State as long
    Protect as long
    lType as long
end type

type EVENTLOGRECORD
    Length as long 
    Reserved as long 
    RecordNumber as long 
    TimeGenerated as long 
    TimeWritten as long
    EventID as long
    EventType as short
    NumStrings as short
    EventCategory as short
    ReservedFlags as short 
    ClosingRecordNumber as long
    StringOffset as long 
    UserSidLength as long
    UserSidOffset as long
    DataLength as long
    DataOffset as long 
end type

type TOKEN_GROUPS
    GroupCount as long
    Groups(ANYSIZE_ARRAY) as SID_AND_ATTRIBUTES
end type

type TOKEN_PRIVILEGES
    PrivilegeCount as long
    Privileges(ANYSIZE_ARRAY) as LUID_AND_ATTRIBUTES
end type

type CONTEXT
    FltF0 as double
    FltF1 as double
    FltF2 as double
    FltF3 as double
    FltF4 as double
    FltF5 as double
    FltF6 as double
    FltF7 as double
    FltF8 as double
    FltF9 as double
    FltF10 as double
    FltF11 as double
    FltF12 as double
    FltF13 as double
    FltF14 as double
    FltF15 as double
    FltF16 as double
    FltF17 as double
    FltF18 as double
    FltF19 as double
    FltF20 as double
    FltF21 as double
    FltF22 as double
    FltF23 as double
    FltF24 as double
    FltF25 as double
    FltF26 as double
    FltF27 as double
    FltF28 as double
    FltF29 as double
    FltF30 as double
    FltF31 as double
    IntV0 as double
    IntT0 as double
    IntT1 as double
    IntT2 as double
    IntT3 as double
    IntT4 as double
    IntT5 as double
    IntT6 as double
    IntT7 as double
    IntS0 as double
    IntS1 as double
    IntS2 as double
    IntS3 as double
    IntS4 as double
    IntS5 as double
    IntFp as double
    IntA0 as double
    IntA1 as double
    IntA2 as double
    IntA3 as double
    IntA4 as double
    IntA5 as double
    IntT8 as double
    IntT9 as double
    IntT10 as double
    IntT11 as double
    IntRa as double
    IntT12 as double
    IntAt as double
    IntGp as double
    IntSp as double
    IntZero as double
    Fpcr as double
    SoftFpcr as double
    Fir as double
    Psr as long
    ContextFlags as long
    Fill(4) as long
end type

type EXCEPTION_POINTERS
    pExceptionRecord as EXCEPTION_RECORD
    ContextRecord as CONTEXT
end type

type LDT_BYTES	
    BaseMid as byte
    Flags1 as byte
    Flags2 as byte
    BaseHi as byte
end type

type LDT_ENTRY
    LimitLow as short
    BaseLow as short
    HighWord as long	
end type

type TIME_ZONE_INFORMATION
    Bias as long
    StandardName(32) as short
    StandardDate as SYSTEMTIME
    StandardBias as long
    DaylightName(32) as short
    DaylightDate as SYSTEMTIME
    DaylightBias as long
end type

type WIN32_STREAM_ID
    dwStreamID as long
    dwStreamAttributes as long
    dwStreamSizeLow as long
    dwStreamSizeHigh as long
    dwStreamNameSize as long
    cStreamName as byte
end type

type STARTUPINFO
    cb as long
    lpReserved as char ptr
    lpDesktop as char ptr
    lpTitle as char ptr
    dwX as long
    dwY as long
    dwXSize as long
    dwYSize as long
    dwXCountChars as long
    dwYCountChars as long
    dwFillAttribute as long
    dwFlags as long
    wShowWindow as short
    cbReserved2 as short
    lpReserved2 as sys
    hStdInput as sys
    hStdOutput as sys
    hStdError as sys
end type

type WIN32_FIND_DATA
    dwFileAttributes as long
    ftCreationTime as FILETIME
    ftLastAccessTime as FILETIME
    ftLastWriteTime as FILETIME
    nFileSizeHigh as long
    nFileSizeLow as long
    dwReserved0 as long
    dwReserved1 as long
    cFileName(MAX_PATH) as zstring
    cAlternate(14) as zstring
end type

type CPINFO
    MaxCharSize as long 
    DefaultChar(MAX_DEFAULTCHAR) as byte 
    LeadByte(MAX_LEADBYTES) as byte 
end type

type NUMBERFMT
    NumDigits as long 
    LeadingZero as long 
    Grouping as long 
    lpDecimalSep as char ptr 
    lpThousandSep as char ptr 
    NegativeOrder as long 
end type

type CURRENCYFMT
    NumDigits as long 
    LeadingZero as long 
    Grouping as long 
    lpDecimalSep as char ptr 
    lpThousandSep as char ptr 
    NegativeOrder as long 
    PositiveOrder as long 
    lpCurrencySymbol as char ptr 
end type

type COORD
    x as short
    y as short
end type

type SMALL_RECT
    Left as short
    Top as short
    Right as short
    Bottom as short
end type

type KEY_EVENT_RECORD
    bKeyDown as long
    wRepeatCount as short
    wVirtualKeyCode as short
    wVirtualScanCode as short
    uChar as byte
    dwControlKeyState as long
end type

type MOUSE_EVENT_RECORD
    dwMousePosition as COORD
    dwButtonState as long
    dwControlKeyState as long
    dwEventFlags as long
end type

type WINDOW_BUFFER_SIZE_RECORD
    dwSize as COORD
end type

type MENU_EVENT_RECORD
    dwCommandId as long
end type

type FOCUS_EVENT_RECORD
    bSetFocus as long
end type

type CHAR_INFO
    Char as short
    Attributes as short
end type

type CONSOLE_SCREEN_BUFFER_INFO
    dwSize as COORD
    dwCursorPosition as COORD
    wAttributes as short
    srWindow as SMALL_RECT
    dwMaximumWindowSize as COORD
end type

type CONSOLE_CURSOR_INFO
    dwSize as long
    bVisible as long
end type

type XFORM
    eM11 as double
    eM12 as double
    eM21 as double
    eM22 as double
    eDx as double
    eDy as double
end type

type BITMAP
    bmType as long
    bmWidth as long
    bmHeight as long
    bmWidthBytes as long
    bmPlanes as short
    bmBitsPixel as short
    bmBits as long
end type

type RGBTRIPLE
    rgbtBlue as byte
    rgbtGreen as byte
    rgbtRed as byte
end type

type RGBQUAD
    rgbBlue as byte
    rgbGreen as byte
    rgbRed as byte
    rgbReserved as byte
end type

type BITMAPCOREHEADER
    bcSize as long
    bcWidth as short
    bcHeight as short
    bcPlanes as short
    bcBitCount as short
end type

type BITMAPINFOHEADER
    biSize as long
    biWidth as long
    biHeight as long
    biPlanes as short
    biBitCount as short
    biCompression as long
    biSizeImage as long
    biXPelsPerMeter as long
    biYPelsPerMeter as long
    biClrUsed as long
    biClrImportant as long
end type

type BITMAPINFO
    bmiHeader as BITMAPINFOHEADER
    bmiColors as RGBQUAD
end type

type BITMAPCOREINFO
    bmciHeader as BITMAPCOREHEADER
    bmciColors as RGBTRIPLE
end type

type BITMAPFILEHEADER
    bfType as short
    bfSize as long
    bfReserved1 as short
    bfReserved2 as short
    bfOffBits as long
end type

type HANDLETABLE
    objectHandle(1) as sys
end type

type METARECORD
    rdSize as long
    rdFunction as short
    rdParm(1) as short
end type

type METAFILEPICT
    mm as long
    xExt as long
    yExt as long
    hMF as sys
end type

type METAHEADER
    mtType as short
    mtHeaderSize as short
    mtVersion as short
    mtSize as long
    mtNoObjects as short
    mtMaxRecord as long
    mtNoParameters as short
end type

type ENHMETARECORD
    iType as long
    nSize as long
    dParm(1) as long
end type

type SIZEL
    cx as long
    cy as long
end type

type ENHMETAHEADER
    iType as long
    nSize as long
    rclBounds as RECTL
    rclFrame as RECTL
    dSignature as long
    nVersion as long
    nBytes as long
    nRecords as long
    nHandles as short
    sReserved as short
    nDescription as long
    offDescription as long
    nPalEntries as long
    szlDevice as SIZEL
    szlMillimeters as SIZEL
end type

type TEXTMETRIC
    tmHeight as long
    tmAscent as long
    tmDescent as long
    tmInternalLeading as long
    tmExternalLeading as long
    tmAveCharWidth as long
    tmMaxCharWidth as long
    tmWeight as long
    tmOverhang as long
    tmDigitizedAspectX as long
    tmDigitizedAspectY as long
    tmFirstChar as byte
    tmLastChar as byte
    tmDefaultChar as byte
    tmBreakChar as byte
    tmItalic as byte
    tmUnderlined as byte
    tmStruckOut as byte
    tmPitchAndFamily as byte
    tmCharSet as byte
end type

type NEWTEXTMETRIC
    tmHeight as long
    tmAscent as long
    tmDescent as long
    tmInternalLeading as long
    tmExternalLeading as long
    tmAveCharWidth as long
    tmMaxCharWidth as long
    tmWeight as long
    tmOverhang as long
    tmDigitizedAspectX as long
    tmDigitizedAspectY as long
    tmFirstChar as byte
    tmLastChar as byte
    tmDefaultChar as byte
    tmBreakChar as byte
    tmItalic as byte
    tmUnderlined as byte
    tmStruckOut as byte
    tmPitchAndFamily as byte
    tmCharSet as byte
    ntmFlags as long
    ntmSizeEM as long
    ntmCellHeight as long
    ntmAveWidth as long
end type

type PELARRAY
    paXCount as long
    paYCount as long
    paXExt as long
    paYExt as long
    paRGBs as short
end type

type LOGBRUSH
    lbStyle as long
    lbColor as long
    lbHatch as long
end type

type LOGPEN
    lopnStyle as long
    lopnWidth as POINTAPI
    lopnColor as long
end type

type EXTLOGPEN
    elpPenStyle as long
    elpWidth as long
    elpBrushStyle as long
    elpColor as long
    elpHatch as long
    elpNumEntries as long
    elpStyleEntry(1) as long
end type

type PALETTEENTRY
    peRed as byte
    peGreen as byte
    peBlue as byte
    peFlags as byte
end type

type LOGPALETTE
    palVersion as short
    palNumEntries as short
    palPalEntry(1) as PALETTEENTRY
end type

type LOGFONT
    lfHeight as long
    lfWidth as long
    lfEscapement as long
    lfOrientation as long
    lfWeight as long
    lfItalic as byte
    lfUnderline as byte
    lfStrikeOut as byte
    lfCharSet as byte
    lfOutPrecision as byte
    lfClipPrecision as byte
    lfQuality as byte
    lfPitchAndFamily as byte
    lfFaceName(LF_FACESIZE) as byte
end type

type NONCLIENTMETRICS
    cbSize as long
    iBorderWidth as long
    iScrollWidth as long
    iScrollHeight as long
    iCaptionWidth as long
    iCaptionHeight as long
    lfCaptionFont as LOGFONT
    iSMCaptionWidth as long
    iSMCaptionHeight as long
    lfSMCaptionFont as LOGFONT
    iMenuWidth as long
    iMenuHeight as long
    lfMenuFont as LOGFONT
    lfStatusFont as LOGFONT
    lfMessageFont as LOGFONT
end type

type ENUMLOGFONT
    elfLogFont as LOGFONT
    elfFullName(LF_FULLFACESIZE) as byte
    elfStyle(LF_FACESIZE) as byte
end type

type PANOSE
    ulculture as long
    bFamilyType as byte
    bSerifStyle as byte
    bWeight as byte
    bProportion as byte
    bContrast as byte
    bStrokeVariation as byte
    bArmStyle as byte
    bLetterform as byte
    bMidline as byte
    bXHeight as byte
end type

type EXTLOGFONT
    elfLogFont as LOGFONT
    elfFullName(LF_FULLFACESIZE) as byte
    elfStyle(LF_FACESIZE) as byte
    elfVersion as long
    elfStyleSize as long
    elfMatch as long
    elfReserved as long
    elfVendorId(ELF_VENDOR_SIZE) as byte
    elfCulture as long
    elfPanose as PANOSE
end type

type DEVMODE
    dmDeviceName(CCHDEVICENAME) as zstring
    dmSpecVersion as short
    dmDriverVersion as short
    dmSize as short
    dmDriverExtra as short
    dmFields as long
    dmOrientation as short
    dmPaperSize as short
    dmPaperLength as short
    dmPaperWidth as short
    dmScale as short
    dmCopies as short
    dmDefaultSource as short
    dmPrintQuality as short
    dmColor as short
    dmDuplex as short
    dmYResolution as short
    dmTTOption as short
    dmCollate as short
    dmFormName(CCHFORMNAME) as zstring
    dmUnusedPadding as short
    dmBitsPerPel as long
    dmPelsWidth as long
    dmPelsHeight as long
    dmDisplayFlags as long
    dmDisplayFrequency as long
end type

type RGNDATAHEADER
    dwSize as long
    iType as long
    nCount as long
    nRgnSize as long
    rcBound as Rect
end type

type RGNDATA
    rdh as RGNDATAHEADER
    Buffer as byte
end type

type ABC
    abcA as long
    abcB as long
    abcC as long
end type

type ABCFLOAT
    abcfA as double
    abcfB as double
    abcfC as double
end type

type OUTLINETEXTMETRIC
    otmSize as long
    otmTextMetrics as TEXTMETRIC
    otmFiller as byte
    otmPanoseNumber as PANOSE
    otmfsSelection as long
    otmfsType as long
    otmsCharSlopeRise as long
    otmsCharSlopeRun as long
    otmItalicAngle as long
    otmEMSquare as long
    otmAscent as long
    otmDescent as long
    otmLineGap as long
    otmsCapEmHeight as long
    otmsXHeight as long
    otmrcFontBox as Rect
    otmMacAscent as long
    otmMacDescent as long
    otmMacLineGap as long
    otmusMinimumPPEM as long
    otmptSubscriptSize as POINTAPI
    otmptSubscriptOffset as POINTAPI
    otmptSuperscriptSize as POINTAPI
    otmptSuperscriptOffset as POINTAPI
    otmsStrikeoutSize as long
    otmsStrikeoutPosition as long
    otmsUnderscorePosition as long
    otmsUnderscoreSize as long
    otmpFamilyName as char ptr
    otmpFaceName as char ptr
    otmpStyleName as char ptr
    otmpFullName as char ptr
end type

type POLYTEXT
    x as long
    y as long
    n as long
    lpStr as char ptr
    uiFlags as long
    rcl as Rect
    pdx as long
end type

type FIXED
    fract as short
    Value as short
end type

type MAT2
    eM11 as FIXED
    eM12 as FIXED
    eM21 as FIXED
    eM22 as FIXED
end type

type GLYPHMETRICS
    gmBlackBoxX as long
    gmBlackBoxY as long
    gmptGlyphOrigin as POINTAPI
    gmCellIncX as short
    gmCellIncY as short
end type

type POINTFX
    x as FIXED
    y as FIXED
end type

type TTPOLYCURVE
    wType as short
    cpfx as short
    apfx as POINTFX
end type

type TTPOLYGONHEADER
    cb as long
    dwType as long
    pfxStart as POINTFX
end type

type RASTERIZER_STATUS
    nSize as short
    wFlags as short
    nLanguageID as short
end type

type COLORADJUSTMENT
    caSize as short
    caFlags as short
    caIlluminantIndex as short
    caRedGamma as short
    caGreenGamma as short
    caBlueGamma as short
    caReferenceBlack as short
    caReferenceWhite as short
    caContrast as short
    caBrightness as short
    caColorfulness as short
    caRedGreenTint as short
end type

type DOCINFO
    cbSize as long
    lpszDocName as char ptr
    lpszOutput as char ptr
end type

type KERNINGPAIR
    wFirst as short
    wSecond as short
    iKernAmount as long
end type

type emr
    iType as long
    nSize as long
end type

type emrtext
    ptlReference as POINTL
    nchars as long
    offString as long
    fOptions as long
    rcl as RECTL
    offDx as long
end type

type EMRABORTPATH
    pEmr as emr
end type

type EMRBEGINPATH
    pEmr as emr
end type

type EMRENDPATH
    pEmr as emr
end type

type EMRCLOSEFIGURE
    pEmr as emr
end type

type EMRFLATTENPATH
    pEmr as emr
end type

type EMRWIDENPATH
    pEmr as emr
end type

type EMRSETMETARGN
    pEmr as emr
end type

type EMREMRSAVEDC
    pEmr as emr
end type

type EMRREALIZEPALETTE
    pEmr as emr
end type

type EMRSELECTCLIPPATH
    pEmr as emr
    iMode as long
end type

type EMRSETBKMODE
    pEmr as emr
    iMode as long
end type

type EMRSETMAPMODE
    pEmr as emr
    iMode as long
end type

type EMRSETPOLYFILLMODE
    pEmr as emr
    iMode as long
end type

type EMRSETROP2
    pEmr as emr
    iMode as long
end type

type EMRSETSTRETCHBLTMODE
    pEmr as emr
    iMode as long
end type

type EMRSETTEXTALIGN
    pEmr as emr
    iMode as long
end type

type EMRSETMITERLIMIT
    pEmr as emr
    eMiterLimit as double
end type

type EMRRESTOREDC
    pEmr as emr
    iRelative as long
end type

type EMRSETARCDIRECTION
    pEmr as emr
    iArcDirection as long
end type

type EMRSETMAPPERFLAGS
    pEmr as emr
    dwFlags as long
end type

type EMRSETTEXTCOLOR
    pEmr as emr
    crColor as long
end type

type EMRSETBKCOLOR
    pEmr as emr
    crColor as long
end type

type EMRSELECTOBJECT
    pEmr as emr
    ihObject as sys
end type

type EMRDELETEOBJECT
    pEmr as emr
    ihObject as sys
end type

type EMRSELECTPALETTE
    pEmr as emr
    ihPal as sys
end type

type EMRRESIZEPALETTE
    pEmr as emr
    ihPal as sys
    cEntries as long
end type

type EMRSETPALETTEENTRIES
    pEmr as emr
    ihPal as sys
    iStart as long
    cEntries as long
    aPalEntries(1) as PALETTEENTRY
end type

type EMRSETCOLORADJUSTMENT
    pEmr as emr
    ColorAdjustment as ColorAdjustment
end type

type EMRGDICOMMENT
    pEmr as emr
    cbData as long
    Data(1) as short
end type

type EMREOF
    pEmr as emr
    nPalEntries as long
    offPalEntries as long
    nSizeLast as long
end type

type EMRLINETO
    pEmr as emr
    ptl as POINTL
end type

type EMRMOVETOEX
    pEmr as emr
    ptl as POINTL
end type

type EMROFFSETCLIPRGN
    pEmr as emr
    ptlOffset as POINTL
end type

type EMRFILLPATH
    pEmr as emr
    rclBounds as RECTL
end type

type EMRSTROKEANDFILLPATH
    pEmr as emr
    rclBounds as RECTL
end type

type EMRSTROKEPATH
    pEmr as emr
    rclBounds as RECTL
end type

type EMREXCLUDECLIPRECT
    pEmr as emr
    rclClip as RECTL
end type

type EMRINTERSECTCLIPRECT
    pEmr as emr
    rclClip as RECTL
end type

type EMRSETVIEWPORTORGEX
    pEmr as emr
    ptlOrigin as POINTL
end type

type EMRSETWINDOWORGEX
    pEmr as emr
    ptlOrigin as POINTL
end type

type EMRSETBRUSHORGEX
    pEmr as emr
    ptlOrigin as POINTL
end type

type EMRSETVIEWPORTEXTEX
    pEmr as emr
    szlExtent as SIZEL
end type

type EMRSETWINDOWEXTEX
    pEmr as emr
    szlExtent as SIZEL
end type

type EMRSCALEVIEWPORTEXTEX
    pEmr as emr
    xNum as long
    xDenom as long
    yNum as long
    yDemon as long
end type

type EMRSCALEWINDOWEXTEX
    pEmr as emr
    xNum as long
    xDenom as long
    yNum as long
    yDemon as long
end type

type EMRSETWORLDTRANSFORM
    pEmr as emr
    xform as XFORM
end type

type EMRMODIFYWORLDTRANSFORM
    pEmr as emr
    xform as XFORM
    iMode as long
end type

type EMRSETPIXELV
    pEmr as emr
    ptlPixel as POINTL
    crColor as long
end type

type EMREXTFLOODFILL
    pEmr as emr
    ptlStart as POINTL
    crColor as long
    iMode as long
end type

type EMRELLIPSE
    pEmr as emr
    rclBox as RECTL
end type

type EMRRECTANGLE
    pEmr as emr
    rclBox as RECTL
end type

type EMRROUNDRECT
    pEmr as emr
    rclBox as RECTL
    szlCorner as SIZEL
end type

type EMRARC
    pEmr as emr
    rclBox as RECTL
    ptlStart as POINTL
    ptlEnd as POINTL
end type

type EMRARCTO
    pEmr as emr
    rclBox as RECTL
    ptlStart as POINTL
    ptlEnd as POINTL
end type

type EMRCHORD
    pEmr as emr
    rclBox as RECTL
    ptlStart as POINTL
    ptlEnd as POINTL
end type

type EMRPIE
    pEmr as emr
    rclBox as RECTL
    ptlStart as POINTL
    ptlEnd as POINTL
end type

type EMRANGLEARC
    pEmr as emr
    ptlCenter as POINTL
    nRadius as long
    eStartAngle as double
    eSweepAngle as double
end type

type EMRPOLYLINE
    pEmr as emr
    rclBounds as RECTL
    cptl as long
    aptl(1) as POINTL
end type

type EMRPOLYBEZIER
    pEmr as emr
    rclBounds as RECTL
    cptl as long
    aptl(1) as POINTL
end type

type EMRPOLYGON
    pEmr as emr
    rclBounds as RECTL
    cptl as long
    aptl(1) as POINTL
end type

type EMRPOLYBEZIERTO
    pEmr as emr
    rclBounds as RECTL
    cptl as long
    aptl(1) as POINTL
end type

type EMRPOLYLINE16
    pEmr as emr
    rclBounds as RECTL
    cpts as long
    apts(1) as POINTS
end type

type EMRPOLYBEZIER16
    pEmr as emr
    rclBounds as RECTL
    cpts as long
    apts(1) as POINTS
end type

type EMRPOLYGON16
    pEmr as emr
    rclBounds as RECTL
    cpts as long
    apts(1) as POINTS
end type

type EMRPLOYBEZIERTO16
    pEmr as emr
    rclBounds as RECTL
    cpts as long
    apts(1) as POINTS
end type

type EMRPOLYLINETO16
    pEmr as emr
    rclBounds as RECTL
    cpts as long
    apts(1) as POINTS
end type

type EMRPOLYDRAW
    pEmr as emr
    rclBounds as RECTL
    cptl as long
    aptl(1) as POINTL
    abTypes(1) as short
end type

type EMRPOLYDRAW16
    pEmr as emr
    rclBounds as RECTL
    cpts as long
    apts(1) as POINTS
    abTypes(1) as short
end type

type EMRPOLYPOLYLINE
    pEmr as emr
    rclBounds as RECTL
    nPolys as long
    cptl as long
    aPolyCounts(1) as long
    aptl(1) as POINTL
end type

type EMRPOLYPOLYGON
    pEmr as emr
    rclBounds as RECTL
    nPolys as long
    cptl as long
    aPolyCounts(1) as long
    aptl(1) as POINTL
end type

type EMRPOLYPOLYLINE16
    pEmr as emr
    rclBounds as RECTL
    nPolys as long
    cpts as long
    aPolyCounts(1) as long
    apts(1) as POINTS
end type

type EMRPOLYPOLYGON16
    pEmr as emr
    rclBounds as RECTL
    nPolys as long
    cpts as long
    aPolyCounts(1) as long
    apts(1) as POINTS
end type

type EMRINVERTRGN
    pEmr as emr
    rclBounds as RECTL
    cbRgnData as long
    RgnData(1) as short
end type

type EMRPAINTRGN
    pEmr as emr
    rclBounds as RECTL
    cbRgnData as long
    RgnData(1) as short
end type

type EMRFILLRGN
    pEmr as emr
    rclBounds as RECTL
    cbRgnData as long
    ihBrush as sys
    RgnData(1) as short
end type

type EMRFRAMERGN
    pEmr as emr
    rclBounds as RECTL
    cbRgnData as long
    ihBrush as sys
    szlStroke as SIZEL
    RgnData(1) as short
end type

type EMREXTSELECTCLIPRGN
    pEmr as emr
    cbRgnData as long
    iMode as long
    RgnData(1) as short
end type

type EMREXTTEXTOUT
    pEmr as emr
    rclBounds as RECTL
    iGraphicsMode as long
    exScale as double
    eyScale as double
    emrtext as emrtext
end type

type EMRBITBLT
    pEmr as emr
    rclBounds as RECTL
    xDest as long
    yDest as long
    cxDest as long
    cyDest as long
    dwRop as long
    xSrc as long
    ySrc as long
    xformSrc as xform
    crBkColorSrc as long
    iUsageSrc as long
    offBmiSrc as long
    cbBmiSrc as long
    offBitsSrc as long
    cbBitsSrc as long
end type

type EMRSTRETCHBLT
    pEmr as emr
    rclBounds as RECTL
    xDest as long
    yDest as long
    cxDest as long
    cyDest as long
    dwRop as long
    xSrc as long
    ySrc as long
    xformSrc as xform
    crBkColorSrc as long
    iUsageSrc as long
    offBmiSrc as long
    cbBmiSrc as long
    offBitsSrc as long
    cbBitsSrc as long
    cxSrc as long
    cySrc as long
end type

type EMRMASKBLT
    pEmr as emr
    rclBounds as RECTL
    xDest as long
    yDest as long
    cxDest as long
    cyDest as long
    dwRop as long
    xSrc2 as long
    cyDest2 as long
    dwRop2 as long
    xSrc as long
    ySrc as long
    xformSrc as XFORM
    crBkColorSrc as long
    iUsageSrc as long
    offBmiSrc as long
    cbBmiSrc as long
    offBitsSrc as long
    cbBitsSrc as long
    xMask as long
    yMask as long
    iUsageMask as long
    offBmiMask as long
    cbBmiMask as long
    offBitsMask as long
    cbBitsMask as long
end type

type EMRPLGBLT
    pEmr as emr
    rclBounds as RECTL
    aptlDest(3) as POINTL
    xSrc as long
    ySrc as long
    cxSrc as long
    cySrc as long
    xformSrc as XFORM
    crBkColorSrc as long
    iUsageSrc as long
    offBmiSrc as long
    cbBmiSrc as long
    offBitsSrc as long
    cbBitsSrc as long
    xMask as long
    yMask as long
    iUsageMask as long
    offBmiMask as long
    cbBmiMask as long
    offBitsMask as long
    cbBitsMask as long
end type

type EMRSETDIBITSTODEVICE
    pEmr as emr
    rclBounds as RECTL
    xDest as long
    yDest as long
    xSrc as long
    ySrc as long
    cxSrc as long
    cySrc as long
    offBmiSrc as long
    cbBmiSrc as long
    offBitsSrc as long
    cbBitsSrc as long
    iUsageSrc as long
    iStartScan as long
    cScans as long
end type

type EMRSTRETCHDIBITS
    pEmr as emr
    rclBounds as RECTL
    xDest as long
    yDest as long
    xSrc as long
    ySrc as long
    cxSrc as long
    cySrc as long
    offBmiSrc as long
    cbBmiSrc as long
    offBitsSrc as long
    cbBitsSrc as long
    iUsageSrc as long
    dwRop as long
    cxDest as long
    cyDest as long
end type

type EMREXTCREATEFONTINDIRECT
    pEmr as emr
    ihFont as sys
    elfw as EXTLOGFONT
end type

type EMRCREATEPALETTE
    pEmr as emr
    ihPal as sys
    lgpl as LOGPALETTE
end type

type EMRCREATEPEN
    pEmr as emr
    ihPen as sys
    lopn as LOGPEN
end type

type EMREXTCREATEPEN
    pEmr as emr
    ihPen as sys
    offBmi as long
    cbBmi as long
    offBits as long
    cbBits as long
    elp as EXTLOGPEN
end type

type EMRCREATEBRUSHINDIRECT
    pEmr as emr
    ihBrush as sys
    lb as LOGBRUSH
end type

type EMRCREATEMONOBRUSH
    pEmr as emr
    ihBrush as sys
    iUsage as long
    offBmi as long
    cbBmi as long
    offBits as long
    cbBits as long
end type

type EMRCREATEDIBPATTERNBRUSHPT
    pEmr as emr
    ihBursh as sys
    iUsage as long
    offBmi as long
    cbBmi as long
    offBits as long
    cbBits as long
end type

type BITMAPV4HEADER
    bV4Size as long
    bV4Width as long
    bV4Height as long
    bV4Planes as short
    bV4BitCount as short
    bV4V4Compression as long
    bV4SizeImage as long
    bV4XPelsPerMeter as long
    bV4YPelsPerMeter as long
    bV4ClrUsed as long
    bV4ClrImportant as long
    bV4RedMask as long
    bV4GreenMask as long
    bV4BlueMask as long
    bV4AlphaMask as long
    bV4CSType as long
    bV4Endpoints as long
    bV4GammaRed as long
    bV4GammaGreen as long
    bV4GammaBlue as long
end type

type FONTSIGNATURE
    fsUsb(4) as long
    fsCsb(2) as long
end type

type CHARSETINFO
    ciCharset as long
    ciACP as long
    fs as FONTSIGNATURE
end type

type LOCALESIGNATURE
    lsUsb(4) as long
    lsCsbDefault(2) as long
    lsCsbSupported(2) as long
end type

type NEWTEXTMETRICEX
    ntmTm as NEWTEXTMETRIC
    ntmFontSig as FONTSIGNATURE
end type

type ENUMLOGFONTEX
    elfLogFont as LOGFONT
    elfFullName(LF_FULLFACESIZE) as byte
    elfStyle(LF_FACESIZE) as byte
    elfScript(LF_FACESIZE) as byte
end type

type GCP_RESULTS
    lStructSize as long
    lpOutString as char ptr
    lpOrder as sys
    lpDX as sys
    lpCaretPos as sys
    lpClass as char ptr
    lpGlyphs as char ptr
    nGlyphs as long
    nMaxFit as long
end type

type CIEXYZ
    ciexyzX as long
    ciexyzY as long
    ciexyzZ as long
end type

type CIEXYZTRIPLE
    ciexyzRed as CIEXYZ
    ciexyzGreen as CIEXYZ
    ciexyBlue as CIEXYZ
end type

type LOGCOLORSPACE
    lcsSignature as long
    lcsVersion as long
    lcsSize as long
    lcsCSType as long
    lcsIntent as long
    lcsEndPoints as CIEXYZTRIPLE
    lcsGammaRed as long
    lcsGammaGreen as long
    lcsGammaBlue as long
    lcsFileName(MAX_PATH) as zstring
end type

type EMRSELECTCOLORSPACE
    pEmr as emr
    ihCS as sys
end type

type EMRCREATECOLORSPACE
    pEmr as emr
    ihCS as sys
    lcs as LOGCOLORSPACE
end type

type CBTACTIVATESTRUCT
    fMouse as long
    hWndActive as sys
end type

type EVENTMSG
    message as long
    paramL as long
    paramH as long
    time as long
    hwnd as sys
end type

type CWPSTRUCT
    lParam as long
    wParam as long
    message as long
    hwnd as sys
end type

type DEBUGHOOKINFO
    hModuleHook as sys
    Reserved as long
    lParam as long
    wParam as long
    code as long
end type

type MOUSEHOOKSTRUCT
    pt as POINTAPI
    hwnd as sys
    wHitTestCode as long
    dwExtraInfo as long
end type

type MINMAXINFO
    ptReserved as POINTAPI
    ptMaxSize as POINTAPI
    ptMaxPosition as POINTAPI
    ptMinTrackSize as POINTAPI
    ptMaxTrackSize as POINTAPI
end type

type COPYDATASTRUCT
    dwData as long
    cbData as long
    lpData as sys
end type

type WINDOWPOS
    hwnd as sys
    hWndInsertAfter as sys
    x as long
    y as long
    cx as long
    cy as long
    flags as long
end type

type ACCEL
    fVirt as byte
    key as short
    cmd as short
end type

type PAINTSTRUCT
    hdc as sys
    fErase as long
    rcPaint as Rect
    fRestore as long
    fIncUpdate as long
    rgbReserved(32) as byte
end type

type CREATESTRUCT
    lpCreateParams as sys
    hInstance as sys
    hMenu as sys
    hWndParent as sys
    cy as long
    cx as long
    y as long
    x as long
    style as long
    lpszName as char ptr
    lpszClass as char ptr
    ExStyle as long
end type

type CBT_CREATEWND
    lpcs as CREATESTRUCT
    hWndInsertAfter as sys
end type

type WINDOWPLACEMENT
    Length as long
    flags as long
    showCmd as long
    ptMinPosition as POINTAPI
    ptMaxPosition as POINTAPI
    rcNormalPosition as Rect
end type

type MEASUREITEMSTRUCT
    CtlType as long
    CtlID as long
    itemID as long
    itemWidth as long
    itemHeight as long
    itemData as long
end type

type DRAWITEMSTRUCT
    CtlType as long
    CtlID as long
    itemID as long
    itemAction as long
    itemState as long
    hwndItem as sys
    hdc as sys
    rcItem as Rect
    itemData as long
end type

type DELETEITEMSTRUCT
    CtlType as long
    CtlID as long
    itemID as long
    hwndItem as sys
    itemData as long
end type

type COMPAREITEMSTRUCT
    CtlType as long
    CtlID as long
    hwndItem as sys
    itemID1 as long
    itemData1 as long
    itemID2 as long
    itemData2 as long
end type

type WNDCLASS
    style as long
    lpfnwndproc as sys
    cbClsextra as long
    cbWndExtra as long
    hInstance as sys
    hIcon as sys
    hCursor as sys
    hbrBackground as sys
    lpszMenuName as char ptr
    lpszClassName as char ptr
end type

type DLGTEMPLATE
    style as long
    dwExtendedStyle as long
    cdit as short
    x as short
    y as short
    cx as short
    cy as short
end type

type DLGITEMTEMPLATE
    style as long
    dwExtendedStyle as long
    x as short
    y as short
    cx as short
    cy as short
    id as short
end type

type MENUITEMTEMPLATEHEADER
    versionNumber as short
    offset as short
end type

type MENUITEMTEMPLATE
    mtOption as short
    mtID as short
    mtString as byte
end type

type ICONINFO
    fIcon as long
    xHotspot as long
    yHotspot as long
    hbmMask as long
    hbmColor as long
end type

type MDICREATESTRUCT
    szClass as char ptr
    szTitle as char ptr
    hOwner as sys
    x as long
    y as long
    cx as long
    cy as long
    style as long
    lParam as long
end type

type CLIENTCREATESTRUCT
    hWindowMenu as sys
    idFirstChild as long
end type

type MULTIKEYHELP
    mkSize as long
    mkKeylist as byte
    szKeyphrase(253) as zstring
end type

type HELPWININFO
    wStructSize as long
    x as long
    y as long
    dx as long
    dy as long
    wMax as long
    rgchMember(2) as zstring
end type

type DDEACK
    bAppReturnCode as short
    Reserved as short
    fbusy as short
    fack as short
end type

type DDEADVISE
    Reserved as short
    fDeferUpd as short
    fAckReq as short
    cfFormat as short
end type

type DDEDATA
    unused as short
    fresponse as short
    fRelease as short
    Reserved as short
    fAckReq as short
    cfFormat as short
    Value(1) as byte
end type

type DDEPOKE
    unused as short
    fRelease as short
    fReserved as short
    cfFormat as short
    Value(1) as byte
end type

type DDELN
    unused as short
    fRelease as short
    fDeferUpd as short
    fAckReq as short
    cfFormat as short
end type

type DDEUP
    unused as short
    fAck as short
    fRelease as short
    fReserved as short
    fAckReq as short
    cfFormat as short
    rgb(1) as byte
end type

type HSZPAIR
    hszSvc as sys
    hszTopic as sys
end type

type SECURITY_QUALITY_OF_SERVICE
    Length as long
    Impersonationlevel as short
    ContextTrackingMode as short
    EffectiveOnly as long
end type

type CONVCONTEXT
    cb as long
    wFlags as long
    wCountryID as long
    iCodePage as long
    dwLangID as long
    dwSecurity as long
    qos as SECURITY_QUALITY_OF_SERVICE
end type

type CONVINFO
    cb as long
    hUser as sys
    hConvPartner as sys
    hszSvcPartner as sys
    hszServiceReq as sys
    hszTopic as sys
    hszItem as sys
    wFmt as long
    wType as long
    wStatus as long
    wConvst as long
    wLastError as long
    hConvList as sys
    ConvCtxt as CONVCONTEXT
    hwnd as sys
    hwndPartner as sys
end type

type DDEML_MSG_HOOK_DATA 
    uiLo as long 
    uiHi as long
    cbData as long 
    Data(8) as long 
end type

type MONMSGSTRUCT
    cb as long
    hwndTo as sys
    dwTime as long
    htask as sys
    wMsg as long
    wParam as long
    lParam as long
    dmhd as DDEML_MSG_HOOK_DATA 
end type

type MONCBSTRUCT
    cb as long
    dwTime as long
    htask as sys
    dwRet as long
    wType as long
    wFmt as long
    hConv as sys
    hsz1 as sys
    hsz2 as sys
    hData as sys
    dwData1 as long
    dwData2 as long
    cc as CONVCONTEXT 
    cbData as long 
    Data(8) as long 
end type

type MONHSZSTRUCT
    cb as long
    fsAction as long 
    dwTime as long
    hsz as sys
    htask as sys
    str as byte
end type

type MONERRSTRUCT
    cb as long
    wLastError as long
    dwTime as long
    htask as sys
end type

type MONLINKSTRUCT
    cb as long
    dwTime as long
    htask as sys
    fEstablished as long
    fNoData as long
    hszSvc as sys
    hszTopic as sys
    hszItem as sys
    wFmt as long
    fServer as long
    hConvServer as sys
    hConvClient as sys
end type

type MONCONVSTRUCT
    cb as long
    fConnect as long
    dwTime as long
    htask as sys
    hszSvc as sys
    hszTopic as sys
    hConvClient as sys
    hConvServer as sys
end type

type smpte
    hour as byte
    min as byte
    sec as byte
    frame as byte
    fps as byte
    dummy as byte
    pad(2) as byte
end type

type midi
    songptrpos as long
end type

type MMTIME
    wType as long
    u as long
end type

type MIDIEVENT
    dwDeltaTime as long 
    dwStreamID as long 
    dwEvent as long 
    dwParms(1) as long 
end type

type MIDISTRMBUFFVER
    dwVersion as long 
    dwMid as long 
    dwOEMVersion as long 
end type

type MIDIPROPTIMEDIV
    cbStruct as long
    dwTimeDiv as long
end type

type MIDIPROPTEMPO
    cbStruct as long
    dwTempo as long
end type

type MIXERCAPS
    wMid as short 
    wPid as short 
    vDriverVersion as long 
    szPname(MAXPNAMELEN) as zstring 
    fdwSupport as long 
    cDestinations as long 
end type

type Target 
    dwType as long 
    dwDeviceID as long 
    wMid as short 
    wPid as short 
    vDriverVersion as long 
    szPname(MAXPNAMELEN) as zstring
end type

type MIXERLINE
    cbStruct as long 
    dwDestination as long 
    dwSource as long 
    dwLineID as long 
    fdwLine as long 
    dwUser as long 
    dwComponentType as long 
    cChannels as long 
    cConnections as long 
    cControls as long 
    szShortName(MIXER_SHORT_NAME_CHARS) as zstring
    szName(MIXER_LONG_NAME_CHARS) as zstring
    tTarget as Target
end type

type MIXERCONTROL
    cbStruct as long 
    dwControlID as long 
    dwControlType as long 
    fdwControl as long 
    cMultipleItems as long 
    szShortName(MIXER_SHORT_NAME_CHARS) as zstring
    szName(MIXER_LONG_NAME_CHARS) as zstring
    Bounds(6) as long 
    Metrics(6) as long 
end type

type MIXERLINECONTROLS
    cbStruct as long 
    dwLineID as long 
    dwControl as long 
    cControls as long 
    cbmxctrl as long 
    pamxctrl as MIXERCONTROL 
end type

type MIXERCONTROLDETAILS
    cbStruct as long 
    dwControlID as long 
    cChannels as long 
    item as long 
    cbDetails as long 
    paDetails as long 
end type

type MIXERCONTROLDETAILS_LISTTEXT
    dwParam1 as long
    dwParam2 as long
    szName(MIXER_LONG_NAME_CHARS) as zstring
end type

type MIXERCONTROLDETAILS_BOOLEAN
    fValue as long
end type

type MIXERCONTROLDETAILS_SIGNED
    lValue as long
end type

type MIXERCONTROLDETAILS_UNSIGNED
    dwValue as long
end type

type JOYINFOEX
    dwSize as long 
    dwFlags as long 
    dwXpos as long 
    dwYpos as long 
    dwZpos as long 
    dwRpos as long 
    dwUpos as long 
    dwVpos as long 
    dwButtons as long 
    dwButtonNumber as long 
    dwPOV as long 
    dwReserved1 as long 
    dwReserved2 as long 
end type

type DRVCONFIGINFO
    dwDCISize as long
    lpszDCISectionName as char ptr
    lpszDCIAliasName as char ptr
    dnDevNode as long
end type

type WAVEHDR
    lpData as char ptr
    dwBufferLength as long
    dwBytesRecorded as long
    dwUser as long
    dwFlags as long
    dwLoops as long
    lpNext as sys
    Reserved as long
end type

type WAVEOUTCAPS
    wMid as short
    wPid as short
    vDriverVersion as long
    szPname(MAXPNAMELEN) as zstring
    dwFormats as long
    wChannels as short
    dwSupport as long
end type

type WAVEINCAPS
    wMid as short
    wPid as short
    vDriverVersion as long
    szPname(MAXPNAMELEN) as zstring
    dwFormats as long
    wChannels as short
end type

type WAVEFORMAT
    wFormatTag as short
    nChannels as short
    nSamplesPerSec as long
    nAvgBytesPerSec as long
    nBlockAlign as short
end type

type PCMWAVEFORMAT
    wf as WAVEFORMAT
    wBitsPerSample as short
end type

type MIDIOUTCAPS
    wMid as short
    wPid as short
    vDriverVersion as long
    szPname(MAXPNAMELEN) as zstring
    wTechnology as short
    wVoices as short
    wNotes as short
    wChannelMask as short
    dwSupport as long
end type

type MIDIINCAPS
    wMid as short
    wPid as short
    vDriverVersion as long
    szPname(MAXPNAMELEN) as zstring
end type

type MIDIHDR
    lpData as char ptr
    dwBufferLength as long
    dwBytesRecorded as long
    dwUser as long
    dwFlags as long
    lpNext as sys
    Reserved as long
end type

type AUXCAPS
    wMid as short
    wPid as short
    vDriverVersion as long
    szPname(MAXPNAMELEN) as zstring
    wTechnology as short
    dwSupport as long
end type

type TIMECAPS
    wPeriodMin as long
    wPeriodMax as long
end type

type JOYCAPS
    wMid as short
    wPid as short
    szPname(MAXPNAMELEN) as zstring
    wXmin as short
    wXmax as short
    wYmin as short
    wYmax as short
    wZmin as short
    wZmax as short
    wNumButtons as short
    wPeriodMin as short
    wPeriodMax as short
end type

type JOYINFO
    wXpos as long
    wYpos as long
    wZpos as long
    wButtons as long
end type

type MMIOINFO
    dwFlags as long
    fccIOProc as long
    pIOProc as long
    wErrorRet as long
    htask as sys
    cchBuffer as long
    pchBuffer as char ptr
    pchNext as char ptr
    pchEndRead as char ptr
    pchEndWrite as char ptr
    lBufOffset as long
    lDiskOffset as long
    adwInfo(4) as long
    dwReserved1 as long
    dwReserved2 as long
    hmmio as sys
end type

type MMCKINFO
    ckid as long
    ckSize as long
    fccType as long
    dwDataOffset as long
    dwFlags as long
end type

type MCI_GENERIC_PARMS
    dwCallback as long
end type

type MCI_OPEN_PARMS
    dwCallback as long
    wDeviceID as long
    lpstrDeviceType as char ptr
    lpstrElementName as char ptr
    lpstrAlias as char ptr
end type

type MCI_PLAY_PARMS
    dwCallback as long
    dwFrom as long
    dwTo as long
end type

type MCI_SEEK_PARMS
    dwCallback as long
    dwTo as long
end type

type MCI_STATUS_PARMS
    dwCallback as long
    dwReturn as long
    dwItem as long
    dwTrack as short
end type

type MCI_INFO_PARMS
    dwCallback as long
    lpstrReturn as char ptr
    dwRetSize as long
end type

type MCI_GETDEVCAPS_PARMS
    dwCallback as long
    dwReturn as long
    dwIten as long
end type

type MCI_SYSINFO_PARMS
    dwCallback as long
    lpstrReturn as char ptr
    dwRetSize as long
    dwNumber as long
    wDeviceType as long
end type

type MCI_SET_PARMS
    dwCallback as long
    dwTimeFormat as long
    dwAudio as long
end type

type MCI_BREAK_PARMS
    dwCallback as long
    nVirtKey as long
    hwndBreak as sys
end type

type MCI_SOUND_PARMS
    dwCallback as long
    lpstrSoundName as char ptr
end type

type MCI_SAVE_PARMS
    dwCallback as long
    lpFileName as char ptr
end type

type MCI_LOAD_PARMS
    dwCallback as long
    lpFileName as char ptr
end type

type MCI_RECORD_PARMS
    dwCallback as long
    dwFrom as long
    dwTo as long
end type

type MCI_VD_PLAY_PARMS
    dwCallback as long
    dwFrom as long
    dwTo as long
    dwSpeed as long
end type

type MCI_VD_STEP_PARMS
    dwCallback as long
    dwFrames as long
end type

type MCI_VD_ESCAPE_PARMS
    dwCallback as long
    lpstrCommand as char ptr
end type

type MCI_WAVE_OPEN_PARMS
    dwCallback as long
    wDeviceID as long
    lpstrDeviceType as char ptr
    lpstrElementName as char ptr
    lpstrAlias as char ptr
    dwBufferSeconds as long
end type

type MCI_WAVE_DELETE_PARMS
    dwCallback as long
    dwFrom as long
    dwTo as long
end type

type MCI_WAVE_SET_PARMS
    dwCallback as long
    dwTimeFormat as long
    dwAudio as long
    wInput as long
    wOutput as long
    wFormatTag as short
    wReserved2 as short
    nChannels as short
    wReserved3 as short
    nSamplesPerSec as long
    nAvgBytesPerSec as long
    nBlockAlign as short
    wReserved4 as short
    wBitsPerSample as short
    wReserved5 as short
end type

type MCI_SEQ_SET_PARMS
    dwCallback as long
    dwTimeFormat as long
    dwAudio as long
    dwTempo as long
    dwPort as long
    dwSlave as long
    dwMaster as long
    dwOffset as long
end type

type MCI_ANIM_OPEN_PARMS
    dwCallback as long
    wDeviceID as long
    lpstrDeviceType as char ptr
    lpstrElementName as char ptr
    lpstrAlias as char ptr
    dwStyle as long
    hWndParent as sys
end type

type MCI_ANIM_PLAY_PARMS
    dwCallback as long
    dwFrom as long
    dwTo as long
    dwSpeed as long
end type

type MCI_ANIM_STEP_PARMS
    dwCallback as long
    dwFrames as long
end type

type MCI_ANIM_WINDOW_PARMS
    dwCallback as long
    hwnd as sys
    nCmdShow as long
    lpstrText as char ptr
end type

type MCI_ANIM_RECT_PARMS
    dwCallback as long
    rc as Rect
end type

type MCI_ANIM_UPDATE_PARMS
    dwCallback as long
    rc as Rect
    hdc as sys
end type

type MCI_OVLY_OPEN_PARMS
    dwCallback as long
    wDeviceID as long
    lpstrDeviceType as char ptr
    lpstrElementName as char ptr
    lpstrAlias as char ptr
    dwStyle as long
    hWndParent as sys
end type

type MCI_OVLY_WINDOW_PARMS
    dwCallback as long
    hwnd as sys
    nCmdShow as long
    lpstrText as char ptr
end type

type MCI_OVLY_RECT_PARMS
    dwCallback as long
    rc as Rect
end type

type MCI_OVLY_SAVE_PARMS
    dwCallback as long
    lpFileName as char ptr
    rc as Rect
end type

type MCI_OVLY_LOAD_PARMS
    dwCallback as long
    lpFileName as char ptr
    rc as Rect
end type

type PRINTER_INFO_1
    flags as long
    pDescription as char ptr
    pName as char ptr
    pComment as char ptr
end type

type PRINTER_INFO_2
    pServerName as char ptr
    pPrinterName as char ptr
    pShareName as char ptr
    pPortName as char ptr
    pDriverName as char ptr
    pComment as char ptr
    pLocation as char ptr
    pDevMode as DEVMODE
    pSepFile as char ptr
    pPrintProcessor as char ptr
    pDatatype as char ptr
    pParameters as char ptr
    pSecurityDescriptor as SECURITY_DESCRIPTOR
    Attributes as long
    Priority as long
    DefaultPriority as long
    StartTime as long
    UntilTime as long
    Status as long
    cJobs as long
    AveragePPM as long
end type

type PRINTER_INFO_3
    pSecurityDescriptor as SECURITY_DESCRIPTOR
end type

type JOB_INFO_1
    JobId as long
    pPrinterName as char ptr
    pMachineName as char ptr
    pUserName as char ptr
    pDocument as char ptr
    pDatatype as char ptr
    pStatus as char ptr
    Status as long
    Priority as long
    Position as long
    TotalPages as long
    PagesPrinted as long
    Submitted as SYSTEMTIME
end type

type JOB_INFO_2
    JobId as long
    pPrinterName as char ptr
    pMachineName as char ptr
    pUserName as char ptr
    pDocument as char ptr
    pNotifyName as char ptr
    pDatatype as char ptr
    pPrintProcessor as char ptr
    pParameters as char ptr
    pDriverName as char ptr
    pDevMode as DEVMODE
    pStatus as char ptr
    pSecurityDescriptor as SECURITY_DESCRIPTOR
    Status as long
    Priority as long
    Position as long
    StartTime as long
    UntilTime as long
    TotalPages as long
    Size as long
    Submitted as SYSTEMTIME
    time as long
    PagesPrinted as long
end type

type ADDJOB_INFO_1
    Path as char ptr
    JobId as long
end type

type DRIVER_INFO_1
    pName as char ptr
end type

type DRIVER_INFO_2
    cVersion as long
    pName as char ptr
    pEnvironment as char ptr
    pDriverPath as char ptr
    pDataFile as char ptr
    pConfigFile as char ptr
end type

type DOC_INFO_1
    pDocName as char ptr
    pOutputFile as char ptr
    pDatatype as char ptr
end type

type FORM_INFO_1
    pName as char ptr
    Size as SIZEL
    ImageableArea as RECTL
end type

type PRINTPROCESSOR_INFO_1
    pName as char ptr
end type

type PORT_INFO_1
    pName as char ptr
end type

type MONITOR_INFO_1
    pName as char ptr
end type

type MONITOR_INFO_2
    pName as char ptr
    pEnvironment as char ptr
    pDLLName as char ptr
end type

type DATATYPES_INFO_1
    pName as char ptr
end type

type PRINTER_DEFAULTS
    pDatatype as char ptr
    pDevMode as DEVMODE
    DesiredAccess as long
end type

type PRINTER_INFO_4
    pPrinterName as char ptr
    pServerName as char ptr
    Attributes as long
end type

type PRINTER_INFO_5
    pPrinterName as char ptr
    pPortName as char ptr
    Attributes as long
    DeviceNotSelectedTimeout as long
    TransmissionRetryTimeout as long
end type

type DRIVER_INFO_3
    cVersion as long
    pName as char ptr 
    pEnvironment as char ptr 
    pDriverPath as char ptr 
    pDataFile as char ptr 
    pConfigFile as char ptr 
    pHelpFile as char ptr 
    pDependentFiles as char ptr 
    pMonitorName as char ptr 
    pDefaultDataType as char ptr 
end type

type DOC_INFO_2
    pDocName as char ptr
    pOutputFile as char ptr
    pDatatype as char ptr
    dwMode as long
    JobId as long
end type

type PORT_INFO_2
    pPortName as char ptr
    pMonitorName as char ptr
    pDescription as char ptr
    fPortType as long
    Reserved as long
end type

type PROVIDOR_INFO_1
    pName as char ptr
    pEnvironment as char ptr
    pDLLName as char ptr
end type

type NETRESOURCE
    dwScope as long
    dwType as long
    dwDisplayType as long
    dwUsage as long
    lpLocalName as char ptr
    lpRemoteName as char ptr
    lpComment as char ptr
    lpProvider as char ptr
end type

type NCB
    ncb_command as short
    ncb_retcode as short
    ncb_lsn as short
    ncb_num as short
    ncb_buffer as char ptr
    ncb_length as short
    ncb_callname(NCBNAMSZ) as zstring
    ncb_name(NCBNAMSZ) as zstring
    ncb_rto as short
    ncb_sto as short
    ncb_post as long
    ncb_lana_num as short
    ncb_cmd_cplt as short
    ncb_reserve(10) as byte
    ncb_event as long
end type

type ADAPTER_STATUS
    adapter_address(6) as zstring
    rev_major as short
    reserved0 as short
    adapter_type as short
    rev_minor as short
    duration as short
    frmr_recv as short
    frmr_xmit as short
    iframe_recv_err as short
    xmit_aborts as short
    xmit_success as long
    recv_success as long
    iframe_xmit_err as short
    recv_buff_unavail as short
    t1_timeouts as short
    ti_timeouts as short
    Reserved1 as long
    free_ncbs as short
    max_cfg_ncbs as short
    max_ncbs as short
    xmit_buf_unavail as short
    max_dgram_size as short
    pending_sess as short
    max_cfg_sess as short
    max_sess as short
    max_sess_pkt_size as short
    name_count as short
end type

type NAME_BUFFER
    name(NCBNAMSZ) as zstring
    name_num as short
    name_flags as short
end type

type SESSION_HEADER
    sess_name as short
    num_sess as short
    rcv_dg_outstanding as short
    rcv_any_outstanding as short
end type

type SESSION_BUFFER
    lsn as short
    State as short
    local_name(NCBNAMSZ) as zstring
    remote_name(NCBNAMSZ) as zstring
    rcvs_outstanding as short
    sends_outstanding as short
end type

type LANA_ENUM
    Length as short
    lana(MAX_LANA) as short
end type

type FIND_NAME_HEADER
    node_count as short
    Reserved as short
    unique_group as short
end type

type FIND_NAME_BUFFER
    Length as short
    access_control as short
    frame_control as short
    destination_addr(6) as short
    source_addr(6) as short
    routing_info(18) as short
end type

type ACTION_HEADER
    transport_id as long
    action_code as short
    Reserved as short
end type

type USER_INFO_3
    Name as long
    Password as long
    PasswordAge as long
    Privilege as long
    HomeDir as long
    Comment as long
    Flags as long
    ScriptPath as long
    AuthFlags as long
    FullName as long
    UserComment as long
    Parms as long
    Workstations as long
    LastLogon as long
    LastLogoff as long
    AcctExpires as long
    MaxStorage as long
    UnitsPerWeek as long
    LogonHours as long
    BadPwCount as long
    NumLogons as long
    LogonServer as long
    CountryCode as long
    CodePage as long
    UserID as long
    PrimaryGroupID as long
    Profile as long
    HomeDirDrive as long
    PasswordExpired as long
end type

type GROUP_INFO_2
    Name as long
    Comment as long
    GroupID as long
    Attributes as long
end type

type LOCALGROUP_MEMBERS_INFO_0
    pSID as long
end type

type LOCALGROUP_MEMBERS_INFO_1
    pSID as long
    eUsage as g_netSID_NAME_USE
    psName as long
end type

type WKSTA_INFO_102
    wki102_platform_id as long
    wki102_computername as long
    wki102_langroup as long
    wki102_ver_major as long
    wki102_ver_minor as long
    wki102_lanroot as long
    wki102_logged_on_users as long
end type

type WKSTA_USER_INFO_1
    wkui1_username as long
    wkui1_logon_domain as long
    wkui1_oth_domains as long
    wkui1_logon_server as long
end type

type NETRESOURCE
    dwScope as long
    dwType as long
    dwDisplayType as long
    dwUsage as long
    pLocalName as long
    pRemoteName as long
    pComment as long
    pProvider as long
end type

type CRGB
    bRed as byte
    bGreen as byte
    bBlue as byte
    bExtra as byte
end type

type SERVICE_STATUS
    dwServiceType as long
    dwCurrentState as long
    dwControlsAccepted as long
    dwWin32ExitCode as long
    dwServiceSpecificExitCode as long
    dwCheckPoint as long
    dwWaitHint as long
end type

type ENUM_SERVICE_STATUS
    lpServiceName as char ptr
    lpDisplayName as char ptr
    ServiceStatus as SERVICE_STATUS
end type

type QUERY_SERVICE_LOCK_STATUS
    fIsLocked as long
    lpLockOwner as char ptr
    dwLockDuration as long
end type

type QUERY_SERVICE_CONFIG
    dwServiceType as long
    dwStartType as long
    dwErrorControl as long
    lpBinaryPathName as char ptr
    lpLoadOrderGroup as char ptr
    dwTagId as long
    lpDependencies as char ptr
    lpServiceStartName as char ptr
    lpDisplayName as char ptr
end type

type SERVICE_TABLE_ENTRY
    lpServiceName as char ptr
    lpServiceProc as sys
end type

type LARGE_INTEGER
    lowpart as long
    highpart as long
end type

type PERF_DATA_BLOCK
    Signature(4) as zstring
    LittleEndian as long
    Version as long
    Revision as long
    TotalByteLength as long
    HeaderLength as long
    NumObjectTypes as long
    DefaultObject as long
    SystemTime as SYSTEMTIME
    PerfTime as LARGE_INTEGER
    PerfFreq as LARGE_INTEGER
    PerTime100nSec as LARGE_INTEGER
    SystemNameLength as long
    SystemNameOffset as long
end type

type PERF_OBJECT_TYPE
    TotalByteLength as long
    DefinitionLength as long
    HeaderLength as long
    ObjectNameTitleIndex as long
    ObjectNameTitle as char ptr
    ObjectHelpTitleIndex as long
    ObjectHelpTitle as char ptr
    DetailLevel as long
    NumCounters as long
    DefaultCounter as long
    NumInstances as long
    CodePage as long
    PerfTime as LARGE_INTEGER
    PerfFreq as LARGE_INTEGER
end type

type PERF_COUNTER_DEFINITION
    ByteLength as long
    CounterNameTitleIndex as long
    CounterNameTitle as char ptr
    CounterHelpTitleIndex as long
    CounterHelpTitle as char ptr
    DefaultScale as long
    DetailLevel as long
    CounterType as long
    CounterSize as long
    CounterOffset as long
end type

type PERF_INSTANCE_DEFINITION
    ByteLength as long
    ParentObjectTitleIndex as long
    ParentObjectInstance as long
    UniqueID as long
    NameOffset as long
    NameLength as long
end type

type PERF_COUNTER_BLOCK
    ByteLength as long
end type

type COMPOSITIONFORM
    dwStyle as long
    ptCurrentPos as POINTAPI
    rcArea as Rect
end type

type CANDIDATEFORM
    dwIndex as long
    dwStyle as long
    ptCurrentPos as POINTAPI
    rcArea as Rect
end type

type CANDIDATELIST
    dwSize as long
    dwStyle as long
    dwCount as long
    dwSelection as long
    dwPageStart as long
    dwPageSize as long
    dwOffset(1) as long
end type

type STYLEBUF
    dwStyle as long
    szDescription(STYLE_DESCRIPTION_SIZE) as zstring
end type

type MODEMDEVCAPS
    dwActualSize as long
    dwRequiredSize as long
    dwDevSpecificOffset as long
    dwDevSpecificSize as long
    dwModemProviderVersion as long
    dwModemManufacturerOffset as long
    dwModemManufacturerSize as long
    dwModemModelOffset as long
    dwModemModelSize as long
    dwModemVersionOffset as long
    dwModemVersionSize as long
    dwDialOptions as long 
    dwCallSetupFailTimer as long 
    dwInactivityTimeout as long 
    dwSpeakerVolume as long 
    dwSpeakerMode as long 
    dwModemOptions as long 
    dwMaxDTERate as long 
    dwMaxDCERate as long 
    abVariablePortion(1) as byte
end type

type MODEMSETTINGS
    dwActualSize as long
    dwRequiredSize as long
    dwDevSpecificOffset as long
    dwDevSpecificSize as long
    dwCallSetupFailTimer as long 
    dwInactivityTimeout as long 
    dwSpeakerVolume as long 
    dwSpeakerMode as long 
    dwPreferredModemOptions as long 
    dwNegotiatedModemOptions as long 
    dwNegotiatedDCERate as long 
    abVariablePortion(1) as byte
end type

type DRAGINFO
    uSize as long 
    pt as POINTAPI
    fNC as long
    lpFileList as char ptr
    grfKeyState as long
end type

type APPBARDATA
    cbSize as long
    hwnd as sys
    uCallbackMessage as long
    uEdge as long
    rc as Rect
    lParam as long 
end type

type SHFILEOPSTRUCT
    hwnd as sys
    wFunc as long
    pFrom as char ptr
    pTo as char ptr
    fFlags as short
    fAnyOperationsAborted as long
    hNameMappings as sys
    lpszProgressTitle as char ptr 
end type

type SHNAMEMAPPING
    pszOldPath as char ptr
    pszNewPath as char ptr
    cchOldPath as long
    cchNewPath as long
end type

type SHELLEXECUTEINFO
    cbSize as long
    fMask as long
    hwnd as sys
    lpVerb as char ptr
    lpFile as char ptr
    lpParameters as char ptr
    lpDirectory as char ptr
    nShow as long
    hInstApp as sys
    lpIDList as sys
    lpClass as char ptr
    hkeyClass as sys
    dwHotKey as long
    hIcon as sys
    hProcess as sys
end type

type NOTIFYICONDATA
    cbSize as long
    hwnd as sys
    uID as long
    uFlags as long
    uCallbackMessage as long
    hIcon as sys
    szTip(64) as zstring
end type

type SHFILEINFO
    hIcon as sys
    iIcon as long 
    dwAttributes as long 
    szDisplayName(MAX_PATH) as zstring 
    szTypeName(80) as zstring 
end type

type VS_FIXEDFILEINFO
    dwSignature as long
    dwStrucVersion as long 
    dwFileVersionMS as long 
    dwFileVersionLS as long 
    dwProductVersionMS as long 
    dwProductVersionLS as long 
    dwFileFlagsMask as long 
    dwFileFlags as long 
    dwFileOS as long 
    dwFileType as long 
    dwFileSubtype as long 
    dwFileDateMS as long 
    dwFileDateLS as long 
end type

type ICONMETRICS
    cbSize as long
    iHorzSpacing as long
    iVertSpacing as long
    iTitleWrap as long
    lfFont as LOGFONT
end type

type HELPINFO
    cbSize as long
    iContextType as long
    iCtrlId as long
    hItemHandle as sys
    dwContextId as long
    MousePos as POINTAPI
end type

type ANIMATIONINFO
    cbSize as long
    iMinAnimate as long
end type

type MINIMIZEDMETRICS
    cbSize as long
    iWidth as long
    iHorzGap as long
    iVertGap as long
    iArrange as long
    lfFont as LOGFONT
end type

type OSVERSIONINFO
    dwOSVersionInfoSize as long
    dwMajorVersion as long
    dwMinorVersion as long
    dwBuildNumber as long
    dwPlatformId as long
    szCSDVersion(128) as zstring
end type

type SYSTEM_POWER_STATUS
    ACLineStatus as byte
    BatteryFlag as byte
    BatteryLifePercent as byte
    Reserved1 as byte
    BatteryLifeTime as long
    BatteryFullLifeTime as long
end type

type OPENFILENAME
    lStructSize as long
    hwndOwner as sys
    hInstance as sys
    lpstrFilter as char ptr
    lpstrCustomFilter as char ptr
    nMaxCustFilter as long
    nFilterIndex as long
    lpstrFile as char ptr
    nMaxFile as long
    lpstrFileTitle as char ptr
    nMaxFileTitle as long
    lpstrInitialDir as char ptr
    lpstrTitle as char ptr
    flags as long
    nFileOffset as short
    nFileExtension as short
    lpstrDefExt as char ptr
    lCustData as long
    lpfnHook as sys
    lpTemplateName as char ptr
end type

type NMHDR
    hwndFrom as sys
    idfrom as long
    code as long
end type

type OFNOTIFY
    hdr as NMHDR
    lpOFN as OPENFILENAME
    pszFile as char ptr 
end type

type CHOOSECOLOR
    lStructSize as long
    hwndOwner as sys
    hInstance as sys
    rgbResult as long
    lpCustColors as sys
    flags as long
    lCustData as long
    lpfnHook as sys
    lpTemplateName as char ptr
end type

type FINDREPLACE
    lStructSize as long 
    hwndOwner as sys
    hInstance as sys
    flags as long 
    lpstrFindWhat as char ptr 
    lpstrReplaceWith as char ptr 
    wFindWhatLen as short 
    wReplaceWithLen as short 
    lCustData as long 
    lpfnHook as sys
    lpTemplateName as char ptr 
end type

type CHOOSEFONT
    lStructSize as long
    hwndOwner as sys
    hdc as sys
    lpLogFont as sys
    iPointSize as long 
    flags as long 
    rgbColors as long 
    lCustData as long 
    lpfnHook as sys
    lpTemplateName as char ptr 
    hInstance as sys
    lpszStyle as char ptr 
    nFontType as short 
    MISSING_ALIGNMENT as short
    nSizeMin as long 
    nSizeMax as long 
end type

type PRINTDLG
    lStructSize as long
    hwndOwner as sys
    hDevMode as sys
    hDevNames as sys
    hdc as sys
    flags as long
    nFromPage as short
    nToPage as short
    nMinPage as short
    nMaxPage as short
    nCopies as short
    hInstance as sys
    lCustData as long
    lpfnPrintHook as sys
    lpfnSetupHook as sys
    lpPrintTemplateName as char ptr
    lpSetupTemplateName as char ptr
    hPrintTemplate as sys
    hSetupTemplate as sys
end type

type DEVNAMES
    wDriverOffset as short
    wDeviceOffset as short
    wOutputOffset as short
    wDefault as short
end type

type PAGESETUPDLG
    lStructSize as long
    hwndOwner as sys
    hDevMode as sys
    hDevNames as sys
    flags as long
    ptPaperSize as POINTAPI
    rtMinMargin as Rect
    rtMargin as Rect
    hInstance as sys
    lCustData as long
    lpfnPageSetupHook as sys
    lpfnPagePaintHook as sys
    lpPageSetupTemplateName as char ptr
    hPageSetupTemplate as sys
end type

type COMMCONFIG
    dwSize as long
    wVersion as short
    wReserved as short
    dcbx as DCB
    dwProviderSubType as long
    dwProviderOffset as long
    dwProviderSize as long
    wcProviderData as byte
end type

type PIXELFORMATDESCRIPTOR
    nSize as short
    nVersion as short
    dwFlags as long
    iPixelType as byte
    cColorBits as byte
    cRedBits as byte
    cRedShift as byte
    cGreenBits as byte
    cGreenShift as byte
    cBlueBits as byte
    cBlueShift as byte
    cAlphaBits as byte
    cAlphaShift as byte
    cAccumBits as byte
    cAccumRedBits as byte
    cAccumGreenBits as byte
    cAccumBlueBits as byte
    cAccumAlphaBits as byte
    cDepthBits as byte
    cStencilBits as byte
    cAuxBuffers as byte
    iLayerType as byte
    bReserved as byte
    dwLayerMask as long
    dwVisibleMask as long
    dwDamageMask as long
end type

type DRAWTEXTPARAMS
    cbSize as long
    iTabLength as long
    iLeftMargin as long
    iRightMargin as long
    uiLengthDrawn as long
end type

type MENUITEMINFO
    cbSize as long
    fMask as long
    fType as long
    fState as long
    wID as long
    hSubMenu as sys
    hbmpChecked as sys
    hbmpUnchecked as sys
    dwItemData as long
    dwTypeData as char ptr
    cch as long
end type

type SCROLLINFO
    cbSize as long
    fMask as long
    nMin as long
    nMax as long
    nPage as long
    nPos as long
    nTrackPos as long
end type

type MSGBOXPARAMS
    cbSize as long
    hwndOwner as sys
    hInstance as sys
    lpszText as char ptr
    lpszCaption as char ptr
    dwStyle as long
    lpszIcon as char ptr
    dwContextHelpId as long
    lpfnMsgBoxCallback as sys
    dwLanguageId as long
end type

type WNDCLASSEX
    cbSize as long
    style as long
    lpfnWndProc as sys
    cbClsExtra as long
    cbWndExtra as long
    hInstance as sys
    hIcon as sys
    hCursor as sys
    hbrBackground as sys
    lpszMenuName as char ptr
    lpszClassName as char ptr
    hIconSm as sys
end type

type TPMPARAMS
    cbSize as long
    rcExclude as Rect
end type

