'cTimerHighRes.inc class file
'Last updated:
'2011.10.22 KS

'Member variables have a "m" prefix for member
'Parameters/Arguements have an "a" prefix for arguement

declare function QueryPerformanceCounter   lib "kernel32.dll" ( byRef lpPerformanceCount as quad ) as sys
declare function QueryPerformanceFrequency lib "kernel32.dll" ( byRef lpFrequency as quad ) as sys

class cTimerHighRes
    private 
        quad mBeginTime
        quad mEndTime
        quad mLastTime
        quad mFrequency
        quad mPauseTime
        sys  mRunning
        
    public 
        method Start()
            mRunning = 1
            SetBeginTime
        end method


        method Stop()
            mRunning = 0
            SetEndTime
        end method
        
 
        method Reset()
            if mRunning then
                Start
            else
                mRunning = 0
                mPauseTime = 0
            end if
        end method


        method GetSeconds() as double
            if mRunning then
                SetEndTime
            end if
            return ( mLastTime / mFrequency )
        end method
  
  
        method GetFrequency() as quad
            return mFrequency
        end method
 
 
        method IsRunning() as sys
            return mRunning
        end method


        method KillTimer()
            Destructor
        end method
        
        
        method Pause()
            if mRunning then
                Stop
            end if
            mPauseTime = mLastTime
        end method
        
        method Unpause()
            if mRunning = 0 then
                Start
            end if
        end method


    private 
        method Constructor()
            QueryPerformanceFrequency mFrequency 
            mRunning = 0
            mPauseTime = 0
        end method


        method Destructor()
            mRunning = 0
        end method
        
        
        method SetBeginTime()
            QueryPerformanceFrequency mFrequency
            QueryPerformanceCounter mBeginTime 
            mLastTime = 0
        end method


        method SetEndTime()
            QueryPerformanceCounter mEndTime 
            mLastTime = ( mEndTime - mBeginTime ) + mPauseTime
        end method
end class


'Notes:

'References:
'QueryPerformanceFrequency: http://msdn.microsoft.com/en-us/library/ms644905(v=vs.85).aspx
'QueryPerformanceCounter  : http://msdn.microsoft.com/en-us/library/ms644904(v=vs.85).aspx