#define SBT_UNDEF  0
#define SBT_DOUBLE 1
#define SBT_LONG   2
#define SBT_STRING 3
#define SBT_ZCHAR  4


type SbProgram
  pMEM              as sys
  maf               as sys
  mrf               as sys
  fErrorFlags       as sys
  pszFileName       as sys
  pszCacheFileName  as sys
  FirstUNIXline     as sys

  fpStdouFunction   as sys
  fpStdinFunction   as sys
  fpEnvirFunction   as sys
  pEmbedder         as sys
  fpReportFunction  as sys
  pReportPointer    as sys
  pSTI              as sys
  pEPo              as sys

  pCONF             as sys
  pREAD             as sys
  pLEX              as sys
  pEX               as sys
  pBUILD            as sys
  pEXE              as sys
  pPREP             as sys
end type

type SbData
  typ as dword
  siz as dword
  union {
    dbl as double
    lng as sys
    str as char*
    gen as sys
  }
end type


'ad-hoc definitions
'==================
typedef byte BYTE,*PBYTE
typedef sys(*pReportFunction)()
typedef sys ptConfigTree,pFixSizeMemoryObject,pCnode,pMortalList,pMemoryObject
typedef sys CommandFunctionType,SymbolTable,pSupportTable
typedef sys MUTEX,pModule,pHookFunctions,LexNASymbol,cSymbolList

typedef sys  CFT_NODE,pSbProgram,pSbData
typedef void FILE,DIR,DirEnt

typedef void* pExecuteObject


/*
typedef struct _FixSizeMemoryObject {

  union _fsmoval{
    PBYTE  pValue; // the value of the object
    long   lValue; // the long value of the object
    double dValue; // the double value of the object
    struct _FixSizeMemoryObject **aValue;
    } Value;
  unsigned long Size; // the actual size used (may be different from the size indicated by the type)
  BYTE sType; // index to the array SizeOfType. If this is LARGE_BLOCK_TYPE then
              // Size is the memory allocated for the value
  BYTE vType; // the variable type, VTYPE_/LONG/DOUBLE/STRING/REF/UNDEF/ARRAY
  BYTE State; // state of the variable (mortal, free or assigned)
  // these two pointers help to maintain either the free list or the mortal lists
  // a variable can never be in a free and in a mortal list at the same time
  // in case of reference variable these fields maintain a linked list of
  // variables referencing the same value
  struct _FixSizeMemoryObject *next;     // link to the next object
  union {
    struct _FixSizeMemoryObject *prev;   // link to the previous object
    struct _FixSizeMemoryObject **rprev; // link to the previous variable referencing
    }link;
  long ArrayLowLimit, ArrayHighLimit;    // If this is an array then these fields tell you where to start
                                         // and where to end
  } FixSizeMemoryObject, *pFixSizeMemoryObject, 
    *MortalList, **pMortalList;
*/



'HOOK FUNCTIONS
'==============

typedef struct _HookFunctions {

  void *hook_pointer;//this can freely be used by a module that alters some of the hook functions

#define HOOK_FILE_ACCESS(X) (pEo->pHookers->HOOK_file_access(pEo,(X)))
  int (*HOOK_file_access)(pExecuteObject, char *);

#define HOOK_FOPEN(X,Y) (pEo->pHookers->HOOK_fopen(pEo,(X),(Y)))
  FILE *(*HOOK_fopen)(pExecuteObject, char *, char *);

#define HOOK_FCLOSE(X) (pEo->pHookers->HOOK_fclose(pEo,(X)))
  void (*HOOK_fclose)(pExecuteObject, FILE *);

#define HOOK_SIZE(X) (pEo->pHookers->HOOK_size(pEo,(X)))
  long (*HOOK_size)(pExecuteObject, char *);

#define HOOK_TIME_ACCESSED(X) (pEo->pHookers->HOOK_time_accessed(pEo,(X)))
  long (*HOOK_time_accessed)(pExecuteObject, char *);

#define HOOK_TIME_MODIFIED(X) (pEo->pHookers->HOOK_time_modified(pEo,(X)))
  long (*HOOK_time_modified)(pExecuteObject, char *);

#define HOOK_TIME_CREATED(X) (pEo->pHookers->HOOK_time_created(pEo,(X)))
  long (*HOOK_time_created)(pExecuteObject, char *);

#define HOOK_ISDIR(X) (pEo->pHookers->HOOK_isdir(pEo,(X)))
  int (*HOOK_isdir)(pExecuteObject, char *);

#define HOOK_ISREG(X) (pEo->pHookers->HOOK_isreg(pEo,(X)))
  int (*HOOK_isreg)(pExecuteObject, char *);

#define HOOK_EXISTS(X) (pEo->pHookers->HOOK_exists(pEo,(X)))
  int (*HOOK_exists)(pExecuteObject, char *);

#define HOOK_TRUNCATE(X,Y) (pEo->pHookers->HOOK_truncate(pEo,(X),(Y)))
  int (*HOOK_truncate)(pExecuteObject, FILE *, long);

#define HOOK_FGETC(X) (pEo->pHookers->HOOK_fgetc(pEo,(X)))
  int (*HOOK_fgetc)(pExecuteObject, FILE *);

#define HOOK_FERROR(X) (pEo->pHookers->HOOK_ferror(pEo,(X)))
  int (*HOOK_ferror)(pExecuteObject, FILE *);

#define HOOK_FREAD(X,Y,Z,W) (pEo->pHookers->HOOK_fread(pEo,(X),(Y),(Z),(W)))
  int (*HOOK_fread)(pExecuteObject, char *, int, int, FILE *);

#define HOOK_SETMODE(X,Y) (pEo->pHookers->HOOK_setmode(pEo,(X),(Y)))
  void (*HOOK_setmode)(pExecuteObject,FILE *, int);

#define HOOK_BINMODE(X) (pEo->pHookers->HOOK_binmode(pEo,(X)))
  void (*HOOK_binmode)(pExecuteObject,FILE *);

#define HOOK_TEXTMODE(X) (pEo->pHookers->HOOK_textmode(pEo,(X)))
  void (*HOOK_textmode)(pExecuteObject,FILE *);

#define HOOK_FWRITE(X,Y,Z,W) (pEo->pHookers->HOOK_fwrite(pEo,(X),(Y),(Z),(W)))
  int (*HOOK_fwrite)(pExecuteObject, char *, int, int, FILE *);

#define HOOK_PUTC(X,Y) (pEo->pHookers->HOOK_fputc(pEo,(X),(Y)))
  int (*HOOK_fputc)(pExecuteObject, int, FILE *);

#define HOOK_FLOCK(X,Y) (pEo->pHookers->HOOK_flock(pEo,(X),(Y)))
  int (*HOOK_flock)(pExecuteObject, FILE *, int);

#define HOOK_LOCK(X,Y,Z,W) (pEo->pHookers->HOOK_lock(pEo,(X),(Y),(Z),(W)))
  int (*HOOK_lock)(pExecuteObject, FILE *, int, long, long);

#define HOOK_FEOF(X) (pEo->pHookers->HOOK_feof(pEo,(X)))
  int (*HOOK_feof)(pExecuteObject, FILE *);

#define HOOK_MKDIR(X) (pEo->pHookers->HOOK_mkdir(pEo,(X)))
  int (*HOOK_mkdir)(pExecuteObject, char *);

#define HOOK_RMDIR(X) (pEo->pHookers->HOOK_rmdir(pEo,(X)))
  int (*HOOK_rmdir)(pExecuteObject, char *);

#define HOOK_REMOVE(X) (pEo->pHookers->HOOK_remove(pEo,(X)))
  int (*HOOK_remove)(pExecuteObject, char *);

#define HOOK_DELTREE(X) (pEo->pHookers->HOOK_deltree(pEo,(X)))
  int (*HOOK_deltree)(pExecuteObject, char *);

#define HOOK_MAKEDIRECTORY(X) (pEo->pHookers->HOOK_MakeDirectory(pEo,(X)))
  int (*HOOK_MakeDirectory)(pExecuteObject, char *);

#define HOOK_OPENDIR(X,Y) (pEo->pHookers->HOOK_opendir(pEo,(X),(Y)))
  DIR *(*HOOK_opendir)(pExecuteObject, char *, tDIR *);

#define HOOK_READDIR(X) (pEo->pHookers->HOOK_readdir(pEo,(X)))
  struct dirent *(*HOOK_readdir)(pExecuteObject, DIR *);

#define HOOK_CLOSEDIR(X) (pEo->pHookers->HOOK_closedir(pEo,(X)))
  void (*HOOK_closedir)(pExecuteObject, DIR *);

#define HOOK_SLEEP(X) (pEo->pHookers->HOOK_sleep(pEo,(X)))
  void (*HOOK_sleep)(pExecuteObject, long);

#define HOOK_CURDIR(X,Y) (pEo->pHookers->HOOK_curdir(pEo,(X),(Y)))
  int (*HOOK_curdir)(pExecuteObject, char *, unsigned long);

#define HOOK_CHDIR(X) (pEo->pHookers->HOOK_chdir(pEo,(X)))
  int (*HOOK_chdir)(pExecuteObject, char *);

#define HOOK_CHOWN(X,Y) (pEo->pHookers->HOOK_chown(pEo,(X),(Y)))
  int (*HOOK_chown)(pExecuteObject, char *, char *);

#define HOOK_SETCREATETIME(X,Y) (pEo->pHookers->HOOK_SetCreateTime(pEo,(X),(Y)))
  int (*HOOK_SetCreateTime)(pExecuteObject, char *, long);

#define HOOK_SETMODIFYTIME(X,Y) (pEo->pHookers->HOOK_SetModifyTime(pEo,(X),(Y)))
  int (*HOOK_SetModifyTime)(pExecuteObject, char *, long);

#define HOOK_SETACCESSTIME(X,Y) (pEo->pHookers->HOOK_SetAccessTime(pEo,(X),(Y)))
  int (*HOOK_SetAccessTime)(pExecuteObject, char *, long);

  int (*HOOK_ExecBefore)(pExecuteObject);
  int (*HOOK_ExecAfter)(pExecuteObject);
  int (*HOOK_ExecCall)(pExecuteObject);
  int (*HOOK_ExecReturn)(pExecuteObject);

#define HOOK_GETHOSTNAME(X,Y) (pEo->pHookers->HOOK_gethostname(pEo,(X),(Y)))
  int (*HOOK_gethostname)(pExecuteObject, char *, long);
#define HOOK_GETHOST(X,Y) (pEo->pHookers->HOOK_gethost(pEo,(X),(Y)))
  int (*HOOK_gethost)(pExecuteObject, char *, struct hostent *);
#define HOOK_TCPCONNECT(X,Y) (pEo->pHookers->HOOK_tcpconnect(pEo,(X),(Y)))
  int (*HOOK_tcpconnect)(pExecuteObject, SOCKET *, char *);
#define HOOK_TCPSEND(X,Y,Z,W) (pEo->pHookers->HOOK_tcpsend(pEo,(X),(Y),(Z),(W)))
  int (*HOOK_tcpsend)(pExecuteObject, SOCKET, char *, long, int);
#define HOOK_TCPRECV(X,Y,Z,W) (pEo->pHookers->HOOK_tcprecv(pEo,(X),(Y),(Z),(W)))
  int (*HOOK_tcprecv)(pExecuteObject, SOCKET, char *, long, int);
#define HOOK_TCPCLOSE(X) (pEo->pHookers->HOOK_tcpclose(pEo,(X)))
  int (*HOOK_tcpclose)(pExecuteObject, SOCKET);

  int (*HOOK_killproc)(pExecuteObject, long);
#define HOOK_KILLPROC(X) (pEo->pHookers->HOOK_killproc(pEo,(X)))
  int (*HOOK_getowner)(pExecuteObject, char *, char *, long);
#define HOOK_GETOWNER(X,Y,Z) (pEo->pHookers->HOOK_getowner(pEo,(X),(Y),(Z)))
  char *(*HOOK_fcrypt)(pExecuteObject, char *, char *, char *);
#define HOOK_FCRYPT(X,Y,Z) (pEo->pHookers->HOOK_fcrypt(pEo,(X),(Y),(Z)))
  long (*HOOK_CreateProcess)(pExecuteObject, char *);
#define HOOK_CREATEPROCESS(X) (pEo->pHookers->HOOK_CreateProcess(pEo,(X)))

  int (*HOOK_CallScribaFunction)(pExecuteObject,
                                 unsigned long,
                                 pFixSizeMemoryObject *,
                                 unsigned long,
                                 pFixSizeMemoryObject *);
#define HOOK_CALLSCRIBAFUNCTION(X,Y,Z,W) (pEo->pHookers->HOOK_CallScribaFunction(pEo,(X),(Y),(Z),(W)))

  long (*HOOK_CreateProcessEx)(pExecuteObject,
                              char *,
                              long,
                              unsigned long *,
                              unsigned long *);
#define HOOK_CREATEPROCESSEX(P,TO,PID,EXIT) (pEo->pHookers->HOOK_CreateProcessEx(pEo,(P),(TO),(PID),(EXIT)))

  int (*HOOK_waitpid)(pExecuteObject, long, unsigned long *);
#define HOOK_WAITPID(X,Y) (pEo->pHookers->HOOK_waitpid(pEo,(X),(Y)))
  } HookFunctions




typedef struct _VersionInfo {
  unsigned long MagicCode;
  unsigned long VersionHigh, VersionLow;
  unsigned long MyVersionHigh,MyVersionLow;
  unsigned long Build;
  unsigned long Date;
  unsigned char Variation[9];
  } VersionInfo,*pVersionInfo;



'EXECUTE OBJECT
'==============


typedef struct _ExecuteObject
{
  void *(*memory_allocating_function)(size_t);
  void (*memory_releasing_function)(void *);
  void *pMemorySegment; 
  pReportFunction report;
  void *reportptr; 
  unsigned long fErrorFlags;
  ptConfigTree pConfig; 
  char *StringTable; 
  unsigned long cbStringTable; 
  pcNODE CommandArray;
  unsigned long StartNode;
  unsigned long CommandArraySize;
  long cGlobalVariables;
  pFixSizeMemoryObject GlobalVariables;
  long cLocalVariables;
  pFixSizeMemoryObject LocalVariables; 
  unsigned long ProgramCounter;
  unsigned long NextProgramCounter;
  int fNextPC; 
     #define fStopRETURN 1
     #define fStopSTOP   2
  int fStop;
  unsigned long lStepCounter;  
  unsigned long lGlobalStepCounter; 
  long lFunctionLevel;        
  long GlobalStepLimit;       
  long LocalStepLimit;        
  long FunctionLevelLimit;    
  int fWeAreCallingFuction; 
  unsigned long ErrorCode;
  int fErrorGoto; 
    #define ONERROR_NOTHING    0
    #define ONERROR_GOTO       1
    #define ONERROR_RESUME     2
    #define ONERROR_RESUMENEXT 3
  unsigned long ErrorGoto;   
  unsigned long ErrorResume; 
  unsigned long LastError;   
  unsigned long OperatorNode;     
  pFixSizeMemoryObject pOpResult; 
  pFixSizeMemoryObject pFunctionResult; 
  pMortalList pGlobalMortalList;   
  unsigned long FunctionArgumentsNode; 
  pMemoryObject pMo;
  CommandFunctionType *pCommandFunction;
  void *CommandParameter[NUM_CMD]; 
  void(*Finaliser)(struct _ExecuteObject*); //itr void (*(Finaliser[NUM_CMD]))(struct _ExecuteObject*);
  void **InstructionParameter;     
  VersionInfo Ver;
  void *fpStdinFunction;  
  void *fpStdouFunction;  
  void *fpEnvirFunction;  
  char *CmdLineArgument;  
  SymbolTable OptionsTable; 
  void *pEmbedder; 
  pSupportTable pST; 
  pSupportTable pSTI;
  MUTEX mxModules;   
  pModule modules;   
  struct _ExecuteObject *pEPo;
  char *pszModuleError; 
  pHookFunctions pHookers; 
  LexNASymbol *pCSYMBOLS; 
  int fThreadedCommandTable; 
  char **CSymbolList;
}ExecuteObject,*pExecuteObject





'SUPPORT TABLE
'=============


typedef struct _SupportTable {

  pExecuteObject pEo; 

     #define besPROCALLOC(X) (pSt->pEo->pSTI->Alloc((X),besPROCMEMORYSEGMENT))

  void * (*Alloc)(size_t n, void *p);

     #define besALLOC(X) (pSt->Alloc((X),pSt->pEo->pMemorySegment))

  void   (*Free)(void *pMem, void *p);

     #define besFREE(X) (pSt->Free((X),pSt->pEo->pMemorySegment),(X)=NULL)
     #define besPROCFREE(X) (pSt->pEo->pSTI->Free((X),besPROCMEMORYSEGMENT),(X)=NULL)
     #define besPROCMEMORYSEGMENT (pSt->pEo->pSTI->pEo->pMemorySegment)
  
  pFixSizeMemoryObject (*NewMortalString)(pMemoryObject pMo, unsigned long StringSize, pMortalList pMortal);
  pFixSizeMemoryObject (*NewMortalLong)(pMemoryObject pMo, pMortalList pMortal);
  pFixSizeMemoryObject (*NewMortalRef)(pMemoryObject pMo, pMortalList pMortal);
  pFixSizeMemoryObject (*NewMortalDouble)(pMemoryObject pMo, pMortalList pMortal);
  pFixSizeMemoryObject (*NewMortalArray)(pMemoryObject pMo, pMortalList pMortal, long IndexLow, long IndexHigh);

     #define besNEWMORTALSTRING(X)  (pSt->NewMortalString(pSt->pEo->pMo,(X),pSt->pEo->pGlobalMortalList))
     #define besNEWMORTALLONG       (pSt->NewMortalLong(pSt->pEo->pMo,pSt->pEo->pGlobalMortalList))
     #define besNEWMORTALREF        (pSt->NewMortalRef(pSt->pEo->pMo,pSt->pEo->pGlobalMortalList))
     #define besNEWMORTALDOUBLE     (pSt->NewMortalDouble(pSt->pEo->pMo,pSt->pEo->pGlobalMortalList))
     #define besNEWMORTALARRAY(X,Y) (pSt->NewMortalArray(pSt->pEo->pMo,pSt->pEo->pGlobalMortalList,(X),(Y)))

  pFixSizeMemoryObject (*NewString)(pMemoryObject pMo, unsigned long StringSize);
  pFixSizeMemoryObject (*NewLong)(pMemoryObject pMo);
  pFixSizeMemoryObject (*NewRef)(pMemoryObject pMo);
  pFixSizeMemoryObject (*NewDouble)(pMemoryObject pMo);
  pFixSizeMemoryObject (*NewArray)(pMemoryObject pMo, long LowIndex, long HighIndex);

     #define besNEWSTRING(X)  (pSt->NewString(pSt->pEo->pMo,(X)))
     #define besNEWLONG       (pSt->NewLong(pSt->pEo->pMo))
     #define besNEWREF        (pSt->NewRef(pSt->pEo->pMo))
     #define besNEWDOUBLE     (pSt->NewDouble(pSt->pEo->pMo))
     #define besNEWARRAY(X,Y) (pSt->NewArray(pSt->pEo->pMo,(X),(Y)))

  int (*ReleaseVariable)(pMemoryObject, pFixSizeMemoryObject);

     #define besRELEASE(X)    (pSt->ReleaseVariable(pSt->pEo->pMo,(X)))

  int (*SetRef)(pMemoryObject,pFixSizeMemoryObject *,pFixSizeMemoryObject *);

     #define besSETREF(X,Y) (pSt->SetRef(St->pEo->pMo,(X),(Y))

  char * (*ConfigData)(ptConfigTree p, char *s);

     #define besCONFIG(X) (pSt->ConfigData(pSt->pEo->pConfig,(X)))

  CFT_NODE (*FindNode)(ptConfigTree, CFT_NODE, char *);

     #define besCONFIGFINDNODE(X,Y,Z) (pSt->FindNode((X),(Y),(Z)))

  int (*GetEx)(ptConfigTree, char *, CFT_NODE *, char **, long *, double *, int *);

     #define besCONFIGEX(CT,CS,NS,CSS,LS,DS,IS) (pSt->GetEx((CT),(CS),(NS),(CSS),(LS),(DS),(IS)))

  CFT_NODE (*EnumFirst)(ptConfigTree, CFT_NODE);

     #define besCONFIGENUMFIRST(X,Y) (pSt->EnumFirst((X),(Y)))

  CFT_NODE (*EnumNext)(ptConfigTree, CFT_NODE);

     #define besCONFIGENUMNEXT(X,Y) (pSt->EnumNext((X),(Y)))

  char * (*GetKey)(ptConfigTree, CFT_NODE );

     #define besCONFIGGETKEY(X,Y) (pSt->GetKey((X),(Y)))

  SymbolTable (*NewSymbolTable)(void* (*memory_allocating_function)(size_t,void *),
                                void *pMemorySegment);

  void (*FreeSymbolTable)(SymbolTable table,
                          void (*memory_releasing_function)(void *,void *),
                          void *pMemorySegment);
  void (*TraverseSymbolTable)(SymbolTable table,
                              void (*call_back_function)(char *SymbolName, void *SymbolValue, void *f),
                              void *f);

  void **(*LookupSymbol)(char *s,
                         SymbolTable hashtable,
                         int insert,
                         void* (*memory_allocating_function)(size_t, void *),
                         void (*memory_releasing_function)(void *, void *),
                         void *pMemorySegment);

  int (*DeleteSymbol)(char *s,
                      SymbolTable hashtable,
                      void (*memory_releasing_function)(void *, void *),
                      void *pMemorySegment);

     #define besNEWSYMBOLTABLE() \
     (pSt->NewSymbolTable(pSt->Alloc,pSt->pEo->pMemorySegment))

     #define besFREESYMBOLTABLE(X) \
     (pSt->FreeSymbolTable((X),pSt->Free,pSt->pEo->pMemorySegment))

     #define besTRAVERSESYMBOLTABLE(X,Y,Z) \
     (pSt->TraverseSymbolTable((X),(Y),(Z)))

     #define besLOOKUPSYMBOL(X,Y,Z) \
     (pSt->LookupSymbol((X),(Y),(Z),pSt->Alloc,\
                                 pSt->Free,\
                                 pSt->pEo->pMemorySegment))

     #define besDeleteSymbol(X,Y) \
     (pSt->DeleteSymbol((X),(Y),pSt->Free,pSt->pEo->pMemorySegment))


  void *(*LoadLibrary)(char *s); 
  void (*FreeLibrary)(void *);     
  void *(*GetFunctionByName)(void *pLibrary,char *pszFunctionName);

     #define besLOADLIBRARY(X) (pSt->LoadLibrary( (X) ))

     #define besFREELIBRARY(X) (pSt->FreeLibrary( (X) ))

     #define besGETFUNCTIONBYNAME(LIB,FUN) (pSt->GetFunctionByName((LIB),(FUN)))

  FILE *(*fopen)(char *pszFileName,char *pszOpenMode);
  void (*fclose)(FILE *fp);
  long (*size)(char *pszFileName);
  long (*time_accessed)(char *pszFileName);
  long (*time_modified)(char *pszFileName);
  long (*time_created)(char *pszFileName);
  int (*isdir)(char *pszFileName);
  int (*isreg)(char *pszFileName);
  int (*exists)(char *pszFileName);
  int (*truncate)(FILE *,long lNewFileSize);
  int (*fgetc)(FILE *);
  int (*fread)(char *, int, int, FILE *);
  int (*fwrite)(char *, int, int, FILE *);
  void (*setmode)(FILE *, int);
  void (*binmode)(FILE *);
  void (*textmode)(FILE *);
  int (*ferror)(FILE *);
  int (*fputc)(int c, FILE*fp);
  int (*flock)(FILE *fp,int iLockType);
  int (*lock)(FILE *fp,int iLockType,long lStart,long lLength);
  int (*feof)(FILE *fp);
  int (*mkdir)(char *pszDirectoryName);
  int (*rmdir)(char *pszDirectoryName);
  int (*remove)(char *pszFileName);
  int (*deltree)(char *pszDirectoryName);
  int (*MakeDirectory)(char *pszDirectoryName);
  DIR *(*opendir)(char *pszDirectoryName,tDIR *pDirectory);
  struct dirent *(*readdir)(DIR *pDirectory);
  void (*closedir)(DIR *pDirectory);

     #define besFOPEN(FN,OM)       (pSt->fopen( (FN),(OM) ))
     #define besFCLOSE(FP)         (pSt->fclose( (FP) ))
     #define besSIZE(FN)           (pSt->size( (FN) ))
     #define besTIME_ACCESSED(FN)  (pSt->time_accessed( (FN) ))
     #define besTIME_MODIFIED(FN)  (pSt->time_modified( (FN) ))
     #define besTIME_CREATED(FN)   (pSt->time_created( (FN) ))
     #define besISDIR(FN)          (pSt->isdir( (FN) ))
     #define besISREG(FN)          (pSt->isreg( (FN) ))
     #define besEXISTS(FN)         (pSt->exists( (FN) ))
     #define besTRUNCATE(FN,NS)    (pSt->truncate( (FN),(NS) ))
     #define besFGETC(FP)          (pSt->fgetc( (FP) ))
     #define besFREAD(S,X,Y,FP)    (pSt->fread( (S),(X),(Y),(FP) ))
     #define besFWRITE(S,X,Y,FP)   (pSt->fwrite( (S),(X),(Y),(FP) ))
     #define besSETMODE(FP,M)      (pSt->setmode( (FP),(M) ))
     #define besBINMODE(FP)        (pSt->binmode( (FP) ))
     #define besTEXTMODE(FP)       (pSt->textmode( (FP) ))
     #define besFERROR(FP)         (pSt->ferror( (FP) ))
     #define besFPUTC(C,FP)        (pSt->fputc( (C),(FP) ))
     #define besFLOCK(FP)          (pSt->flock( (FP) ))
     #define besLOCK(FP,LT,LS,LE)  (pSt->lock( (FP),(LT),(LS),(LE) ))
     #define besFEOF(FP)           (pSt->feof( (FP) ))
     #define besMKDIR(DN)          (pSt->mkdir( (DN) ))
     #define besRMDIR(DN)          (pSt->rmdir( (DN) ))
     #define besREMOVE(FN)         (pSt->remove( (FN) ))
     #define besDELTREE(DN)        (pSt->deltree( (DN) ))
     #define besMAKEDIRECTORY(DN)  (pSt->MakeDirectory( (DN) ))
     #define besOPENDIR(DN,DP)     (pSt->opendir( (DN),(DP) ))
     #define besREADDIR(DP)        (pSt->readdir( (DP) ))
     #define besCLOSEDIR(DP)       (pSt->closedir( (DP) ))

  long (*GetOption)(pExecuteObject,char*);
  int (*SetOption)(pExecuteObject,char *,long);
  int (*ResetOption)(pExecuteObject,char *);

     #define besOPTION(x)          (pSt->GetOption(pSt->pEo,(x)))
     #define besSETOPTION(x,y)     (pSt->SetOption(pSt->pEo,(x),(y)))
     #define besRESETOPTION(x)     (pSt->ResetOption(pSt->pEo,(x)))

  pFixSizeMemoryObject (*Convert2String)(pExecuteObject, pFixSizeMemoryObject, pMortalList);
  pFixSizeMemoryObject (*Convert2Long)(pExecuteObject, pFixSizeMemoryObject, pMortalList);
  pFixSizeMemoryObject (*Convert2Double)(pExecuteObject, pFixSizeMemoryObject, pMortalList);

  int                  (*IsStringInteger)(pFixSizeMemoryObject);
  double               (*GetDoubleValue)(pExecuteObject, pFixSizeMemoryObject);
  long                 (*GetLongValue)  (pExecuteObject, pFixSizeMemoryObject);

     #define besCONVERT2STRING(x)  (pSt->Convert2String(pSt->pEo,(x),pSt->pEo->pGlobalMortalList))
     #define besCONVERT2LONG(x)    (pSt->Convert2Long(pSt->pEo,(x),pSt->pEo->pGlobalMortalList))
     #define besGETLONGVALUE(x)    (pSt->GetLongValue(pSt->pEo,(x)))
     #define besCONVERT2DOUBLE(x)  (pSt->Convert2Double(pSt->pEo,(x),pSt->pEo->pGlobalMortalList))
     #define besGETDOUBLEVALUE(x)    (pSt->GetDoubleValue(pSt->pEo,(x)))
     #define besISSTRINGINTEGER(x) (pSt->IsStringInteger(x))
/*
     #define besCONVERT2ZCHAR(x,y)   (y) = besALLOC(STRLEN( (x) )+1);\
                                if( (y) == NULL )return COMMAND_ERROR_MEMORY_LOW;\
                                memcpy((y),STRINGVALUE( (x) ),STRLEN( (x) ));\
                                (y)[STRLEN( (x) )] = (char)0;
*/
  int (*InitModuleInterface)(pExecuteObject, int);
  int (*LoadModule)(pExecuteObject, char *, pModule **);
  int (*GetModuleFunctionByName)(pExecuteObject, char *, char *, void **, pModule **);
  int (*UnloadAllModules)(pExecuteObject);
  int (*UnloadModule)(pExecuteObject, char *);

     #define besREINITINTERFACE (pSt->InitModuleInterface(pSt->pEo,1)
     #define besLOADMODULE(x,y) (pSt->LoadModule(pSt->pEo,(x),(y))
     #define besGETMODULEFUNCTIONBYNAME(x,y,z,w) (pSt->GetModuleFunctionByName(pSt->pEo,(x),(y),(z),(w))
     #define besUNLOADALLMODULES (pSt->UnloadAllModules(pSt->pEo))
     #define besUNLOADMODULE(x) (pSt->UnloadModule(pSt->pEo,(x))

  void (*sleep)(long);
  int  (*curdir)(char *, unsigned long);
  int  (*chdir)(char *);
  int  (*chown)(char *, char *);
  int  (*SetCreateTime)(char *, long);
  int  (*SetModifyTime)(char *, long);
  int  (*SetAccessTime)(char *, long);

     #define besSLEEP(x)           (pSt->sleep(x))
     #define besCURDIR(x,y)        (pSt->curdir((x),(y)))
     #define besCHDIR(x)           (pSt->chdir(x))
     #define besCHOWN(x,y)         (pSt->chown((x),(y)))
     #define besSETCREATETIME(x,y) (pSt->SetCreateTime((x),(y)))
     #define besSETMODIFYTIME(x,y) (pSt->SetModifyTime((x),(y)))
     #define besSETACCESSTIME(x,y) (pSt->SetAccessTime((x),(y)))

  int (*GetHostName)(char *, long);
  int (*GetHost)(char *, struct hostent *);
  int (*TcpConnect)(SOCKET *, char *);
  int (*TcpSend)(SOCKET, char *, long, int);
  int (*TcpRecv)(SOCKET, char *, long, int);
  int (*TcpClose)(SOCKET);

     #define besGETHOSTNAME(X,Y) (pSt->GetHostName((X),(Y)))
     #define besGETHOST(X,Y) (pSt->GetHost((X),((Y)))
     #define besTCPCONNECT(X,Y) (pSt->TcpConnect((X),(Y)))
     #define besTCPSEND(X,Y,Z) (pSt->TcpSend((X),(Y),(Z)))
     #define besTCPRECV(X,Y,Z) (pSt->TcpRecv((X),(Y),(Z)))
     #define besTCPCLOSE(Y) (pSt->TcpClose((X))

  int (*KillProc)(long);

     #define besKILLPROC(X) (pSt->KillProc((X))

  int (*GetOwner)(char *, char *, long);

     #define besGETOWNER(X,Y,Z) (pSt->GetOwner((X),(Y),(Z));

  char *(*Crypt)(char *, char *, char *);

     #define besCRYPT(X,Y,Z) (pSt->Crypt((X),(Y),(Z)))

  void (*MD5Init)(MD5_CTX *context);

     #define besMD5INIT(C) (pSt->MD5Init((C)))

  void (*MD5Update)(MD5_CTX *context, unsigned char *input, unsigned int inputLen);

     #define besMD5UPDATE(C,I,L) (pSt->MD5Update((C),(I),(L)))

  void (*MD5Final)(unsigned char digest[16], MD5_CTX *context);

     #define besMD5FINAL(D,C) (pSt->MD5Final((D),(C)))

  long (*CreateProcess)(char *);

     #define besCREATEPROCESS(X) (pSt->CreateProcess(X))

  int (*CopyCommandTable)(pExecuteObject);

     #define besCOPYCOMMANDTABLE (pSt->CopyCommandTable(pSt->pEo))

  long (*GetCommandByName)(pExecuteObject, char *, long);

     #define besGETCOMMANDBYNAME(X,Y) (pSt->GetCommandByName(pSt->pEo,(X),(Y)))

  pFixSizeMemoryObject (*DupMortalize)(pMemoryObject,pFixSizeMemoryObject,pMortalList,int *);
  pFixSizeMemoryObject (*Evaluate)(pExecuteObject,unsigned long,pMortalList,int *,int);
  pFixSizeMemoryObject *(*LeftValue)(pExecuteObject,unsigned long,pMortalList,int *,int);
  void (*Immortalize)(pFixSizeMemoryObject,pMortalList);
  void (*ReleaseMortals)(pMemoryObject,pMortalList pMortal);

     #define besEVALUATEEXPRESSION(x) (pSt->DupMortalize(pEo->pMo,\
                                            pSt->Evaluate(pEo,x,_pThisCommandMortals,&iErrorCode,0),\
                                            _pThisCommandMortals,\
                                            &iErrorCode))

     #define _besEVALUATEEXPRESSION(x) (pSt->Evaluate(pEo,x,_pThisCommandMortals,&iErrorCode,0))
     #define _besEVALUATEEXPRESSION_A(x) (pSt->Evaluate(pEo,x,_pThisCommandMortals,&iErrorCode,1))
     #define besEVALUATELEFTVALUE(x) (pSt->LeftValue(pEo,x,_pThisCommandMortals,&iErrorCode,0))
     #define besEVALUATELEFTVALUE_A(x) (pSt->LeftValue(pEo,x,_pThisCommandMortals,&iErrorCode,1))
     #define besIMMORTALIZE(x) (pSt->Immortalize(x,_pThisCommandMortals))

  int (*Dereference)(unsigned long, pFixSizeMemoryObject *);

     #define besDEREFERENCE(X) if( pSt->Dereference(pSt->pEo->pMo->maxderef,&(X)) )\
                            return COMMAND_ERROR_CIRCULAR;

  unsigned long (*match_index)(char ch);

     #define besMatchIndex(X) (pSt->match_index(X))

  void (*match_InitSets)(pMatchSets pMS);

     #define besMatchIniSets(X) (pSt->matchInitSets(X))

  void (*match_ModifySet)(pMatchSets pMS,
                          char JokerCharacter,
                          int nChars,
                          unsigned char *pch,
                          int fAction);
     #define besMatchModifySet(X,Y,Z,W,Q) (pSt->match_ModifySet((X),(Y),(Z),(W),(Q)))

  int (*match_match)(char *pszPattern,
                     unsigned long cbPattern,
                     char *pszString,
                     unsigned long cbString,
                     char **ParameterArray,
                     unsigned long *pcbParameterArray,
                     char *pszBuffer,
                     int cArraySize,
                     int cbBufferSize,
                     int fCase,
                     pMatchSets pThisMatchSets,
                     int *iResult);

     #define besMatchMatch(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10,P11,P12)\
     (pSt->match_match((P1),(P2),(P3),(P4),(P5),(P6),(P7),(P8),(P9),(P10),(P11),(P12)))

  int (*match_count)(char *pszPattern,unsigned long cbPattern);

     #define besMatchCount(X,Y) (pSt->match_count((X),(Y)))

  int (*match_parameter)(char *pszFormat,
                         unsigned long cbFormat,
                         char **ParameterArray,
                         unsigned long *pcbParameterArray,
                         char *pszBuffer,
                         int cArraySize,
                         unsigned long *pcbBufferSize);

     #define besMatchParameter(P1,P2,P3,P4,P5,P6,P7)\
     (pSt->match_parameter((P1),(P2),(P3),(P4),(P5),(P6),(P7)))

  int (*match_size)(char *pszFormat,
                    unsigned long cbFormat,
                    unsigned long *pcbParameterArray,
                    int cArraySize,
                    int *cbBufferSize);

     #define besMatchSize(P1,P2,P3,P4,P5)\
     (pSt->match_size((P1),(P2),(P3),(P4),(P5)))


  int (*thread_CreateThread)(PTHREADHANDLE pThread,
                      void *pStartFunction,
                      void *pThreadParameter);

     #define besCreateThread(X,Y,Z) (pSt->thread_CreateThread((X),(Y),(Z)))

  void (*thread_ExitThread)();

     #define besExitThread() (pSt->thread_ExitThread())

  void (*thread_InitMutex)(PMUTEX pMutex);

     #define besInitMutex(X) (pSt->thread_InitMutex(X))

  void (*thread_FinishMutex)(PMUTEX pMutex);

     #define besFinishMutex(X) (pSt->thread_FinishMutex(X))

  void (*thread_LockMutex)(PMUTEX pMutex);

     #define besLockMutex(X) (pSt->thread_LockMutex(X))

  void (*thread_UnlockMutex)(PMUTEX pMutex);

     #define besUnlockMutex(X) (pSt->thread_UnlockMutex(X))

  void (*shared_InitLock)(PSHAREDLOCK p);

     #define besInitSharedLock(X) (pSt->shared_InitLock(X))

  void (*shared_FinishLock)(PSHAREDLOCK p);

     #define besFinishSharedLock(X) (pSt->shared_FinishLock(X))

  void (*shared_LockRead)(PSHAREDLOCK p);

     #define besLockSharedRead(X) (pSt->shared_LockRead(X))

  void (*shared_LockWrite)(PSHAREDLOCK p);

     #define besLockSharedWrite(X) (pSt->shared_LockWrite(X))

  void (*shared_UnlockRead)(PSHAREDLOCK p);

     #define besUnlockSharedRead(X) (pSt->shared_UnlockRead(X))

  void (*shared_UnlockWrite)(PSHAREDLOCK p);

     #define besUnlockSharedWrite(X) (pSt->shared_UnlockWrite(X))

  pSbProgram (*scriba_new)(void * (*maf)(size_t), void (*mrf)(void *));

     #define besScribaNew(F0,F1) (pSt->scriba_New((F0),(F1)))

  void (*scriba_destroy)(pSbProgram pProgram);

     #define besScribaDestroy(F0) (pSt->scriba_Destroy((F0)))

  pSbData (*scriba_NewSbData)(pSbProgram pProgram);

     #define besScribaNewSbData(F0) (pSt->scriba_NewSbData((F0)))

  pSbData (*scriba_NewSbLong)(pSbProgram pProgram, long lInitValue);

     #define besScribaNewSbLong(F0,F1) (pSt->scriba_NewSbLong((F0),(F1)))

  pSbData (*scriba_NewSbDouble)(pSbProgram pProgram, double dInitValue);

     #define besScribaNewSbDouble(F0,F1) (pSt->scriba_NewSbDouble((F0),(F1)))

  pSbData (*scriba_NewSbUndef)(pSbProgram pProgram);

     #define besScribaNewSbUndef(F0) (pSt->scriba_NewSbUndef((F0)))

  pSbData (*scriba_NewSbString)(pSbProgram pProgram, char *pszInitValue);

     #define besScribaNewSbString(F0,F1) (pSt->scriba_NewSbString((F0),(F1)))

  pSbData (*scriba_NewSbBytes)(pSbProgram pProgram, unsigned long len, unsigned char *pszInitValue);

     #define besScribaNewSbBytes(F0,F1,F2) (pSt->scriba_NewSbBytes((F0),(F1),(F2)))

  void (*scriba_DestroySbData)(pSbProgram pProgram, pSbData p);

     #define besScribaDestroySbData(F0,F1) (pSt->scriba_DestroySbData((F0),(F1)))

  void (*scriba_PurgeReaderMemory)(pSbProgram pProgram);

     #define besScribaPurgeReaderMemory(F0) (pSt->scriba_PurgeReaderMemory((F0)))

  void (*scriba_PurgeLexerMemory)(pSbProgram pProgram);

     #define besScribaPurgeLexerMemory(F0) (pSt->scriba_PurgeLexerMemory((F0)))

  void (*scriba_PurgeSyntaxerMemory)(pSbProgram pProgram);

     #define besScribaPurgeSyntaxerMemory(F0) (pSt->scriba_PurgeSyntaxerMemory((F0)))

  void (*scriba_PurgeBuilderMemory)(pSbProgram pProgram);

     #define besScribaPurgeBuilderMemory(F0) (pSt->scriba_PurgeBuilderMemory((F0)))

  void (*scriba_PurgeExecuteMemory)(pSbProgram pProgram);

     #define besScribaPurgeExecuteMemory(F0) (pSt->scriba_PurgeExecuteMemory((F0)))

  int (*scriba_SetFileName)(pSbProgram pProgram, char *pszFileName);

     #define besScribaSetFileName(F0,F1) (pSt->scriba_SetFileName((F0),(F1)))

  int (*scriba_LoadConfiguration)(pSbProgram pProgram, char *pszForcedConfigurationFileName);

     #define besScribaLoadConfiguration(F0,F1) (pSt->scriba_LoadConfiguration((F0),(F1)))

  int (*scriba_InheritConfiguration)(pSbProgram pProgram, pSbProgram pFrom);

     #define besScribaInheritConfiguration(F0,F1) (pSt->scriba_InheritConfiguration((F0),(F1)))

  void (*scriba_SetCgiFlag)(pSbProgram pProgram);

     #define besScribaSetCgiFlag(F0) (pSt->scriba_SetCgiFlag((F0)))

  void (*scriba_SetReportFunction)(pSbProgram pProgram, void *fpReportFunction);

     #define besScribaSetReportFunction(F0,F1) (pSt->scriba_SetReportFunction((F0),(F1)))

  void (*scriba_SetReportPointer)(pSbProgram pProgram, void *pReportPointer);

     #define besScribaSetReportPointer(F0,F1) (pSt->scriba_SetReportPointer((F0),(F1)))

  void (*scriba_SetStdin)(pSbProgram pProgram, void *fpStdinFunction);

     #define besScribaSetStdin(F0,F1) (pSt->scriba_SetStdin((F0),(F1)))

  void (*scriba_SetStdout)(pSbProgram pProgram, void *fpStdoutFunction);

     #define besScribaSetStdout(F0,F1) (pSt->scriba_SetStdout((F0),(F1)))

  void (*scriba_SetEmbedPointer)(pSbProgram pProgram, void *pEmbedder);

     #define besScribaSetEmbedPointer(F0,F1) (pSt->scriba_SetEmbedPointer((F0),(F1)))

  void (*scriba_SetEnvironment)(pSbProgram pProgram, void *fpEnvirFunction);

     #define besScribaSetEnvironment(F0,F1) (pSt->scriba_SetEnvironment((F0),(F1)))
'ok
  int (*scriba_LoadBinaryProgram)(pSbProgram pProgram);

     #define besScribaLoadBinaryProgram(F0) (pSt->scriba_LoadBinaryProgram((F0)))

  int (*scriba_InheritBinaryProgram)(pSbProgram pProgram, pSbProgram pFrom);

     #define besScribaInheritBinaryProgram(F0,F1) (pSt->scriba_InheritBinaryProgram((F0),(F1)))

  int (*scriba_ReadSource)(pSbProgram pProgram);

     #define besScribaReadSource(F0) (pSt->scriba_ReadSource((F0)))

  int (*scriba_DoLexicalAnalysis)(pSbProgram pProgram);

     #define besScribaDoLexicalAnalysis(F0) (pSt->scriba_DoLexicalAnalysis((F0)))

  int (*scriba_DoSyntaxAnalysis)(pSbProgram pProgram);

     #define besScribaDoSyntaxAnalysis(F0) (pSt->scriba_DoSyntaxAnalysis((F0)))

  int (*scriba_BuildCode)(pSbProgram pProgram);

     #define besScribaBuildCode(F0) (pSt->scriba_BuildCode((F0)))

  int (*scriba_IsFileBinaryFormat)(pSbProgram pProgram);

     #define besScribaIsFileBinaryFormat(F0) (pSt->scriba_IsFileBinaryFormat((F0)))

  int (*scriba_GetCacheFileName)(pSbProgram pProgram);

     #define besScribaGetCacheFileName(F0) (pSt->scriba_GetCacheFileName((F0)))

  int (*scriba_UseCacheFile)(pSbProgram pProgram);

     #define besScribaUseCacheFile(F0) (pSt->scriba_UseCacheFile((F0)))

  int (*scriba_SaveCacheFile)(pSbProgram pProgram);

     #define besScribaSaveCacheFile(F0) (pSt->scriba_SaveCacheFile((F0)))

  int (*scriba_RunExternalPreprocessor)(pSbProgram pProgram, char **ppszArgPreprocessor);

     #define besScribaRunExternalPreprocessor(F0,F1) (pSt->scriba_RunExternalPreprocessor((F0),(F1)))

  int (*scriba_SaveCode)(pSbProgram pProgram, char *pszCodeFileName);

     #define besScribaSaveCode(F0,F1) (pSt->scriba_SaveCode((F0),(F1)))

  void (*scriba_SaveCCode)(pSbProgram pProgram, char *pszCodeFileName);

     #define besScribaSaveCCode(F0,F1) (pSt->scriba_SaveCCode((F0),(F1)))

  int (*scriba_LoadSourceProgram)(pSbProgram pProgram);

     #define besScribaLoadSourceProgram(F0) (pSt->scriba_LoadSourceProgram((F0)))

  int (*scriba_Run)(pSbProgram pProgram, char *pszCommandLineArgument);

     #define besScribaRun(F0,F1) (pSt->scriba_Run((F0),(F1)))

  int (*scriba_NoRun)(pSbProgram pProgram);

     #define besScribaNoRun(F0) (pSt->scriba_NoRun((F0)))

  void (*scriba_ResetVariables)(pSbProgram pProgram);

     #define besScribaResetVariables(F0) (pSt->scriba_ResetVariables((F0)))

  int (*scriba_Call)(pSbProgram pProgram, unsigned long lEntryNode);

     #define besScribaCall(F0,F1) (pSt->scriba_Call((F0),(F1)))

  int (*scriba_CallArg)(pSbProgram pProgram, unsigned long lEntryNode, char *pszFormat, ...);

     #define besScribaCallArg(F0,F1,F2,F3) (pSt->scriba_CallArg((F0),(F1),(F2),(F3)))

  void (*scriba_DestroySbArgs)(pSbProgram pProgram, pSbData Args, unsigned long cArgs);

     #define besScribaDestroySbArgs(F0,F1,F2) (pSt->scriba_DestroySbArgs((F0),(F1),(F2)))

  pSbData (*scriba_NewSbArgs)(pSbProgram pProgram, char *pszFormat, ...);

     #define besScribaNewSbArgs(F0,F1,F2) (pSt->scriba_NewSbArgs((F0),(F1),(F2)))

  int (*scriba_CallArgEx)(pSbProgram pProgram, unsigned long lEntryNode, pSbData ReturnValue, unsigned long cArgs, pSbData Args);

     #define besScribaCallArgEx(F0,F1,F2,F3,F4) (pSt->scriba_CallArgEx((F0),(F1),(F2),(F3),(F4)))

  long (*scriba_LookupFunctionByName)(pSbProgram pProgram, char *pszFunctionName);

     #define besScribaLookupFunctionByName(F0,F1) (pSt->scriba_LookupFunctionByName((F0),(F1)))

  long (*scriba_LookupVariableByName)(pSbProgram pProgram, char *pszVariableName);

     #define besScribaLookupVariableByName(F0,F1) (pSt->scriba_LookupVariableByName((F0),(F1)))

  long (*scriba_GetVariableType)(pSbProgram pProgram, long lSerial);

     #define besScribaGetVariableType(F0,F1) (pSt->scriba_GetVariableType((F0),(F1)))

  int (*scriba_GetVariable)(pSbProgram pProgram, long lSerial, pSbData *pVariable);

     #define besScribaGetVariable(F0,F1,F2) (pSt->scriba_GetVariable((F0),(F1),(F2)))

  int (*scriba_SetVariable)(pSbProgram pProgram, long lSerial, int type, long lSetValue, double dSetValue, char *pszSetValue, unsigned long size);

     #define besScribaSetVariable(F0,F1,F2,F3,F4,F5,F6) (pSt->scriba_SetVariable((F0),(F1),(F2),(F3),(F4),(F5),(F6)))

  int (*log_state)(ptLogger pLOG);

     #define besLogState(X) (pSt->log_state(X))

  int (*log_init)(ptLogger pLOG,
                  void *(*memory_allocating_function)(size_t, void *),
                  void (*memory_releasing_function)(void *, void *),
                  void *pMemorySegment,
                  char *pszLogFileName,
                  int iLogType);

     #define besLogInit(F0,F1,F2,F3,F4,F5) (pSt->log_init((F0),(F1),(F2),(F3),(F4),(F5)))

  int (*log_printf)(ptLogger pLOG,
                    char *pszFormat,
                    ...);

     #define besLogPrintf pSt->log_printf

  int (*log_shutdown)(ptLogger pLOG);

     #define besLogShutdown(X) (pSt->log_shutdown(X))

  unsigned long (*handle_GetHandle)(void **pHandle,
                                    void *pMEM,
                                    void *pointer);

     #define besHandleGetHandle(X,Y) (pSt->handle_GetHandle(&(X),pSt->pEo->pMemorySegment,(Y)))

  void *(*handle_GetPointer)(void **pHandle,
                             unsigned long handle);

     #define besHandleGetPointer(X,Y) (pSt->handle_GetPointer( &(X),(Y)))

  void (*handle_FreeHandle)(void **pHandle,
                            unsigned long handle);
     #define besHandleFreeHandle(X,Y) (pSt->handle_FreeHandle( &(X), (Y)))

  void (*handle_DestroyHandleArray)(void **pHandle,
                                    void *pMEM);
     #define besHandleDestroyHandleArray(X) (pSt->handle_DestroyHandleArray( &(X),pSt->pEo->pMemorySegment))

  int (*basext_GetArgsF)(pSupportTable pSt,
                      pFixSizeMemoryObject pParameters,
                      char *pszFormat,
                      ...
                      );

     #define besGETARGS pSt->basext_GetArgsF(pSt,pParameters,
     #define besGETARGE );
     #define besARGUMENTS(X) int iError; iError = pSt->basext_GetArgsF(pSt,pParameters,(X),
     #define besARGEND ); if( iError )return iError;

  void *(*InitSegment)(void * (*maf)(size_t),
                            void   (*mrf)(void *));
  long (*SegmentLimit)(void *p,unsigned long NewMaxSize);
  void (*FreeSegment)(void *p);
  void (*FinishSegment)(void *p);

     #define besINIT_SEGMENT(MAF,MRF) (pSt->InitSegment(MAF,MRF))
     #define besSEGMENT_LIMIT(PMS,L) (pSt->SegmentLimit(PMS,L))
     #define besFREE_SEGMENT(PMS) (pSt->FreeSegment(PMS))
     #define besFINISH_SEGMENT(PMS) (pSt->FinishSegment(PMS))

  } SupportTable, *pSupportTable

