#ifndef __THINCORE_BI__
#define __THINCORE_BI__

#include once "windows.bi"
#include once "win/ole2.bi"

#inclib "thinCore"
extern "Windows-MS"

Const TB_TRUE  AS long = 1
const TB_FALSE As Long = 0

const VarMainType_IsNumber       As Long = 20
const VarMainType_IsString       As Long = 30
const VarMainType_IsAsciiZ       As Long = 25
const VarMainType_IsVariant      As Long = 50

const VarSubType_Byte            As Long =  1
const VarSubType_Integer         As Long =  2
const VarSubType_Word            As Long =  3
const VarSubType_DWord           As Long =  4
const VarSubType_Long            As Long =  5
const VarSubType_Quad            As Long =  6
const VarSubType_Single          As Long =  7
const VarSubType_Double          As Long =  8
const VarSubType_Currency        As Long =  9
const VarSubType_Ext             As Long = 10
const VarSubType_Variant         As Long = 50

'------------------------------------------------------------------------------
'  Return Types from functions/Subs
'------------------------------------------------------------------------------
const thinBasic_ReturnNone           As Long =  0
const thinBasic_ReturnNumber         As Long = 20
const thinBasic_ReturnString         As Long = 30

const thinBasic_ReturnCodeByte       As Long =  1
const thinBasic_ReturnCodeInteger    As Long =  2
const thinBasic_ReturnCodeWord       As Long =  3
const thinBasic_ReturnCodeDWord      As Long =  4
const thinBasic_ReturnCodeLong       As Long =  5
const thinBasic_ReturnCodeQuad       As Long =  6
const thinBasic_ReturnCodeSingle     As Long =  7 
const thinBasic_ReturnCodeDouble     As Long =  8
const thinBasic_ReturnCodeCurrency   As Long =  9
const thinBasic_ReturnCodeExt        As Long = 10
const thinBasic_ReturnCodeString     As Long = 30

const thinBasic_ForceOverWrite       AS Long = 1


'------------------------------------------------------------------------------
'Types
'------------------------------------------------------------------------------
' Extended Numbers for FreeBASIC
' by Joshy and Charles

' assignment (Ext,Double,Single,integer,short,byte)
' casting (String,Double,Single,integer,short,byte)
' Math (+,-,*,/)
' Ext=SQRT(Ext,Double,Single,integer,short,byte)
type NumberFormat
  dp  as long ' DECIMAL PLACES
  sn  as long ' SCIENTIFIC NOTATION
  trz as long ' STRIP END ZEROS
  sdp as long ' ALLOW START WITH DECIMAL POINT 
end type
dim shared as NumberFormat num

' EXTENDED TYPE
type EXT
  as byte Value(9)
  declare constructor
  declare constructor(byref l as EXT)
  declare constructor(byval l as double)
  declare constructor(byval s as string)
  declare operator let(byval r as double)
  declare operator let(byval s as string)
  'declare operator SQR(byref r as EXT) as EXT
  'declare operator SQR(byval r as double) as EXT
  declare operator cast as string
  declare operator cast as double
end type

declare function float_to_ascii(byval pa as ext ptr) as string
declare sub ascii_to_float(byval s as string, byval pa as ext ptr)

' constructors
constructor EXT
 ' dummy constructor
end constructor

constructor EXT(byref l as EXT)
  dim as any ptr d =@value(0),s=@l.value(0)
  asm
  mov eax,[s]
  fldt [eax]
  mov eax,[d]
  fstpt [eax]
  end asm
end constructor

constructor EXT(byval l as double)
  dim as any ptr p =@value(0)
  asm
  fld qword ptr [l]
  mov eax,[p]
  fstpt [eax]
  end asm
end constructor

constructor EXT(byval s as string)
  dim as any ptr p=@value(0)
  ascii_to_float(s,p)
end constructor

'assignment

operator EXT.let(byval l as double)
  dim as any ptr p =@value(0)
  asm
  fld qword ptr [l]
  mov eax,[p]
  fstpt [eax]
  end asm
end operator

operator EXT.let(byval s as string)
  dim as any ptr p=@value(0)
  ascii_to_float(s,p)
end operator

operator EXT.cast as string
  dim as any ptr p =@value(0)
  return float_to_ascii(p)
end operator

operator EXT.cast as double
  dim as any ptr p =@value(0)
  dim as double  d
  asm
  mov eax,[p]
  fldt [eax]
  fstp qword ptr [d]
  end asm
  return d
end operator

Operator + (ByRef l As EXT, ByRef r As EXT) As EXT
  dim as EXT t
  dim as any ptr p = @t.value(0)
  asm 
  mov  eax,[l]
  fldt [eax]
  mov  eax,[r]
  fldt [eax]
  faddp
  mov  eax,[p]
  fstpt [eax]
  end asm
  Return t
End Operator
 
Operator - (ByRef l As EXT, ByRef r As EXT) As EXT
  dim as EXT t
  dim as any ptr p = @t.value(0)
  asm 
  mov  eax,[l]
  fldt [eax]
  mov  eax,[r]
  fldt [eax]
  fsubp
  mov  eax,[p]
  fstpt [eax]
  end asm
  Return t
End Operator
 
 
Operator / (ByRef l As EXT, ByRef r As EXT) As EXT
  dim as EXT t
  dim as any ptr p = @t.value(0)
  asm 
  mov  eax,[l]
  fldt [eax]
  mov  eax,[r]
  fldt [eax]
  fdivp
  mov  eax,[p]
  fstpt [eax]
  end asm
  Return t
End Operator
 
Operator * (ByRef l As EXT, ByRef r As EXT) As EXT
  dim as EXT t
  dim as any ptr p = @t.value(0)
  asm 
  mov  eax,[l]
  fldt [eax]
  mov  eax,[r]
  fldt [eax]
  fmulp
  mov  eax,[p]
  fstpt [eax]
  end asm
  Return t
End Operator



function EXTSQR(byref r as EXT) as EXT
  dim as EXT t
  dim as any ptr p = @t.value(0)
  asm 
  mov  eax,[r]
  fldt [eax]
  fsqrt
  mov  eax,[p]
  fstpt [eax]
  end asm
  Return t
end function





'-----------------------------------------------------
function float_to_ascii(byval pa as ext ptr) as string
'=====================================================
  static as ubyte s(23), t(23) 'BUFFERS
  static as ubyte bcd(11)
  dim as long esize,tempdw,dp,sn,snv,b,nzero,oldcw,truncw
  static as zstring ptr ps,pt

  dim as long num_trz,num_dp,num_sn,num_sdp

  num_trz = num.trz
  num_dp  = num.dp
  num_sn  = num.sn
  num_sdp = num.sdp

  ps=varptr(s(0))
  pt=varptr(t(0))

  asm
  mov eax,0
  mov [snv],eax
  mov [sn],eax
  mov [nzero],eax
  mov ecx,[pa]
  mov eax,[ecx+8]
  and eax,&h7fff
  cmp eax,0
  jnz xfa2  'exit EXCLUDE NON ZERO
  cmp dword ptr [num_trz],0
  jz xfa2 'exit ZERO STRIPPER FLAG
  or eax,[ecx+4]
  jnz xfa2 'exit
  test byte ptr [ecx+9],&h80
  jz xfa1 'exit
  end asm
  *pt="-0"
  asm
  jmp fadonez 'NEGATIVE ZERO
xfa1:
  end asm

  *pt="0"
  asm
  jmp fadonez 'POSITIVE ZERO
xfa2:
  cmp eax,&h7fff
  jnz xfa5n 'exit
  mov dword ptr [nzero],1
  mov eax,[ecx+4]
  and eax,0x7fffffff 'exclude bit 63
  or  eax,[ecx]
  cmp eax,0
  jz xfa4 'exit
  test byte ptr [ecx+7],&h40
  jnz xfa3 'exit
  end asm

  *pt="#sNAN"
  asm
  jmp fadonez 'SIGNALLING NAN

xfa3:
  end asm

  *pt="#qNAN"
  asm
  jmp fadonez 'QUIET NAN
xfa4:
  'NEGATIVE / POSITIVE INFINITY
  test byte ptr [ecx+9],&h80
  jz xfa5 'exit
  end asm

  *pt="#-INF"
  asm
  jmp fadonez 'NEGATIVE INFINITY
xfa5:
  end asm

  *pt="#INF"
  asm
  jmp fadonez 'POSITIVE INFINITY
xfa5n:
  mov eax,[pa]
  fldt [eax]
  'CHECK FOR ZERO
  mov dword ptr [esize],0
  fldz
  fcomip st(0),st(1)
  jz xfa6 'exit
  mov dword ptr [nzero],1

  fldlg2        ' log10(2)
  fld   st(1)   ' copy Src
  fabs          ' insures a positive value
  fyl2x         ' ->[log2(Src)]*[log10(2)] = log10(Src)
  fstcw [oldcw] ' get current control word
  fwait
  mov   ax,[oldcw]
  or    ax,&hc00            ' code it for truncating
  mov   [truncw],ax
  fldcw [truncw]            ' insure rounding code of FPU to truncating

  fist dword ptr [esize]    ' store characteristic of logarithm
  fldcw [oldcw]             ' load back the former control word

  ftst                      ' test logarithm for its sign
  fstsw ax                  ' get result
  fwait
  sahf                      ' transfer to CPU flags
  sbb   dword ptr [esize],0 ' decrement esize if log is negative
  fstp  st(0)               ' get rid of the logarithm

xfa6:
  ' DECIMAL PLACES LIMIT
  mov eax,[num_dp]
  cmp eax,17
  jle xfa7 'exit
   mov eax,17 'LIMIT DECIMAL PLACES
xfa7:
  mov [dp],eax
  ' IS SCIENTIFIC NOTATION ALWAYS REQUIRED
  cmp byte ptr [num_sn],0
  jnz ENotation
  ' VERY LARGE NUMBERS
  mov ecx,[esize]
  cmp ecx,18
  jl xfa8 'exit
  jmp ENotation
xfa8:
  'SMALL NUMBERS
  cmp dword ptr [esize],0
  jge xfa9 'exit
  mov ecx,[dp]
  mov edx,[esize]
  neg edx
  cmp edx,4
  jg ENotation 'LIMIT FOR SIMPLE FORMAT
  mov eax,ecx
  mov [dp],ecx
  jmp PowerAdjust
xfa9:
  ' NUMBERS NOT REQUIRING SCIENTIFIC NOTATION
  mov eax,[dp]
  mov ecx,eax   'DECIMAL PLACES
  add ecx,[esize] 'INTEGER DIGITS 
  sub ecx,17
  jle xfa10 'exit
  ' TOO MANY DIGITS? (ecx contains excess digits)
  sub eax,ecx 'REDUCE MULTIPLIER PLACES IF NECESSARY
  sub [dp],ecx  'REDUCE DECIMAL PLACES ALSO
xfa10:
  jmp PowerAdjust
  ENotation:
  mov ecx,[esize]
  mov [snv],ecx
  mov eax,[dp]
  sub eax,ecx
  mov dword ptr [sn],1 'SCIENTIFIC NOTATION FLAG

  PowerAdjust:
  mov [tempdw],eax 'ADJUSTED MULTIPLIER
  ' Multiply the number by the power of 10
  mov eax,[tempdw]
  cmp eax,0
  jz xfa11 'exit
  fild dword ptr [tempdw]
  fldl2t
  fmulp st(1),st(0)       '->log2(10)*exponent
  fld st(0)
  frndint                 'get the characteristic of the log
  fxch st(1)
  fsub st(0),st(1)        'get only the fractional part but keep the characteristic
  f2xm1                   '->2^(fractional part)-1
  fld1
  faddp st(1),st(0)                    'add 1 back
  fscale                  're-adjust the exponent part of the REAL number
  fstp  st(1)             'get rid of the characteristic of the log
  fmulp st(1),st(0)       '->16-digit integer
xfa11:
  fbstp [bcd] 'SAVE AS PACKED BINARY CODED DECIMAL
  ' EXPAND DIGITS
  lea edx,[bcd]
  lea ecx,[s]
  push ebx
  mov bl,10
rfa12:
  dec bl
  jl xfa12 'exit
  mov ah,[edx]
  inc edx
  mov al,ah
  and al,15
  add al,48
  mov [ecx],al
  inc ecx
  mov al,ah
  shr al,4
  and al,15
  add al,48
  mov [ecx],al
  inc ecx
  jmp rfa12 'repeat

xfa12:
  mov byte ptr [ecx],0
  ' COPY FORMATTED
  lea edx,[t]
  ' NEGATIVE SIGN NEEDED?
  cmp al,48
  jz xfa13 'exit
  mov byte ptr [edx],45
  inc edx
xfa13:
  lea ebx,[s]
  add ebx,18
  mov cl,19
  mov ah,0
  mov ch,[dp]
  dec ch
rfa18:
  dec cl
  jl xfa18 'exit
  ' INSERT DECIMAL POINT
  cmp cl,ch
  jnz xfa15 'exit
  ' PLACE LEADING ZERO
  cmp dword ptr [num_sdp],0
  jnz xfa14 'exit SDP FLAG TO INHIBIT
  cmp ah,0
  jnz xfa14 'exit
  mov byte ptr [edx],48
  inc edx
xfa14:
  mov byte ptr [edx],46
  inc edx
  mov ah,1 'STOP STRIPPING ZEROS

xfa15:
  mov al,[ebx]
  dec ebx
  cmp ah,0
  jnz faok

xfa16:
  cmp al,48
  jz xfa17 'exit STRIP LEADING ZEROS
  mov ah,1 'INHIBIT FUTURE STRIPPING
  faok:
  mov [edx],al
  inc edx

xfa17:
  jmp rfa18 'repeat

xfa18:
  pop ebx
  fadone:
  ' REMOVE ENDING ZEROS
  cmp dword ptr [num_trz],0
  jz xfa21 'exit
  lea ecx,[t] 'BASE ADDRESS OF NUMBER STRING
rfa20:
  dec edx
  cmp edx,ecx      
  jle xit1 'exit LEAVE FIRST CHARACTER ALONE
  mov al,[edx]
  cmp al,46
  jnz xfa19 'exit
  dec edx
  jmp xit1 'STRIP DOT AND EXIT
xfa19:
  cmp al,48
  jnz xfa20 'exit ONLY LOOK AT RIGHT HAND ZEROS
  jmp rfa20 'repeat 'STRIP ZERO AND CONTINUE
xfa20:
  xit1:
  inc edx
xfa21:
  ' ENSURE AT LEAST ONE DIGIT
  lea ecx,[t]
  mov al,[ecx]
  cmp al,45
  jnz xfa22 'exit
  inc ecx
xfa22:
  cmp ecx,edx
  jnz xfa23 'exit
  mov byte ptr [edx],48
  inc edx
xfa23:
  ' CHECK FOR SCIENTIC NOTATION
  cmp dword ptr [sn],0
  jz xfa27 'exit
  cmp dword ptr [nzero],0
  jz xfa27 'exit
  mov eax,[snv]
  cmp eax,0
  jz xfa27 'exit E VALUE ZERO SO OMIT
  mov byte ptr [edx],69
  inc edx 'E'
  mov cl,43
  cmp eax,0
  jge xfa24 'exit
  neg eax
  mov cl,45
xfa24:
  mov [edx],cl
  inc edx 'SIGN
  mov cl,100
  div cl
  push eax
  and eax,&hff
  mov cl,10
  div cl
  cmp ax,0
  jz xfa26 'exit
  or eax,&h3030 'TO ASCII THOUSANDS AND HUNDREDS
  cmp al,48
  jz xfa25 'exit
  mov [edx],al
  inc edx
xfa25:
  mov [edx],ah
  inc edx
xfa26:
  pop eax
  shr eax,8
  div cl
  or eax,&h3030 'TO ASCII TENS AND UNITS
  mov [edx],aX
  add edx,2
xfa27:
  mov byte ptr [edx],0 'APPEND NULL TERMINATOR
  fadonez:
  end asm
  function=rtrim(*pt)
end function


'---------------------------------------------------------
sub ascii_to_float(byval s as string, byval pa as ext ptr)
'=========================================================

  dim as long stt,dpf,dpl,enf,eno,digi,sgf,sgg,ten=10

  asm

  mov ecx,[s]
  '
  'SKIP LEADING WHITE SPACE
  '
raf1:
  mov al,[ecx]
  cmp al,0
  jz ParseExit
  cmp al,32
  jg xaf1 'exit
  inc ecx
  jmp raf1 'repeat
xaf1:
  '
  mov [stt],ecx 'START OF NUMBER
  '
  '---------------
  'SPECIAL NUMBERS
  '---------------
  '
  cmp al,35 '#
  jnz normf 'NORMAL NUMBERS
  mov edx,[pa]
  '
  'DEFAULT ZERO
  '
  mov dword ptr [edx],0
  mov dword ptr [edx+4],0
  mov word ptr [edx+8],0
  '
  inc ecx
  mov eax,[ecx]
  add ecx,4
  or eax,&h20202020 'QUICK LOWERCASE
  '
  cmp eax,&h666e692d '#-INF
  jnz xsnum1 'exit
  mov word ptr [edx+8],&hffff
  jmp xitsn
xsnum1:
  cmp eax,&h6e616e71 '#QNAN
  jnz xsnum2 'exit
  mov dword ptr [edx+4],&h40000000
  mov word ptr [edx+8],&h7fff
  jmp xitsn
xsnum2:
  cmp eax,&h6e616e73 '#SNAN
  jnz xsnum3 'exit
  mov dword ptr [edx+4],&h20000000
  mov word ptr [edx+8],&h7fff
  jmp xitsn
xsnum3:
  and eax,&hffffff 'IGNORE 4TH CHAR
  '  
  cmp eax,&h666e69 '#INF
  jnz xsnum4 'exit
  mov word ptr [edx+8],&h7fff
  dec ecx
  jmp xitsn
xsnum4:
  '
  mov dword ptr [edx+4],&h40000000 'DEFAULT #QNAN
  mov word ptr [edx+8],&h7fff
  end asm
  exit sub
  asm

xitsn:
    '
  end asm
  exit sub
  asm

'-------------------------------------
normf: 'OTHERWISE CONVENTIONAL NUMBERS
'-------------------------------------
  '
  fldz
  dec ecx     'PRE DECR
  '
  '---------
  ParseLoop:
  '---------
  '
raf2:
  inc ecx
  mov al,[ecx]
  cmp al,32
  jle ParseExit
  '
  'TEST FOR E
  '
raf3:
  cmp al,&h65
  jz xaf3 'exit
  cmp al,&h45
  jz xaf3 'exit
  jmp nexne
xaf3:

    'E ENCOUNTERED
raf4:
  mov eax,ecx
  inc eax
  mov dword ptr [enf],eax
  fldz
  mov al,[sgf]
  mov [sgg],al
  mov dword ptr [sgf],0
  jmp ParseLoop
xaf4:
  '
  '-------------------
  nexne: 'BYPASS E SETUP
  '-------------------
  '
  'NEGATIVE SIGN
  '
raf5:
  cmp al,45
  jnz xaf5 'exit
  cmp byte ptr [sgf],0
  jnz NumErr 'NEG SIGN ALREADY ENCOUNTERED
  mov byte ptr [sgf],1 'SET SIGN FLAG
  jmp ParseLoop
xaf5:

raf6:
  cmp al,43
  jnz xaf6 'exit
  cmp ecx,[stt]
  jz ParseLoop 'PLUS SIGN AT START OF NUMBER
  cmp byte ptr [sgf],0
  jnz ParseExit 'PLUS SIGN MARKING BOUNDARY OF NUMBER
  cmp [enf],ecx
  jz ParseLoop 'PLUS SIGN IMMEDIATELY FOLLOWING E
  jmp ParseExit
xaf6:

  'CHECK FOR DECIMAL POINT
  '
raf7:
  cmp al,46
  jnz xaf7 'exit
  cmp dword ptr [enf],0
  jnz NumErr 'DECIMAL POINT AFTER E
  cmp byte ptr [dpf],0
  jnz NumErr 'DECIMAL POINT ALREADY PRESENT
  mov byte ptr [dpf],1
  jmp ParseLoop
xaf7:
  '
  'VALIDATE DIGIT
  '
  sub al,48
  jl ParseExit 'ASCII BELOW '0'
  cmp al,9
  jg ParseExit 'exit  'ASCII ABOVE '9'
  '
  'ACCUM * 10 + DIGIT
  '
  fimul dword ptr [ten]
  mov [digi],al
  fiadd dword ptr [digi]
  '
raf8:
  cmp byte ptr [dpf],0
  jz xaf8 'exit  'NO DECIMAL POINT
  cmp byte ptr [enf],0
  jnz xaf8 'exit 'EXCLUDING E NUMBER
  inc dword ptr [dpl]
xaf8:
  jmp ParseLoop 
xaf2:
  '
  '---------
  ParseExit:
  '---------
  '
  'CHECK FOR NEG SIGN
raf9:
  cmp byte ptr [sgf],0
  jz xaf9 'exit
  fchs
xaf9:
  '
  'DECIMAL PLACES BUT NO E NUMBER
  '
raf10:
   cmp dword ptr [enf],0
   jnz xaf10 'exit
   mov dword ptr [enf],1 'SET TO SCALE
   fldz
xaf10:
  '
  '
  'SCALE VALUE PRESENT?
  '
raf11:
  cmp dword ptr [enf],0
  jz xaf11 'exit
  '
  fisub dword ptr [dpl] 'ADJUST SCALER FOR DECIMAL PLACES
  fldl2t
  fmulp  st(1),st(0)   '->log2(10)*exponent
  fld   st(0)
  frndint              'get the characteristic of the log
  fxch
  fsub st,st(1)        'get only the fractional part but keep the characteristic
  f2xm1                '->2^(fractional part)-1
  fld1
  faddp st(1),st(0)    'add 1 back
  fscale               're-adjust the exponent part of the REAL number
  fstp  st(1)          'get rid of the characteristic of the log
  fmulp st(1),st(0)    '->16-digit integer
  '
  'CHECK FOR NEG SIGN
  '
raf12:
  cmp byte ptr [sgg],0
  jz xaf12 'exit
  fchs
xaf12:

xaf11:

  '
  okay: 'NUMBER COMPLETED
  '----------------------
  
  mov eax,[pa]
  fstpt [eax]
  end asm
  '
  exit sub
  '
  asm
  '
  NumErr: 'NUMBER ERRORS
  '---------------------
  '
  fstp st(0) 'DUMP ACCUM
  fld1
  mov eax,[pa]
  fstpt [eax]
  end asm
  print "Number error"
 
end sub


'----------------------------------------------------------------------------
'thinBasic_LoadSymbol
'----------------------------------------------------------------------------
' Description
' Creates e new keyword inside interpreter.
' You define your own Function or Sub inside your program.
' Then call thinBasic_LoadSymbol to add a new keyword connected to your new function/sub
'
' Parameters
' SymbolName  : Name you want to give to your sub or function inside the interpreter.
'
' ReturnCode  : specify what kind of var your function returns
' %thinBasic_ReturnNumber
' %thinBasic_ReturnString (If SymbolName end with "$", %thinBasic_ReturnString will be forced
' %thinBasic_ReturnNone
'
' FunctionOrSubPointer:
'  will be called when SymbolName keyword will be encountered during script execution
'
'   ForceOverWrite:
' If different from 0 it means that even if SymbolName already exists as a keyword, you want to overwrite it with a new one.
'
' Possible Return Code
' >0 = no error, return the associated SymbolName ID
' -1 = empty SymbolName
' -2 = duplicated SymbolName and no ForceOverWrite flag
' -3 = invalid sub/function pointer
' -4 = SymbolName contains invalid char(s)
'
' Example
'   thinBasic_LoadSymbol "MyNewFunction", %thinBasic_ReturnNumber, @MyFunc
DECLARE Function thinBasic_LoadSymbol ALIAS "thinBasic_LoadSymbol_FB" _
  (byval SymbolName           As ZString Ptr, _
   BYVAL ReturnCode           AS Long, _
   BYVAL FunctionOrSubPointer As Any Ptr, _
   BYVAL ForceOverWrite       As Long = thinBasic_ForceOverWrite) As Long

'----------------------------------------------------------------------------
'thinBasic_VariableExists
'----------------------------------------------------------------------------
' Returns true/false depending if the given name is a variable or not
DECLARE FUNCTION thinBasic_VariableExists (BYVAL vName AS BSTR) AS LONG

'----------------------------------------------------------------------------
'thinBasic_VariableGetInfo
'----------------------------------------------------------------------------
' Returns additional variable info giving variable name.
' ATTENTION: pass variable as reference. 
' Function will populate with relevant information
' Function will return a pointer to variable data that can be used in other situations.
DECLARE FUNCTION thinBasic_VariableGetInfo _
  (Byval SearchKey   AS BSTR    , _
   Byval pMainType   As Long Ptr, _
   Byval pSubType    As Long Ptr, _
   Byval pIsArray    As Long Ptr) As long


'----------------------------------------------------------------------------
' thinBasic_VariableGetInfoEX
'----------------------------------------------------------------------------
' Returns additional variable info giving variable name.
' ATTENTION: pass variable as reference. Function will populate with relevant information
' Function returns a pointer to internal thinBasic variable structure data that can be used in other situations.
declare FUNCTION thinBasic_VariableGetInfoEX _
  (byval SearchKey   as BSTR    , _
   byval pMainType   as long ptr, _
   byval pSubType    as long ptr, _
   byval pIsArray    as long ptr, _
   byval pDataPtr    as long ptr, _
   byval pnElements  as long ptr) as long

'---Equates for variable Main Type
const MainType_IsNumber        As Long = 20
const MainType_String          As Long = 30
const MainType_Variant         As Long = 50
const MainType_UDT             As Long = 60

'---Equates for variable Sub Type
const SubType_Byte             As Long =  1
const SubType_Integer          As Long =  2
const SubType_Word             As Long =  3
const SubType_DWord            As Long =  4
const SubType_Long             As Long =  5
const SubType_Quad             As Long =  6
const SubType_Single           As Long =  7
const SubType_Double           As Long =  8
const SubType_Currency         As Long =  9
const SubType_Ext              As Long = 10
const SubType_AsciiZ           As Long = 25 
  

'----------------------------------------------------------------------------
' hinBasic_VariableIsArray
'----------------------------------------------------------------------------
' Returns true/false depending if given name is an array
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_VariableIsArray _
  (BYVAL vName AS BSTR) AS LONG
 
'----------------------------------------------------------------------------
'thinBasic_VariableRedim
'----------------------------------------------------------------------------
' Redim a variable giving variable ptr
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_VariableRedim _
  (BYVAL pVar AS LONG, BYVAL lPreserve AS LONG, _
   BYVAL Dim1 AS LONG, BYVAL Dim2 AS LONG=0, BYVAL Dim3 AS LONG=0) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_ArrayGetElements
'----------------------------------------------------------------------------
' Returns total number of elements inside an array giving the array name
' ATTENTION: this function works on single or multi dimensions arrays
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_ArrayGetElements _
  (BYVAL vName AS BSTR) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_ArrayGetPtr
'----------------------------------------------------------------------------
' Returns the data structure pointer of an array giving its name
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_ArrayGetPtr _
 (byval vName AS BSTR) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_ArrayGetInfo
'----------------------------------------------------------------------------
' Returns information on an array passing array pointer returned by thinBasic_ArrayGetPtr
'----------------------------------------------------------------------------
enum ArrayInfo
  Array_ElementsCount =  1 ' Total number of elements in the array
  Array_ElementSize   =  2 ' The size of the single element (for example an array of LONGs will return 4)
  Array_Dimensions    =  3 ' Number of dimensions (from 1 to 3)
  Array_Size          =  4 ' Memory size allocated for the array. This will not compute the memory needed for strings
  Array_ElementsType  = 10 ' Type of elements strored into the array. See equates for thinBasic_VariableGetInfo
end enum
DECLARE FUNCTION thinBasic_ArrayGetInfo  _
  (ArrayPtr AS LONG, BYVAL InfoType AS ArrayInfo) AS LONG
 

'----------------------------------------------------------------------------
' thinBasic_AddEquate
'----------------------------------------------------------------------------
' Add a new equate (constant)
'----------------------------------------------------------------------------
' check optional
DECLARE FUNCTION thinBasic_AddEquate  _
  (BYVAL vName       AS BSTR, _
   BYVAL lValString  AS BSTR, BYVAL lValNumber  AS EXT, _
   BYVAL ForceType   AS LONG =0) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_AddVariable
'----------------------------------------------------------------------------
' Add a new variable to current stack level
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_AddVariable _
  (BYVAL vName AS BSTR,            _
   BYVAL lValString AS BSTR, BYVAL lValNumber AS EXT, _
   BYVAL ForceType AS LONG) AS LONG

'----------------------------------------------------------------------------
' thinBasic_ChangeVariableNumber
'----------------------------------------------------------------------------
' Change the value of a numeric variable giving its name a the new value
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_ChangeVariableNumber _
  (BYVAL vName AS BSTR,BYVAL lValNumber AS EXT) AS LONG

'----------------------------------------------------------------------------
' thinBasic_ChangeVariableString
'----------------------------------------------------------------------------
' Change the value of a string variable giving its name a the new value
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_ChangeVariableString  _
  (BYVAL vName AS BSTR, BYVAL lValNumber AS BSTR) AS LONG

'----------------------------------------------------------------------------
' thinBasic_GetToken
'----------------------------------------------------------------------------
' Returns the next token as token ID.
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_GetToken _
  (BYVAL AutoPutBack AS Long) AS LONG

'----------------------------------------------------------------------------
' thinBasic_GetTokenName
'----------------------------------------------------------------------------
' Returns the next token as string.
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_GetTokenName _
  (BYVAL AutoPutBack AS LONG=0) AS BSTR

'----------------------------------------------------------------------------
' thinBasic_GetTokenID
'----------------------------------------------------------------------------
' Return internal engine unique ID giving the token name
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_GetTokenID(BYVAL TokenName AS BSTR) AS LONG

'----------------------------------------------------------------------------
' thinBasic_TokenGetCurrentID
'----------------------------------------------------------------------------
' Return current token ID
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_TokenGetCurrentID () AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_PutBack
'----------------------------------------------------------------------------
' Put back into parsing stack the last parsed token
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_Putback(BYVAL lPtr AS LONG = 0) AS LONG

'----------------------------------------------------------------------------
'thinBasic_FunctionExists
'----------------------------------------------------------------------------
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_FunctionExists(BYVAL fName AS BSTR) AS LONG
 
 
'typo?
'----------------------------------------------------------------------------
' thinBasic_GetKeywordSpeficic
'----------------------------------------------------------------------------
' Instruct parser to get next token, test if it a keyword and if yes,
' check if it is one of the possible keywords passed. If not, a RT-Error will be generated
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_GetKeywordSpeficic _
                           (                                       _
                                       BYVAL HideError   AS LONG , _
                                       BYVAL AutoPutBack AS LONG , _
                                       BYVAL lKey1   AS LONG     , _
                                       _' OPTIONAL
                                       BYVAL lKey2   AS LONG     , _
                                       BYVAL lKey3   AS LONG     , _
                                       BYVAL lKey4   AS LONG     , _
                                       BYVAL lKey5   AS LONG     , _
                                       BYVAL lKey6   AS LONG     , _
                                       BYVAL lKey7   AS LONG     , _
                                       BYVAL lKey8   AS LONG     , _
                                       BYVAL lKey9   AS LONG     , _
                                       BYVAL lKey10  AS LONG     , _
                                       BYVAL lKey11  AS LONG     , _
                                       BYVAL lKey12  AS LONG     , _
                                       BYVAL lKey13  AS LONG     , _
                                       BYVAL lKey14  AS LONG     , _
                                       BYVAL lKey15  AS LONG       _
                           ) AS LONG

'----------------------------------------------------------------------------
' thinBasic_VariableParse
'----------------------------------------------------------------------------
' Instruct parser to get next token, check if variable, check if array and
' return all info needed to subsequent change variable value
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_VariableParse _
  (BYVAL VariablePtr AS LONG PTR, BYVAL VariableAbsPos  AS LONG PTR) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_VariableParsePtr
'----------------------------------------------------------------------------
' Instruct parser to get next token, check if variable return its pointer
'----------------------------------------------------------------------------
'  DECLARE FUNCTION thinBasic_VariableParsePtr                    _
 '                          LIB "thinCore.DLL"                      _
 '                          ALIAS "thinBasic_VariableParsePtr"      _
 '                          (                                       _
 '                            BYREF VariableName    AS STRING     , _
 '                            BYREF VariablePtr     AS LONG         _
 '                          ) AS LONG
DECLARE FUNCTION thinBasic_VariableParsePtr _
  (BYVAL VariablePtr AS LONG PTR) AS LONG

'----------------------------------------------------------------------------
' thinBasic_VariablePtrToDirectPtr
'----------------------------------------------------------------------------
'
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_VariablePtrToDirectPtr _
  (BYVAL VariablePtr AS LONG) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_DirectPtrToDataPtr
'----------------------------------------------------------------------------
'
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_DirectPtrToDataPtr _
  (BYVAL DirectPtr AS LONG) AS LONG
 
'----------------------------------------------------------------------------
' thinBasic_VariableParseAndGetInfo
'----------------------------------------------------------------------------
'
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_VariableParseAndGetInfo _
  (BYVAL VariableName    AS BSTR PTR, _
   BYVAL VariablePtr     AS LONG PTR, _
   BYVAL MainType        AS LONG PTR, _
   BYVAL SubType         AS LONG PTR, _
   BYVAL DataPtr         AS LONG PTR, _
   BYVAL nElements       AS LONG PTR) AS LONG

'----------------------------------------------------------------------------
' thinBasic_ChangeVariableStringDirect
'----------------------------------------------------------------------------
' See also thinBasic_VariableParse
'
' Change a variable using direct variable pointer's data returned by
' thinBasic_VariableParse. This will ensure to work also with arrays
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_ChangeVariableStringDirect _
  (BYVAL VariablePtr     AS LONG, _
   BYVAL VariableAbsPos  AS LONG, _
   BYVAL lValString      AS BSTR) AS LONG

'----------------------------------------------------------------------------
' thinBasic_ChangeVariableNumberDirect
'----------------------------------------------------------------------------
' See also thinBasic_VariableParse
'
' Change a variable using direct variable pointer's data returned by
' thinBasic_VariableParse. This will ensure to work also with arrays
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_ChangeVariableNumberDirect _
  (BYVAL VariablePtr    AS LONG, _
   BYVAL VariableAbsPos AS LONG, _
   BYVAL lValNumber     AS EXT) AS LONG
 

'---Used for thinBasic_AddEquate to force an equate type in case of missing first char $ or %
 const EquateTypeNumber as long  = 3
 const EquateTypeString as long  = 5
 

' thinBasic_CheckOpenParens
' thinBasic_CheckCloseParens
' thinBasic_CheckComma
' have the following optional parameters:
'
'   HideHerror 
'               if %TRUE, in case of parsing problems, no runtime error will
'               be generated
'   AutoPutBack
'               if %TRUE, in case of parsing problems, the found token
'               will be put back into parsing stack
'
'----------------------------------------------------------------------------
DECLARE SUB      thinBasic_ParseNumber        (Result AS EXT)
DECLARE Sub      thinBasic_ParseDouble        (ByRef Result AS Double)
DECLARE Sub      thinBasic_ParseLong          (ByRef Result AS Long)
DECLARE Function thinBasic_ParseLong_Optional (ByRef Result AS Long) As Long
DECLARE Sub      thinBasic_ParseDWord         (ByRef Result As Dword)


DECLARE FUNCTION thinBasic_Parse1Number() AS EXT
DECLARE FUNCTION thinBasic_Parse2Numbers( _
                   BYVAL Num1 AS EXT PTR, _
                   BYVAL Num2 AS EXT PTR  _
                   ) AS EXT
DECLARE FUNCTION thinBasic_Parse3Numbers( _
                   BYVAL Num1 AS EXT PTR, _
                   BYVAL Num2 AS EXT PTR, _
                   BYVAL Num3 AS EXT PTR  _
                   ) AS EXT

DECLARE FUNCTION thinBasic_Parse4Numbers( _
                   BYVAL Num1 AS EXT PTR, _
                   BYVAL Num2 AS EXT PTR, _
                   BYVAL Num3 AS EXT PTR, _
                   BYVAL Num4 AS EXT PTR  _
                   ) AS EXT
    DECLARE FUNCTION thinBasic_Parse5Numbers( _
                   BYVAL Num1 AS EXT PTR, _
                   BYVAL Num2 AS EXT PTR, _
                   BYVAL Num3 AS EXT PTR, _
                   BYVAL Num4 AS EXT PTR, _
                   BYVAL Num5 AS EXT PTR  _
                   ) AS EXT
    DECLARE FUNCTION thinBasic_Parse6Numbers( _
                   BYVAL Num1 AS EXT PTR, _
                   BYVAL Num2 AS EXT PTR, _
                   BYVAL Num3 AS EXT PTR, _
                   BYVAL Num4 AS EXT PTR, _
                   BYVAL Num5 AS EXT PTR, _
                   BYVAL Num6 AS EXT PTR  _
                   ) AS EXT
    DECLARE FUNCTION thinBasic_Parse7Numbers( _
                   BYVAL Num1 AS EXT PTR, _
                   BYVAL Num2 AS EXT PTR, _
                   BYVAL Num3 AS EXT PTR, _
                   BYVAL Num4 AS EXT PTR, _
                   BYVAL Num5 AS EXT PTR, _
                   BYVAL Num6 AS EXT PTR, _
                   BYVAL Num7 AS EXT PTR  _
                   ) AS EXT



  DECLARE FUNCTION thinBasic_ParseXNumbers( _
                    BYVAL MinNumToParse AS LONG, _
                    BYVAL MaxNumToParse AS LONG, _
                    BYVAL Num1  AS EXT PTR   , _
                    BYVAL Num2  AS EXT PTR=0   , _
                    BYVAL Num3  AS EXT PTR=0   , _
                    BYVAL Num4  AS EXT PTR=0   , _
                    BYVAL Num5  AS EXT PTR=0   , _
                    BYVAL Num6  AS EXT PTR=0   , _
                    BYVAL Num7  AS EXT PTR=0   , _
                    BYVAL Num8  AS EXT PTR=0   , _
                    BYVAL Num9  AS EXT PTR=0   , _
                    BYVAL Num10 AS EXT PTR=0     _
                   ) AS EXT

  DECLARE FUNCTION thinBasic_Parse1StringXNumbers( _
                    BYVAL MinNumToParse AS LONG, _
                    BYVAL MaxNumToParse AS LONG, _
                    BYVAL Str1  AS BSTR PTR, _
                    BYVAL Num1  AS EXT PTR   , _
                    BYVAL Num2  AS EXT PTR=0   , _
                    BYVAL Num3  AS EXT PTR=0   , _
                    BYVAL Num4  AS EXT PTR=0   , _
                    BYVAL Num5  AS EXT PTR=0   , _
                    BYVAL Num6  AS EXT PTR=0   , _
                    BYVAL Num7  AS EXT PTR=0   , _
                    BYVAL Num8  AS EXT PTR=0   , _
                    BYVAL Num9  AS EXT PTR=0   , _
                    BYVAL Num10 AS EXT ptr=0      _
                   ) AS EXT

DECLARE FUNCTION thinBasic_ParseString(BYREF Result As BSTR) AS long
DECLARE FUNCTION thinBasic_ParseStringPtr              ALIAS "thinBasic_ParseString" _
  (BYval pp as zstring ptr ptr) AS long

DECLARE FUNCTION thinBasic_CheckOpenParens(BYVAL HideError AS LONG=0, BYVAL AutoPutBack AS LONG=0) AS LONG
DECLARE FUNCTION thinBasic_CheckOpenParens_Mandatory AS LONG
DECLARE FUNCTION thinBasic_CheckOpenParens_Optional AS LONG

DECLARE FUNCTION thinBasic_CheckCloseParens(BYVAL HideError AS LONG=0, BYVAL AutoPutBack AS LONG=0) AS LONG
DECLARE FUNCTION thinBasic_CheckCloseParens_Mandatory as  LONG
DECLARE FUNCTION thinBasic_CheckCloseParens_Optional    AS LONG

DECLARE FUNCTION thinBasic_CheckComma(BYVAL HideError AS LONG=0, BYVAL AutoPutBack AS LONG=0) AS LONG
DECLARE FUNCTION thinBasic_CheckComma_Mandatory         AS LONG
DECLARE FUNCTION thinBasic_CheckComma_Optional          AS LONG

DECLARE FUNCTION thinBasic_DetermineType  AS LONG

const thinBasic_BufferType_IsFile   = 0
const thinBasic_BufferType_IsScript = 1
 
Declare Function  thinBasic_Init(ByVal hWnd            As Long, _
                                 ByVal cInstance       As Long, _
                                 ByVal sKey            As BSTR) As Long

Declare Function  thinBasic_Release(ByVal hScript         As Long) As Long

Declare Function  thinBasic_Run( _
                          ByVal hScript         As Long       , _
                          byval sBuffer         As BSTR     , _
                          ByVal BufferType      As Long   , _
                          ByVal Options         As Long=0 , _
                          ByVal DebugMode       As Long=0 , _
                          ByVal LogMode         As Long=0 , _
                          ByVal ObfuscateMode   As Long=0 , _
                          ByVal CallingProgram  As Long=0 , _
                          ByVal DependancyMode  As Long=0) As Long

'----------------------------------------------------------------------------
'thinBasic_LoadSymbolEX
'----------------------------------------------------------------------------
' Description
'   Creates e new keyword inside interpreter.
'   You define your own Function or Sub inside your program. Then call
'   thinBasic_LoadSymbol to add a new keyword connected to your new function/sub
'
' Parameters
'   SymbolName  : Name you want to give to your sub or function inside the
'                 interpreter. It is the new keyword name.
'
'   ReturnCode  : specify what kind of var your function returns
'                 Use predefined constants:
'                 %thinBasic_ReturnNumber
'                 %thinBasic_ReturnString
'                 %thinBasic_ReturnNone
'                 If SymbolName will end with "$" char, ReturnCode will
'                 be forced to %thinBasic_ReturnString
'                 Note: if you pass a pointer to a SUB routine and ReturnCode
'                       is different from %thinBasic_ReturnNone, a GPF will be
'                       fired by the Operating System.
'                 Note: if ReturnCode <= 0 then %thinBasic_ReturnNone will be
'                       assumed
'
'   FunctionOrSubPointer:
'                 DWORD returned by CODEPTR function pointing to the function
'                 that will be called when SymbolName keyword will be encountered
'                 during script execution
'
'   ForceOverWrite:
'                 If different from 0 it means that even if SymbolName
'                 already exists as a keyword, you want to overwrite it with
'                 a new one.
'                 For example, if you want to overwrite behave of MID$
'                 creating your own MID$ function, set this parameter to a value
'                 > 0 like in this example:
'                 thinBasic_LoadSymbol("MID$", %thinBasic_ReturnString, CODEPTR(MyMid), 1)
'   sSyntax:
'                 Syntax of the symbol name
'   sHelp:
'                 help about the symbol name
'
' Possible Return Code
'   >0 = no error, return the associated SymbolName ID
'   -1 = empty SymbolName
'   -2 = duplicated SymbolName and no ForceOverWrite flag
'   -3 = invalid sub/function pointer
'   -4 = SymbolName contains invalid char(s)
'
' Example
'   thinBasic_LoadSymbol "MyNewFunction", %thinBasic_ReturnNumber, CODEPTR(MyFunc)
'----------------------------------------------------------------------------
Declare Function  thinBasic_LoadSymbolEX( _
                          ByVal SymbolName            As BSTR  , _
                          ByVal ReturnCode            As Long  , _
                          ByVal FunctionOrSubPointer  As Dword , _
                          ByVal ForceOverWrite        As Long = 0   , _
                          ByVal sSyntax               As BSTR = 0 , _
                          ByVal sHelp                 As BSTR = 0) As Long

  '----------------------------------------------------------------------------
  'thinBasic_VariableGetList
  '----------------------------------------------------------------------------
  ' Returns a string with the list of all variables of a specific stack level
  ' If StackLevel is missing, current stack level will be returned
  '----------------------------------------------------------------------------
  Declare Function thinBasic_VariableGetList(ByVal lStackLevel As Long=0, ByVal sSep As BSTR) As String
  '----------------------------------------------------------------------------
 
  '----------------------------------------------------------------------------
  'thinBasic_VariableGetValueNum
  '----------------------------------------------------------------------------
  ' Returns numeric value of a numeric variable given variable name and optionally array index
  '----------------------------------------------------------------------------
  Declare Function  thinBasic_VariableGetValueNum(ByVal SearchKey As String, ByVal lIndex As Long=0) As Ext
  '----------------------------------------------------------------------------
 
Declare Function  thinBasic_VariableGetInfoPtr( _
                            ByVal pVariable   As Long           , _       '---A pointer to Variable
                            ByRef MainType    As Long           , _       '---ATTENTION: parameter passed BYREF will return info
                            ByRef SubType     As Long           , _       '---ATTENTION: parameter passed BYREF will return info
                            ByRef IsArray     As Long             _       '---ATTENTION: parameter passed BYREF will return info
                          ) As Long

const SubType_Boolean    =  2
const SubType_String     = 30

const MainType_GUID      = 40
const MainType_IsGUID    = MainType_GUID
const MainType_IsString  = MainType_String
 
const MainType_IsVariant = MainType_Variant
const MainType_IsUDT     = MainType_UDT
const MainType_PTR       = 70
const MainType_IsPTR     = MainType_PTR
const MainType_Object    = 80
const MainType_IsObject  = MainType_Object
const MainType_Class     = 90
const MainType_IsClass   = MainType_Class

const Array_ElementsAreFixed     = 15     '%TRUE if elements are fixed size, like fixed strings or UDT
const Array_UBoundDim_1          = 91     'Returns the Upper Bound of dimension 1
const Array_UBoundDim_2          = 92     'Returns the Upper Bound of dimension 2
const Array_UBoundDim_3          = 93     'Returns the Upper Bound of dimension 3

'----------------------------------------------------------------------------
'thinBasic_AddUdt
'----------------------------------------------------------------------------
' Add a new UDT structure
'----------------------------------------------------------------------------
Declare Function  thinBasic_AddUdt(ByVal sUDT_Code As BSTR) As Long
 
'----------------------------------------------------------------------------
'thinBasic_DeclareFunction
'----------------------------------------------------------------------------
' Add a new function using DECLARE statement and function pointer
'----------------------------------------------------------------------------
Declare Function thinBasic_DeclareFunction(ByVal sDeclare As BSTR,ByVal pFun As Dword) As Long

'----------------------------------------------------------------------------
'thinBasic_FunctionGetPtr
'----------------------------------------------------------------------------
'----------------------------------------------------------------------------
Declare Function  thinBasic_FunctionGetPtr(ByVal fName As BSTR) As Long
 
'----------------------------------------------------------------------------
'thinBasic_FunctionGetPtr
'----------------------------------------------------------------------------
'----------------------------------------------------------------------------
Declare Function  thinBasic_FunctionGetName(ByVal FunctionPtr As Long) As String '---PTR to function returned by (for example) thinBasic_FunctionGetPtr

'----------------------------------------------------------------------------
'thinBasic_FunctionIsCallBack
'----------------------------------------------------------------------------
' Determine if fucntion passed as PTR has been defined as CALLBACK function in script
'----------------------------------------------------------------------------
Declare Function  thinBasic_FunctionIsCallBack(ByVal FunctionPtr As Long) As Long '---PTR to function returned by thinBasic_FunctionGetPtr
 
'----------------------------------------------------------------------------
'thinBasic_FunctionGetCBParam
'----------------------------------------------------------------------------
' Returns the value of a designated CallBack pseudo variable.
' ATTENTION: interface function valid only whileinside a callback function      
'----------------------------------------------------------------------------
' Parameters:
'   CBParamType: one of the following equates
      '---Equates for CBParamType
const CBParam_CBHNDL       = 100
const CBParam_CBMSG        = 110
const CBParam_CBCTL        = 120
const CBParam_CBCTLMSG     = 130
const CBParam_CBLPARAM     = 140
const CBParam_CBWPARAM     = 150
const CBParam_CBNMCODE     = 160
const CBParam_CBNMHDR      = 170
const CBParam_CBNMHWND     = 180
const CBParam_CBNMID       = 190
'   lError: a pointer to a long variable that will receive possible error variables
'           Possible errors:
'                            -10: not inside at any function
'                            -20: inside a function but not a callback function
'                            -30: unsupported/invalid CBParamType
'----------------------------------------------------------------------------
Declare Function thinBasic_FunctionGetCBParam(ByVal CBParamType As Long,ByVal lError As Long Ptr=0) As Long
 
'----------------------------------------------------------------------------
'thinBasic_FunctionGetNumberOfParams
'----------------------------------------------------------------------------
' Returns the number of parameters defined in a script function
'----------------------------------------------------------------------------
Declare Function  thinBasic_FunctionGetNumberOfParams(ByVal FunctionPtr As Long) As Long  '---PTR to function returned by thinBasic_FunctionGetPtr
                        
 
'----------------------------------------------------------------------------
'thinBasic_FunctionGetReturnMainType
'----------------------------------------------------------------------------
' Gets the main data type returned by a script function. See %VarMainType* equates above
'----------------------------------------------------------------------------
Declare Function  thinBasic_FunctionGetReturnMainType(ByVal FunctionPtr As Long) As Long '---PTR to function returned by thinBasic_FunctionGetPtr
                        
 
 
'----------------------------------------------------------------------------
'thinBasic_FunctionSimpleCall
'----------------------------------------------------------------------------
' Call a script function and optionally returns it value (numeric or string)
'----------------------------------------------------------------------------
Declare Function  thinBasic_FunctionSimpleCall( _
                          ByVal FunctionName As String,         _  '---Name of the function
                          ByVal ptrEXT As Ext Ptr =0,           _  '---Used to get back from the called function a numeric value
                          ByVal ptrSTR As BSTR Ptr=0            _  '---Used to get back from the called function a string value
                        ) As Long
'----------------------------------------------------------------------------
'thinBasic_ParsePtrToSomething
'----------------------------------------------------------------------------
' Parse whatever and return a PTR to something
'----------------------------------------------------------------------------
Declare Function thinBasic_ParsePtrToSomething(ByRef VariablePtr As Long) As Long '---ATTENTION: parameter passed BYREF will return info
                        
 
'----------------------------------------------------------------------------
'thinBasic_ParseVariableInfo
'----------------------------------------------------------------------------
' Parameters (all passed BYREF ... AS LONG):
'   - VariablePtr       pointer to internal thinBasic Core engine data structure
'                       used to store variable info
'   - MainType          variable main type
'   - SubType           variable sub type
'   - ElementsAreFixed  %TRUE if elements inside data buffer are fixed size.
'                       For example will return %TRUE:
'                         - fixed STRING size, the one declared ... AS STRING * size
'                         - fixed ASCIIZ size, the one declared ... AS ASCIIZ * size
'                         - UDT variables
'   - TotElements       total number of elements in variable. Usually 1 if
'                       variable is not an array
'   - ElementSize       size of the single element. For example if variable is a
'                       LONG, ElementSize = 4. If EXT ElementSize = 10
'                       if variable is a UDT, it will depend from UDT to UDT.
'   - DataPtr           pointer to variable data
'   - AbsPos            absolute position inside the array if variable is an array
'                       if variable is not an array 1 is returned
'----------------------------------------------------------------------------
declare function thinBasic_ParseVariableInfo( _
                          byref VariablePtr       as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref MainType          as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref SubType           as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref ElementsAreFixed  as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref TotElements       as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref ElementSize       as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref DataPtr           as long           , _   '---ATTENTION: parameter passed BYREF will return info
                          byref AbsPos            as long             _   '---ATTENTION: parameter passed BYREF will return info
                        ) as long
'------------------------------------------------------------------------------
'---
' Parse one string expression.
Declare Sub       thinBasic_ParseStr(ByRef sResult As BSTR)
 
'---
' Parse a variant variable (scalar or array) and returns its pointer
Declare Function  thinBasic_ParseVariant() As Dword
 
Declare Function  thinBasic_CheckSemicolon_Mandatory() As Long
Declare Function  thinBasic_CheckSemicolon_Optional() As Long
 
Declare Function  thinBasic_CheckEqual_Mandatory() As Long
Declare Function  thinBasic_CheckEqual_Optional() As Long
 
Declare Function  thinBasic_CheckPoint_Mandatory() As Long
Declare Function  thinBasic_CheckPoint_Optional() As Long
 
Declare Function  thinBasic_CheckPlus_Optional() As Long
Declare Function  thinBasic_CheckMinus_Optional() As Long
Declare Function  thinBasic_CheckMult_Optional() As Long
Declare Function  thinBasic_CheckDiv_Optional() As Long
 
Declare Function  thinBasic_CheckEOL_Optional() As Long
 
 
Declare Function  thinBasic_GetUnknownToken(ByVal AutoPutBack As Long=0) As BSTR
'----------------------------------------------------------------------------
 
'----------------------------------------------------------------------------
Declare Function  thinBasic_CheckEqualType_Mandatory() As Long
#define ERREqual_EQ             1520   ' =
#define ERREqual_PLUSEQUAL      1521   ' +=
#define ERREqual_MINUSEQUAL     1522   ' -=
#define ERREqual_MULTIPLYEQUAL  1523   ' *=
#define ERREqual_DIVIDEEQUAL    1524   ' /=
#define ERREqual_IDIVIDEEQUAL   1525   ' \=
#define ERREqual_CONCEQUAL      1526   ' &=
#define ERREqual_POINTEQUAL     1527   ' .=
'----------------------------------------------------------------------------
'----------------------------------------------------------------------------
' thinBasic_GetVariableNumberDirect
'----------------------------------------------------------------------------
' Returns the value of a variable giving its ptr and it abs position
Declare Function thinBasic_GetVariableNumberDirect(ByVal VariablePtr As Long, ByVal VariableAbsPos  As Long) As Ext
 
'----------------------------------------------------------------------------
'thinBasic_ChangeVariableUDTDirect
'----------------------------------------------------------------------------
' See also thinBasic_VariableParse
'
' Change a variable using direct variable pointer's data returned by
' thinBasic_VariableParse. This will ensure to work also with arrays
'----------------------------------------------------------------------------
Declare Function  thinBasic_ChangeVariableUDTDirect          _
                        Lib "thinCore.DLL"                      _
                        Alias "thinBasic_ChangeVariableUDTDirect" _
                        (                                       _
                          ByVal VariablePtr     As Long       , _
                          ByVal VariableAbsPos  As Long       , _
                          ByVal lValString      As String       _
                        ) As Long

'----------------------------------------------------------------------------
' thinBasic_ScriptIsObuscated
Declare Function  thinBasic_ScriptIsObfuscated() As Long

'----------------------------------------------------------------------------
'Trace Handling
'----------------------------------------------------------------------------
'----------------------------------------------------------------------------
' TRACE Equates
'---What to ask for
#define ERRTRACE_What_SourcePtr                       =   1
#define ERRTRACE_What_StackLevel                      =  10
#define ERRTRACE_What_IFLevel                         =  20
#define ERRTRACE_What_SourceFullPath                  =  30
 
'---Error codes
#define ERRTRACE_Error_NotPossible_Obfuscated         =   1
     
#define ERRTRACE_Error_InstallHandle_Null             = 200
#define ERRTRACE_Error_InstallHandle_AlreadyInstalled = 201
 
'----------------------------------------------------------------------------
'thinBasic_ITrace_GetValue
Declare Function thinBasic_ITrace_GetValue( _
   ByVal lWhat As Long        , _
   ByVal sWhat As BSTR     = 0, _
   ByVal lRet1 As Long Ptr = 0, _
   ByVal lRet2 As Long Ptr = 0, _
   ByVal sRet1 As BSTR ptr = 0) As Long
 
'----------------------------------------------------------------------------
' thinBasic_ITrace_InstallHandle
Declare Function thinBasic_ITrace_InstallHandle(ByVal fHandle As Long) As Long
'----------------------------------------------------------------------------
 
'----------------------------------------------------------------------------
' thinBasic_StackGetCurrent
'----------------------------------------------------------------------------
' Returns the current script stack level.
' 1 = Global, 2 = next function executed, 3 = ...
Declare Function thinBasic_StackGetCurrent() As Long
'------------------------------------------------------------------------------
 
'----------------------------------------------------------------------------
' thinBasic_StackGetList
'----------------------------------------------------------------------------
' Returns a string containing the names of the current nesting stack levels
' As a minimum this function will return one string containing "GLOBAL"
Declare Function thinBasic_StackGetList(ByVal sSep As BSTR=0) As BSTR
'----------------------------------------------------------------------------


'----------------------------------------------------------------------------
' thinBasic_FunctionParseAndGetPtr
'----------------------------------------------------------------------------
' Parse the next token (or string expression). Check if it is a function name
' If yes, returns a PTR to internal data function
Declare Function thinBasic_FunctionParseAndGetPtr (ByVal CheckIfCallBack As Long) As Long

'----------------------------------------------------------------------------
' thinBasic_FunctionCall_ByPtr
'----------------------------------------------------------------------------
' Call a script function and optionally returns it value (numeric or string)
' This function permits to call script functions passing parameters
' Parameters are passed using a shared memory area made by a sequence of DOUBLEs (8 bytes) one for each parameter to be passed.
' The paramaters memory area will be interpreted by thinBasic core engine depending by parameters declaration made in script.
' So far the following type of parameters are supported: numeric parameters passed BYVAL up to DOUBLE range
'
' Example: if programmer wants to pass 2 parameters, set lModParams = 2 and setup
' a 16 bytes memory area (2 params * 8 bytes each) where to store the 2 parameter values.
Declare Function thinBasic_FunctionCall_ByPtr _
  (ByVal FunctionPtr   As Long         , _
   ByVal lModParams    As Long         , _
   ByVal lModParamsPtr As any ptr      , _
   ByVal ptrDOUBLE     As Double Ptr =0, _
   ByVal ptrSTR        As BSTR = 0) As Long

'----------------------------------------------------------------------------
' thinBasic_FunctionSimpleCall_ByPtr
'----------------------------------------------------------------------------
' Call a script function and optionally returns it value (numeric or string)
' This function permits to call script callback functions passing automatic pseudo callbacks variables
' USE only when in need of a callback function from module
'----------------------------------------------------------------------------
Declare Function thinBasic_FunctionSimpleCall_ByPtr _
  (ByVal FunctionPtr As Long, _  '---PTR to function returned by thinBasic_FunctionGetPtr or other way
   ByVal ptrEXT     As Ext  Ptr = 0, _  '---Used to get back from the called function a numeric value
   ByVal ptrSTR     As BSTR Ptr = 0, _  '---Used to get back from the called function a string value
   ByVal IsCallBack As Long = 0              , _
   ByVal lCBHNDL    As Long = 0              , _
   ByVal lCBMSG     As Long = 0              , _
   ByVal lCBCTL     As Long = 0              , _
   ByVal lCBCTLMSG  As Long = 0              , _
   ByVal lCBLPARAM  As Long = 0              , _
   ByVal lCBWPARAM  As Long = 0              , _
   ByVal lCBNMCODE  As Long = 0              , _
   ByVal lCBNMHDR   As Long  = 0             , _
   ByVal lCBNMHWND  As Long = 0              , _
   ByVal lCBNMID    As Long = 0) As Long



'----------------------------------------------------------------------------
' thinBasic_Class_Add
'----------------------------------------------------------------------------
' Add a new class to thinBasic Core Engine
Declare Function thinBasic_Class_Add _
  (ByVal sClassName As BSTR, _       '---Name of the Class to be created
   ByVal pClassFunc As Long) As Long ' ---Pointer to a class function that will handle calls to methods
                          
'----------------------------------------------------------------------------
 
'----------------------------------------------------------------------------
' thinBasic_Class_AddMethod
'----------------------------------------------------------------------------
' Add a method to a class previously created with thinBasic_Class_Add
'----------------------------------------------------------------------------
Declare Function thinBasic_Class_AddMethod _
  (ByVal pClass                As Long, _     '---Poiter to a class. This is the value returned by thinBasic_Class_Add
   ByVal sMethodName           As BSTR, _     '---Name of the Class to be created
   ByVal MethodReturnType      As Long, _
   ByVal pMethodFunc           As Long) as long '---Pointer to a method function that will handle method execution
'----------------------------------------------------------------------------

const Class_Action_None          = 0
const Class_Action_Get           = 1
const Class_Action_Set           = 2
 
const Class_Action_Constructor   = 100
const Class_Action_Destructor    = 110
 
'----------------------------------------------------------------------------
' thinBasic_Class_AddProperty
'----------------------------------------------------------------------------
' Add a property to a class previously created with thinBasic_Class_Add
'----------------------------------------------------------------------------
Declare Function thinBasic_Class_AddProperty _
  (ByVal pClass                As Long, _     '---Poiter to a class. This is the value returned by thinBasic_Class_Add
   ByVal sPropertyName         As BSTR, _     '---Name of the Class to be created                                     
   ByVal PropertyReturnType    As Long, _                                                                           
   ByVal PtrToPropertyFunction As Long) As Long  '---Pointer to a method function that will handle method execution      
                           

'----------------------------------------------------------------------------
' thinBasic_GetRunTimeInfo
'----------------------------------------------------------------------------
' The following information can be taken:
'  "SCRIPT_PATH"  Path to script
'  "APP_PATH"     Path to thinBasic
'  "HWND"         Handle to main thinBasic window
  '----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_GetRunTimeInfo ( _
  BYVAL InfoName AS BSTR) AS BSTR

'----------------------------------------------------------------------------
' thinBasic_GetLastError
'----------------------------------------------------------------------------
DECLARE FUNCTION thinBasic_GetLastError () AS LONG

'----------------------------------------------------------------------------
' thinBasic_RunTimeError
'----------------------------------------------------------------------------
' Use internal thinCore engine to generate a runtime error
'  ErrorCode      Error code. Get one from the below list
'  AdditionalInfo Personalized text to be shown into runtime error dialog
  '----------------------------------------------------------------------------
DECLARE Function thinBasic_RunTimeError _
  (ByVal ErrorCode As Long, ByVal AdditionalInfo  As BSTR =0) As Long

'------------------------------------------------------------------------------
' RunTime Errors Codes
'------------------------------------------------------------------------------
#define ERR__PARENS                                 1
#define ERR__NOEXP                                  2
#define ERR__DIV_ZERO                               3
#define ERR__EQUAL_EXP                              4
#define ERR__NOT_VAR                                5
#define ERR__LAB_TAB_FULL                           6
#define ERR__DUP_LAB                                7
#define ERR__UNDEF_LAB                              8
#define ERR__THEN_EXPECTED                          9
#define ERR__TO_EXPECTED                           10
#define ERR__TOO_MANY_FOR                          11
#define ERR__NEXT_WITHOUT_FOR                      12
#define ERR__MISS_QUOTE                            15
#define ERR__BAD_FILE                              16
#define ERR__STR_EXPECTED                          17
#define ERR__UNKNOWN_KEYWORD                       18
#define ERR__MISSING_OPENPARENS                    19
#define ERR__MISSING_CLOSEPARENS                   20
#define ERR__MISSING_COMMA                         21
#define ERR__ATOM_COMMAND                          22
#define ERR__ATOM_TOKEN_TYPE                       23
#define ERR__ATOM                                  24
#define ERR__COMMAND_UNKNOWN_RETURNED_PARAMETER    25
#define ERR__PRIMITIVE_STR                         26
#define ERR__PRIMITIVE_NUM                         27
#define ERR__PRINT_ERROR                           28
#define ERR__PRINT_ERROR_NOENDOFLINE               29
#define ERR__VARIABLE_NOT_DEFINED                  30
#define ERR__ATOM_TOKEN_TYPE_NUMERIC               31
#define ERR__IF_WITHOUT_ENDIF                      32
#define ERR__IF_ENDIF_WITHOUT_IF                   33
#define ERR__TOO_MANY_WHILE                        34
#define ERR__WHILE_WITHOUT_WEND                    35
#define ERR__DIM_TYPE_NOT_DEFINED                  36
#define ERR__EXIT_NO_KEY_FOUND                     37
#define ERR__NO_END_FUNCTION_FOUND                 38
#define ERR__FUNCTION_NAME_DUPLICATE               39
#define ERR__FUNCTION_NAME_IS_KEY                  40
#define ERR__FUNCTION_NAME_IS_VAR                  41
#define ERR__FUNCTION_NAME_IS_UDT                  42
    
    
#define ERR__DIM_MISSING_AS                        43
#define ERR__UNDEFINED_TOKEN                       44
#define ERR__UNSUPPORTED_CHAR                      45
                                                
#define ERR__FUNCTION_DECLARE_MISSING_AS           47
#define ERR__DECLARE_FUNCTION_OR_SUB_EXPECTED      48
                                                
#define ERR__DOLOOP_WRONG_CONDITION                49
                                                
                                                
#define ERR__MISSING_ALIAS                         50
#define ERR__MISSING_LIB                           51
#define ERR__UNDEFINED_VAR_TYPE                    52
                                                
#define ERR__LOOP_EXPECTED_WHILE_OR_UNTIL          55
                                                
#define ERR__END_FUNCTION_FOUND                    59
                                                
#define ERR__ITERATE_NO_KEY_FOUND                  60
                                                
#define ERR__VARIABLE_NOT_DIMENSIONED              70
#define ERR__VARIABLE_ISNOT_ARRAY                  71
#define ERR__VARIABLE_MUSTBE_STRING_TYPE           72
                                                
#define ERR__KEYWORD_NOT_EXPECTED                  75
#define ERR__TOKEN_NOT_EXPECTED                    76
                                                
#define ERR__INCLUDE_FILE_NOT_FOUND                80
                                                
#define ERR__FUNCTION_NOT_SUPPORTED                90
                                                
#define ERR__ARRAY_FUNCTION_NOT_SUPPORTED          91
                                                
#define ERR__UDT_ELEMENT_NOT_FOUND                100
                                                
#define ERR__ASSIGNMENT_NOT_SUPPORTED             110
                                                
#define ERR__RELATIONAL_EXPECTED                  115
                                                
#define ERR__API_LIB_NOT_FOUND                    120
#define ERR__API_FUNCTION_NOT_FOUND_IN_LIB        121
#define ERR__API_GENERAL_ADDRESS_NOT_PRESENT      122
                                               
#define ERR__CALL_NOTSUPPORTEDSTATEMENT           130
#define ERR__CALL_FUNCTIONNOTFOUND                131
                                               
#define ERR__EQUATE_ALREADY_DEFINED               135
                                               
#define ERR__VARIABLE_NAME_DUPLICATE_GLOBAL       142
#define ERR__VARIABLE_NAME_DUPLICATE_FUNCTION    144
#define ERR__VARIABLE_NAME_DUPLICATE_LOCAL        145
#define ERR__VARIABLE_NAME_DUPLICATE              146
                                               
#define ERR__FOR_StepShouldBeNegative             150
#define ERR__FOR_StepShouldBePositive             151
#define ERR__FOR_ExpectedAVariable                152
#define ERR__FOR_StepIsZero                       153
                                               
#define ERR__ALIAS_CommandNameExpected            160
#define ERR__ALIAS_AsExpected                     161
#define ERR__ALIAS_UndefNotUndef                  162
                                               
#define ERR__TYPE_MISSING_END_TYPE                170
#define ERR__TYPE_TYPE_NOT_DEFINED                171
#define ERR__TYPE_MISSING_AS                      172
#define ERR__TYPE_NAME_MUSTBE_UNDEFINED           173
#define ERR__TYPE_ARRAY_MUSTBE_DIMENSIONED        174
#define ERR__TYPE_STRINGS_MUST_HAVE_SIZE          175
                                               
#define ERR__FUNCTION_MISSING_AS                  246
#define ERR__REGEXPR_MISSING_TO                   247
#define ERR__REGEXPR_MISSING_IN                   248
#define ERR__SELECT_WITHOUT_ENDSELECT             249
#define ERR__DUPLICATE_SYMBOL                     250
#define ERR__INVALIDNUMERICCHAR                   251
#define ERR__INVALIDDELIMITER                     252
#define ERR__INVALIDDATATYPE                      253
#define ERR__VARIABLE_EXPECTED                    254 
#define ERR__VARIABLE_VARIANT_EXPECTED            255 
                                               
#define ERR__SELECT_MISSING_CASE                  270
#define ERR__SELECT_ERROR_KINDOF_OPERATION        271
                                               
#define ERR__APICALL_REF_EXPECTED                 300
                                               
#define ERR__ARRAY_OUT_OF_BOUND                   400
      
#define ERR__MODULE_SPECIFIC                      500
'----------------------------------------------------------------------------
'thinBasic_ErrorFlag
'----------------------------------------------------------------------------
' Returns a value different from 0 if a runtime error occurred
'----------------------------------------------------------------------------
Declare Function  thinBasic_ErrorFlag() As Long
 
'----------------------------------------------------------------------------
'thinBasic_ErrorFree
'----------------------------------------------------------------------------
' Returns -1 if there thinBasic is not under runtime error state
'----------------------------------------------------------------------------
Declare Function  thinBasic_ErrorFree() As Long
'----------------------------------------------------------------------------
 
'----------------------------------------------------------------------------
'thinBasic_ErrorUserConfirmed
'----------------------------------------------------------------------------
' Returns -1 if, after an error, user has confirmed the dialog
'----------------------------------------------------------------------------
Declare Function  thinBasic_ErrorUserConfirmed() As Long
'----------------------------------------------------------------------------
 
#define ERR__PREPARSER_DirectiveNotSupported       800
#define ERR__PREPARSER_ScriptVersionRequest        820
#define ERR__INTERNAL_RETURNMAINTYPE               900
#define ERR__INTERNAL_DECRIPTION                   910
#define ERR__INTERNAL_UDTBUFFER_SHORT              915
#define ERR__INTERNAL_RETURNNONE_NOCODEPTR         921
#define ERR__INTERNAL_RETURNNUMBER_NOCODEPTR       922
#define ERR__INTERNAL_RETURNSTRING_NOCODEPTR       923
#define ERR__CLASS_NEW_NOINDEXALLOWED              5010
#define ERR__CLASS_NEW_DIFFERENTCLASS              5015
#define ERR__CLASS_NEW_NOCLASS                     5020
#define ERR__CLASS_NEW_EXPECTED_NEW                5025
#define ERR__CLASS_NOT_INIT_WITH_NEW               5030
#define ERR__CLASS_METHODPROPERTY_NOTFOUND         5100
#define ERR__TRACE_STOP_BY_USER                   11000
#define ERR__OBFUSCATION_FILENOTVALID             12000
#define ERR__COM_GENERIC                          30000
end extern

#endif '  __THINCORE_BI__